#include <bits/stdc++.h>

using namespace std;

const long long INF = (long long)1e18;

struct Line
{
	long long k, b;
	Line(long long _k, long long _b)
	{
		k = _k;
		b = _b;
	}
	Line(){}
	long long value(long long x)
	{
		return k * x + b;
	}
	long double intersect(Line other)
	{
		return ((long double)1.0) * (other.b - b) / (k - other.k);
	}
};

struct Envelope
{
	vector<Line> st;
	int ptr;
	Envelope()
	{
		ptr = 0;
	}
	bool better(Line a, Line b, Line c)
	{
		if (c.k == b.k) return c.b > b.b;
		return a.intersect(c) <= a.intersect(b);
	}
	void addLine(Line l)
	{
		while (!st.empty() && st.back().k == l.k)
		{
			if (st.back().b > l.b) return;
			st.pop_back();
		}
		while ((int)st.size() >= 2 && better(st[(int)st.size() - 2], st[(int)st.size() - 1], l)) st.pop_back(), ptr--;
		st.push_back(l);
	}
	long long getMax(long long x)
	{
		if (st.empty()) return -INF;
		ptr = max(ptr, 0);
		ptr = min(ptr, (int)st.size() - 1);
		while (ptr + 1 < (int)st.size() && st[ptr + 1].value(x) >= st[ptr].value(x)) ptr++;
		return st[ptr].value(x);
	}
};
const int MAXN = 1000 * 1000 + 7;

vector<int> g[MAXN], dag[MAXN];
int from[MAXN], to[MAXN], weight[MAXN];
bool on[MAXN], inDag[MAXN];
long long dist[MAXN], dp[MAXN];
vector<int> path[MAXN];
vector<int> havePathes[MAXN];
Envelope hull[MAXN];
bool used[MAXN];
int main()
{
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
#else
  freopen("trains.in", "r", stdin);
  freopen("trains.out", "w", stdout);
#endif
		int n, p, m = 0;
	scanf("%d %d", &n, &p);
	for (int i = 1; i <= p; i++)
	{
		int sz;
		scanf("%d", &sz);

		int last = 0;
		scanf("%d", &last);
		for (int j = 0; j < sz; j++)
		{
			int next, len;
			scanf("%d%d", &len, &next);
			int id = m++;
			from[id] = last;
			to[id] = next;
			weight[id] = len;
			on[id] = 1;
			path[i].push_back(id);
			g[last].push_back(id);
			last = next;
		}
	}

	for (int i = 1; i <= n; i++)
	{
		dist[i] = INF;
	}
	dist[1] = 0;
	priority_queue<pair<int, int> > heap;
	heap.push(make_pair(0, 1));
	vector<int> order;
	while (!heap.empty())
	{
		int v = heap.top().second;
		heap.pop();
		if (used[v]) continue;
		used[v] = true;
		order.push_back(v);
		for (int i = 0; i < (int)g[v].size(); i++)
		{
			int goEdge = g[v][i];
			if (on[goEdge])
			{
				int u = to[goEdge];
				if (dist[u] > dist[v] + weight[goEdge])
				{
					dist[u] = dist[v] + weight[goEdge];
					heap.push(make_pair(-dist[u], u));
				}
			}
		}
	}
	reverse(order.begin(), order.end());
	for (int i = 1; i < (int)order.size(); i++)
	{
		assert(dist[order[i]] <= dist[order[i - 1]]);
	}
	if (dist[n] == INF)
	{
		printf("-1\n");
		return 0;
	}
	for (int i = 0; i < m; i++)
	{
		if (dist[to[i]] == dist[from[i]] + weight[i])
		{
			dag[from[i]].push_back(i);
			inDag[i] = true;
		}
	}
	int nextPath = 0;
	for (int i = 1; i <= p; i++)
	{
		for (int j = 0; j < (int)path[i].size(); j++)
		{
			if (inDag[path[i][j]] && (j == 0 || !inDag[path[i][j - 1]]))
			{
				nextPath++;
				havePathes[from[path[i][j]]].push_back(nextPath);
			}
			if (inDag[path[i][j]])
			{
				havePathes[to[path[i][j]]].push_back(nextPath);
			}
		}
	}
	for (int i = 1; i <= n; i++)
	{
		dp[i] = -INF;
	}
	dp[n] = 0;
	for (int i = 0; i < (int)order.size(); i++)
	{
		int v = order[i];
		if (dist[v] == INF) continue;
		for (int j = 0; j < (int)havePathes[v].size(); j++)
		{
			int curPath = havePathes[v][j];
			dp[v] = max(dp[v], hull[curPath].getMax(dist[v]) + dist[v] * dist[v]);
		}
		for (int j = 0; j < (int)havePathes[v].size(); j++)
		{
			int curPath = havePathes[v][j];
			hull[curPath].addLine(Line(-2LL * dist[v], dp[v] + dist[v] * dist[v]));
		}
	}
	printf("%lld %lld\n", dist[n], dp[1]);
}




