/*
File name: ak_n.cpp
Tag: ACCEPTED
Author: Andreikkaa
Change time: Wed Mar 29 21:35:34 MSK 2017

*/
/*
* C++11 code template for contests.
* @author: Andrey Kalendarov
* @e-mail: andreykalendarov@gmail.com
*/

//#pragma GCC optimize ("O3")
//#define ANDREIKKAA_TOPCODER
//#define ANDREIKKAA_ALLOCATOR
#define ANDREIKKAA_CLASS Solution
#define ANDREIKKAA_METHOD solve
#define ANDREIKKAA_PARAMETERS void
#define ANDREIKKAA_CALL
#define ANDREIKKAA_RETURN_TYPE void

#define first x
#define second y
#include "bits/stdc++.h"
using namespace std;

typedef long long ll;
typedef long double ld;

#define endl '\n'
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()
const ld PI = acos(-1);

const int _ML = 500;
const char _inpf[] =
#if defined(ANDREIKKAA)
"input.txt"
#else
"storage.in"
#endif
;
const char _outf[] =
#if defined(ANDREIKKAA)
""
#else
"storage.out"
#endif
;

#if defined(ANDREIKKAA_ALLOCATOR)
char _mem[_ML * 1024LL * 1024LL];
size_t _ptr = 0;
inline void* operator new(size_t _x) { _ptr += _x; return _mem + _ptr - _x; }
inline void operator delete(void*) { }
#endif

template<typename T, typename U> inline ostream &operator << (ostream &_out, const pair<T, U> &_p) { _out << _p.first << ' ' << _p.second; return _out; }
template<typename T, typename U> inline istream &operator >> (istream &_in, pair<T, U> &_p) { _in >> _p.first >> _p.second; return _in; }
template<typename T> inline ostream &operator << (ostream &_out, const vector<T> &_v) { if (_v.empty()) return _out; _out << _v.front(); for (auto _it = ++_v.begin(); _it != _v.end(); ++_it) _out << ' ' << *_it; return _out; }
template<typename T> inline istream &operator >> (istream &_in, vector<T> &_v) { for (auto &_i : _v) _in >> _i; return _in; }
template<typename T> inline ostream &operator << (ostream &_out, const set<T> &_s) { if (_s.empty()) return _out; _out << *_s.begin(); for (auto _it = ++_s.begin(); _it != _s.end(); ++_it) _out << ' ' << *_it; return _out; }
template<typename T> inline ostream &operator << (ostream &_out, const multiset<T> &_s) { if (_s.empty()) return _out; _out << *_s.begin(); for (auto _it = ++_s.begin(); _it != _s.end(); ++_it) _out << ' ' << *_it; return _out; }
template<typename T> inline ostream &operator << (ostream &_out, const unordered_set<T> &_s) { if (_s.empty()) return _out; _out << *_s.begin(); for (auto _it = ++_s.begin(); _it != _s.end(); ++_it) _out << ' ' << *_it; return _out; }
template<typename T> inline ostream &operator << (ostream &_out, const unordered_multiset<T> &_s) { if (_s.empty()) return _out; _out << *_s.begin(); for (auto _it = ++_s.begin(); _it != _s.end(); ++_it) _out << ' ' << *_it; return _out; }
template<typename T, typename U> inline ostream &operator << (ostream &_out, const map<T, U> &_m) { if (_m.empty()) return _out; _out << '(' << _m.begin()->first << ": " << _m.begin()->second << ')'; for (auto _it = ++_m.begin(); _it != _m.end(); ++_it) _out << ", (" << _it->first << ": " << _it->second << ')'; return _out; }
template<typename T, typename U> inline ostream &operator << (ostream &_out, const unordered_map<T, U> &_m) { if (_m.empty()) return _out; _out << '(' << _m.begin()->first << ": " << _m.begin()->second << ')'; for (auto _it = ++_m.begin(); _it != _m.end(); ++_it) _out << ", (" << _it->first << ": " << _it->second << ')'; return _out; }

/* ________ CODE ________ */

inline vector<pair<int, char>> f(string s)
{
	vector<pair<int, char>> v;

	for (char c : s)
	{
		if (!v.empty() && v.back().y == c)
		{
			++v.back().x;
		}
		else
		{
			v.push_back({ 1, c });
		}
	}
	return v;
}

inline void go_stack(vector<pair<int, char>> &st)
{
	char c = st.back().y;
	while (sz(st) >= 2 && st.back().x > st[sz(st) - 2].x)
	{
		int val = st.back().x;
		st.pop_back();
		val += st.back().x;
		st.pop_back();
		if (st.empty())
		{
			st.push_back({ val, c });
		}
		else
		{
			st.back().x += val;
		}
	}
}

inline bool solve()
{
	string s, t;
	cin >> s >> t;

	for (int i = 0; i + 1 < sz(t); ++i)
	{
		if (t[i] != t[i + 1] && (s[i] != t[i] || s[i + 1] != t[i + 1]))
		{
			return false;
		}
	}

	auto v = f(s);
	auto w = f(t);

	int p = 0;

	for (auto i : w)
	{
		vector<pair<int, char>> cur;
		int sum = 0;
		while (sum < i.x)
		{
			assert(p < sz(v));
			sum += v[p].x;
			cur.push_back(v[p]);
			++p;
		}

		vector<pair<int, char>> st;
		for (auto j : cur)
		{
			if (j.y == i.y)
			{
				if (st.empty() || st.back().y != j.y)
				{
					st.push_back(j);
				}
				else
				{
					st.back().x += j.x;
				}

				go_stack(st);
			}
			else
			{
				if (st.empty() || st.back().x <= j.x)
				{
					st.push_back(j);
				}
				else
				{
					st.back().x += j.x;
					go_stack(st);
				}
			}
		}

		if (sz(st) > 1 || st[0].y != i.y)
		{
			return false;
		}
	}

	return true;
}

inline ANDREIKKAA_RETURN_TYPE mainFunction(ANDREIKKAA_PARAMETERS)
{
	int t;
	cin >> t;

	for (int i = 0; i < t; ++i)
	{
		if (solve())
		{
			cout << "Yes" << endl;
		}
		else
		{
			cout << "No" << endl;
		}
	}
}

/* ________ CODE ________ */

#if defined(ANDREIKKAA) || !defined(ANDREIKKAA_TOPCODER)
int main()
{
#if defined(ANDREIKKAA)
	time_t _start = clock();
#endif
	if (_inpf[0] != '\0')
		assert(freopen(_inpf, "r", stdin) != nullptr);
	if (_outf[0] != '\0')
		assert(freopen(_outf, "w", stdout) != nullptr);
	cin.tie(nullptr);
	ios_base::sync_with_stdio(false);
	cout << setprecision(20);
	//cout << fixed;	
	mainFunction(ANDREIKKAA_CALL);
#if defined(ANDREIKKAA)
	cerr << "Time: " << (clock() - _start) / (ld)CLOCKS_PER_SEC << endl;
	while (true);
#endif
}
#else
class ANDREIKKAA_CLASS { public: ANDREIKKAA_RETURN_TYPE ANDREIKKAA_METHOD(ANDREIKKAA_PARAMETERS) { return mainFunction(ANDREIKKAA_CALL); } };
#endif
