/*
File name: segments_mp_n3_prepared.cpp
Tag: TIME_LIMIT_EXCEEDED
Author: niyaznigmatul
Change time: Wed Mar 29 22:13:45 MSK 2017

*/
#include <cstdio>
#include <algorithm>
#include <vector>
#include <cassert>
#include <set>
#include <map>
using namespace std;
#define pb push_back
#define mp make_pair
#define fs first
#define sc second
#define sz(a) ((int) (a).size())
#define int64 long long
#define TASKNAME "internship"

const int N = (int) 1e6;
const int64 INF = (int64) 1e15 + 1000;
int n, m, x[N], y[N], wx[N], wy[N], who[N], cnt[2 * N], ansi, ansj, ansk, ansl;
int64 maxsum, sumx, sumy;

struct tnode {
	int64 sum, maxsum, maxpref, maxsuf;
	tnode(int64 value = 0): sum(value), maxsum(value), maxpref(value), maxsuf(value) {}
} rmq[4 * N];

tnode operator+(const tnode& a, const tnode& b) {
	tnode c;
	c.sum = a.sum + b.sum;
	c.maxsum = max(max(a.maxsum, b.maxsum), a.maxsuf + b.maxpref);
	c.maxpref = max(a.maxpref, a.sum + b.maxpref);
	c.maxsuf = max(a.maxsuf + b.sum, b.maxsuf);
	return c;
}

void init(int t, int l, int r) {
	if (l == r - 1) {
		rmq[t] = tnode(wy[l]);
	} else {
		int m = (l + r) / 2;
		init(t * 2 + 1, l, m);
		init(t * 2 + 2, m, r);
		rmq[t] = rmq[t * 2 + 1] + rmq[t * 2 + 2];
	}
}

void update(int t, int l, int r, int idx) {
	if (l == r - 1) {
		rmq[t] = tnode(-INF);
	} else {
		int m = (l + r) / 2;
		if (idx < m) {
			update(t * 2 + 1, l, m, idx);
		} else {
			update(t * 2 + 2, m, r, idx);
		}
		rmq[t] = rmq[t * 2 + 1] + rmq[t * 2 + 2];
	}
}

int main() {
	freopen(TASKNAME".in", "r", stdin);
	freopen(TASKNAME".out", "w", stdout);
	scanf("%d%d", &n, &m);
	for (int i = 0; i < n; ++i)
		scanf("%d", &x[i]), x[i]--;
	for (int i = 0; i < n; ++i)
		scanf("%d", &wx[i]), sumx += wx[i];
	for (int i = 0; i < m; ++i)
		scanf("%d", &y[i]), y[i]--;
	for (int i = 0; i < m; ++i)
		scanf("%d", &wy[i]), sumy += wy[i];
	if (sumx > sumy) {
		maxsum = sumx, ansi = 0, ansj = n - 1, ansk = -1, ansl = -1;
	} else {
		maxsum = sumy, ansi = -1, ansj = -1, ansk = 0, ansl = m - 1;
	}
	for (int i = 0; i < n; ++i) {
		who[i] = -1;
		for (int j = 0; j < m; ++j) {
			if (y[j] == x[i]) {
				who[i] = j;
			}
		}
	}
	for (int i = 0; i < n; ++i) {
		init(0, 0, m);
		int64 sum = 0;
		for (int j = i; j < n; ++j) {
			sum += wx[j];
			if (who[j] != -1) {
				update(0, 0, m, who[j]);
			}
			int64 cursum = rmq[0].maxsum;
			if (sum + cursum > maxsum) {
				maxsum = sum + cursum, ansi = i, ansj = j;
			}
		}
	}
	if ((ansi != -1) && (ansj != -1)) {
		for (int xpos = ansi; xpos <= ansj; xpos++) {
			cnt[x[xpos]]++;	
		}
		int64 cursum = 0, bestsum = 0;
		int start = 0;
		for (int k = 0; k < m; ++k) {
			if (cnt[y[k]] > 0) {
				cursum = 0;
				start = k + 1;
				continue;
			}
			cursum += wy[k];
			if (cursum > bestsum) {
				bestsum = cursum, ansk = start, ansl = k;
			}
		}
	}
	printf("%lld\n", maxsum);
	printf("%d %d\n", ansi + 1, ansj + 1);
	printf("%d %d\n", ansk + 1, ansl + 1);
	return 0;
}

