#include <bits/stdc++.h>

using namespace std;

const long long INF = 1000000000000000000;
const long long cost = 1000000000;

struct SegTree {
    int sz;
    vector<long long> it;

    SegTree(int sz_) {
        sz = sz_;
        it.resize(4 * sz);
    }

    void update(int u) {
        it[u] = min(it[2 * u + 1], it[2 * u + 2]);
    }

    void set1(int u, int L, int R, int ind, long long val) {
        if (R - L == 1) {
            it[u] = val;
            return;
        }
        int M = (L + R) / 2;
        if (ind < M) {
            set1(2 * u + 1, L, M, ind, val);
        } else {
            set1(2 * u + 2, M, R, ind, val);
        }
        update(u);
    }

    void set(int ind, long long val) {
        set1(0, 0, sz, ind, val);
    }

    long long getMin1(int u, int L, int R, int left, int right) {
        if (left >= R || L >= right) {
            return INF;
        }
        if (left <= L && R <= right) {
            return it[u];
        }
        int M = (L + R) / 2;
        return min(
                getMin1(2 * u + 1, L, M, left, right),
                getMin1(2 * u + 2, M, R, left, right)
        );
    }

    long long getMin(int l, int r) {
        return getMin1(0, 0, sz, l, r);
    }
};

struct Stack1 {
    vector<long long> mn;

    Stack1() {
        mn.push_back(INF);
    }

    void push(long long x) {
        mn.push_back(min(mn.back(), x));
    }

    void pop() {
        mn.pop_back();
    }

    long long getMin() {
        return mn.back();
    }

    bool isEmpty() {
        return mn.size() == 1;
    }
};

struct Stack2 {
    vector<long long> st, mn;

    Stack2() {
        mn.push_back(INF);
    }

    void push(long long x) {
        st.push_back(x);
        mn.push_back(min(mn.back(), x));
    }

    long long pop() {
        long long ans = st.back();
        st.pop_back();
        mn.pop_back();
        return ans;
    }

    long long getMin() {
        return mn.back();
    }

    bool isEmpty() {
        return st.empty();
    }
};

struct Queue {
    Stack1 s1;
    Stack2 s2;

    Queue() {
        s1 = Stack1();
        s2 = Stack2();
    }

    void push(long long x) {
        s2.push(x);
    }

    void pop() {
        if (s1.isEmpty()) {
            while (!s2.isEmpty()) {
                s1.push(s2.pop());
            }
        }
        s1.pop();
    }

    long long getMin() {
        return min(s1.getMin(), s2.getMin());
    }
};

int main() {
    int n, a;
    scanf("%d%d", &n, &a);
    vector<int> l(n), r(n), c(n);
    vector<int> lrs;
    for (int i = 0; i < n; i++) {
        scanf("%d%d%d", &l[i], &r[i], &c[i]);
        r[i]++;
        lrs.push_back(l[i]);
        lrs.push_back(r[i]);
    }

    sort(lrs.begin(), lrs.end());
    lrs.resize(unique(lrs.begin(), lrs.end()) - lrs.begin());

    vector<Queue> qs(lrs.size() - 1);
    SegTree st(lrs.size() - 1);
    // qs[i] хранит все элементы на отрезке [lrs[i], lrs[i + 1])

    vector<int> l1(n), r1(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < lrs.size(); j++) {
            if (lrs[j] == l[i]) {
                l1[i] = j;
            }
            if (lrs[j] == r[i]) {
                r1[i] = j;
            }
        }
    }

    vector<long long> ans(a + 1);
    long long added = cost;
    ans[a] = 0;

    // Move windows

    // TODO PODGON

    for (int j = 0; j < lrs.size() - 1; j++) {
        if (a + lrs[j + 1] - 1 <= a) {
            qs[j].pop();
        }
        if (a + lrs[j] - 1 <= a) {
            qs[j].push(ans[a + lrs[j] - 1]);
        }

        st.set(j, qs[j].getMin());
    }

    for (int i = a - 1; i >= 0; i--) {
        long long cv = 0;
        // Choose min
        for (int j = 0; j < n; j++) {
            if (i + r[j] - 1 <= a) {
                long long mx = st.getMin(l1[j], r1[j]);
                cv = max(cv, mx - c[j] + added);
            }
        }
        ans[i] = cv - added;

        if (i != 0) {
            added += cost;

            // Move windows

            for (int j = 0; j < lrs.size() - 1; j++) {
                long long om = qs[j].getMin();
                if (i + lrs[j + 1] - 1 <= a) {
                    qs[j].pop();
                }
                if (i + lrs[j] - 1 <= a) {
                    qs[j].push(ans[i + lrs[j] - 1]);
                }

                long long nm = qs[j].getMin();
                if (om != nm) {
                    st.set(j, nm);
                }
            }
        }
    }

    cout << ans[0] + added << endl;

    return 0;
}