#include <bits/stdc++.h>

using namespace std;

const long long INF = 1000000000000000000;
const long long cost = 1000000000;

struct SegTree {
    int sz;
    vector<long long> it, mod;

    SegTree(int sz_) {
        sz = sz_;
        it.resize(4 * sz);
        mod.resize(4 * sz);
    }

    void push(int u) {
        it[2 * u + 1] += mod[u];
        mod[2 * u + 1] += mod[u];
        it[2 * u + 2] += mod[u];
        mod[2 * u + 2] += mod[u];
        mod[u] = 0;
    }

    void update(int u) {
        it[u] = min(it[2 * u + 1], it[2 * u + 2]);
    }

    void set(int u, int L, int R, int ind, long long val) {
        if (R - L == 1) {
            it[u] = val;
            return;
        }
        int M = (L + R) / 2;
        push(u);
        if (ind < M) {
            set(2 * u + 1, L, M, ind, val);
        } else {
            set(2 * u + 2, M, R, ind, val);
        }
        update(u);
    }

    void add(int u, int L, int R, int left, int right, long long val) {
        if (left >= R || L >= right) {
            return;
        }
        if (left <= L && R <= right) {
            it[u] += val;
            mod[u] += val;
            return;
        }
        int M = (L + R) / 2;
        push(u);
        add(2 * u + 1, L, M, left, right, val);
        add(2 * u + 2, M, R, left, right, val);
        update(u);
    }

    long long getMin(int u, int L, int R, int left, int right) {
        if (left >= R || L >= right) {
            return INF;
        }
        if (left <= L && R <= right) {
            return it[u];
        }
        int M = (L + R) / 2;
        push(u);
        return min(
                getMin(2 * u + 1, L, M, left, right),
                getMin(2 * u + 2, M, R, left, right)
        );
    }
};

int main() {
    int n, a;
    scanf("%d%d", &n, &a);
    vector<int> l(n), r(n), c(n);
    for (int i = 0; i < n; i++) {
        scanf("%d%d%d", &l[i], &r[i], &c[i]);
    }
    vector<long long> ans(a + 1);
    SegTree st(a + 1);
    ans[a] = cost;
    for (int i = a - 1; i >= 0; i--) {
        long long cv = 0;
        for (int j = 0; j < n; j++) {
            long long mx = INF;
            if (i + r[j] > a) {
                mx = -INF;
            } else {
                for (int add = l[j]; add <= r[j]; add++) {
                    mx = min(mx, ans[i + add]);
                }
            }
            if (mx != -INF) {
                cv = max(cv, mx - c[j]);
            }
        }
        ans[i] = cv;

        if (i != 0) {
            for (int j = i; j <= a; j++) {
                ans[j] += cost;
            }
        }
    }

    cout << ans[0] << endl;

    return 0;
}