#include <bits/stdc++.h>

using namespace std;

const int MAXN = 50001;

int a[MAXN], x[MAXN], b[MAXN], y[MAXN];
long long yp[MAXN], xp[MAXN];
vector<int> binds[2 * MAXN];
bool allowed[MAXN];
bool added_cols[2 * MAXN];
long long maxsum = 0;
int byl = -1, byr = -1;
int lft[MAXN];
int rght[MAXN];
int n, m;

long long sx(int L, int R) {
    return xp[R + 1] - xp[L];
}

long long sy(int L, int R) {
    return yp[R + 1] - yp[L];
}

void set_allowed(int ind) {
    if (!allowed[ind]) {
        allowed[ind] = true;
        int nl = ind, nr = ind;
        if (ind + 1 < m && allowed[ind + 1]) {
            nr = rght[ind + 1];
        }
        if (ind - 1 >= 0 && allowed[ind - 1]) {
            nl = lft[ind - 1];
        }
        lft[nr] = nl;
        rght[nl] = nr;
        long long s = sy(nl, nr);
        if (s > maxsum) {
            maxsum = s;
            byl = nl;
            byr = nr;
        }
    }
}

void add_color(int col) {
    if (!added_cols[col]) {
        added_cols[col] = true;
        for (int ind : binds[col]) {
            set_allowed(ind);
        }
    }
}

int main() {
    scanf("%d%d", &n, &m);
    for (int i = 0; i < n; i++) {
        scanf("%d", &a[i]);
    }
    for (int i = 0; i < n; i++) {
        scanf("%d", &x[i]);
        xp[i + 1] = xp[i] + x[i];
    }
    for (int i = 0; i < m; i++) {
        scanf("%d", &b[i]);
        binds[b[i]].push_back(i);
    }
    for (int i = 0; i < m; i++) {
        scanf("%d", &y[i]);
        yp[i + 1] = yp[i] + y[i];
    }

    vector<int> has_only_b;
    vector<bool> kek1(2 * MAXN), kek2(2 * MAXN);
    for (int i : a) {
        kek1[i] = true;
    }
    for (int i : b) {
        kek2[i] = true;
    }
    for (int i = 0; i < 2 * MAXN; i++) {
        if (!kek1[i] && kek2[i]) {
            has_only_b.push_back(i);
        }
    }

    long long best = 0;
    int bestyl = -1, bestyr  = -1, bestxl = -1, bestxr = -1;
    for (int L = 0; L < n; L++) {
        fill(added_cols, added_cols + 2 * MAXN, false);
        maxsum = 0;
        byl = byr = -1;
        fill(allowed, allowed + MAXN, false);

        for (int c : has_only_b) {
            add_color(c);
        }
        for (int i = 0; i < L; i++) {
            add_color(a[i]);
        }

        for (int R = n - 1; R >= L; R--) {
            long long cs = sx(L, R) + maxsum;
            if (cs > best) {
                best = cs;
                bestxl = L;
                bestxr = R;
                bestyl = byl;
                bestyr = byr;
            }

            add_color(a[R]);
        }
    }

    long long ssx = sx(0, n - 1);
    if (ssx > best) {
        best = ssx;
        bestxl = 0;
        bestxr = n - 1;
        bestyl = -1;
        bestyr = -1;
    }

    long long ssy = sy(0, m - 1);
    if (ssy > best) {
        best = ssy;
        bestxl = bestxr = -1;
        bestyl = 0;
        bestyr = m - 1;
    }

    cout << best << endl;
    cout << bestxl + 1 << " " << bestxr + 1 << endl;
    cout << bestyl + 1 << " " << bestyr + 1 << endl;

    return 0;
}