# include <iostream>
# include <vector>
# include <cstring>

using namespace std;

const int MAX_N = 1000, INF = 1e9 + 100;
vector<pair<int, int> > graph[MAX_N];
bool used[MAX_N];
pair<int, long long> ans[MAX_N];

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; i++)
    {
        int s;
        cin >> s;
        if (s > 1) return 0;
        int a, b, c;
        cin >> a >> b >> c;
        --a;
        --c;
        graph[a].push_back({c, b});
    }
    for (int i = 1; i < n; i++)
    {
        ans[i] = {INF, INF};
    }
    ans[0] = {0, 0};
    memset(used, 0, n * sizeof(bool));
    while (true)
    {
        pair<pair<int, long long>, int> mn = {{INF, INF}, INF};
        for (int i = 0; i < n; i++)
        {
            if (used[i]) continue;
            mn = min(mn, {ans[i], i});
        }
        if (mn.second == INF) break;
        used[mn.second] = true;
        for (pair<int, int> i : graph[mn.second])
        {
            int a = i.first, b = i.second;
            if (used[a]) continue;
            ans[a] = min(ans[a], {mn.first.first + b, mn.first.second - (long long)b * (long long)b});
        }
    }
    cout << ans[n - 1].first << " " << -ans[n - 1].second;
    return 0;
}

