# include <iostream>
# include <string>
# include <vector>
# include <stack>
# include <set>

using namespace std;

vector<pair<int, int> > get(const string &s)
{
    vector<pair<int, int> > ans;
    if (s[0] == '+') ans.push_back({1, 1});
    else ans.push_back({1, 0});
    for (int i = 1; i < (int)s.size(); i++)
    {
        if (s[i] == s[i - 1]) ++(*ans.rbegin()).first;
        else
        {
            if (s[i] == '+') ans.push_back({1, 1});
        else ans.push_back({1, 0});
        }
    }
    return ans;
}

const int MAX_N = 1e6;
int lft[MAX_N], rght[MAX_N];

void solve()
{
    string s, t;
    cin >> s >> t;
    vector<pair<int, int> > s1 = get(s), t1 = get(t);
    vector<int> need;
    int n = s1.size(), m = t1.size();
    int cnt = 0;
    for (int i = 0; i < n; i++)
    {
        if (i == 0) lft[i] = -1;
        else lft[i] = i - 1;
        if (i == n - 1) rght[i] = -1;
        else rght[i] = i + 1;
        for (int j = 0; j < s1[i].first; j++)
        {
            if (t[cnt + j] != t[cnt])
            {
                cout << "No\n";
                return;
            }
        }
        if (t[cnt] != s[cnt]) need.push_back(i);
        cnt += s1[i].first;
    }
    int p = need.size();
    for (int i = 0; i < p - 1; i++)
    {
        if (need[i] == need[i + 1] - 1)
        {
            cout << "No\n";
            return;
        }
    }
    set<int> need1;
    stack<int> can;
    for (int i : need)
    {
        need1.insert(i);
        if ((i > 0 && s1[i].first < s1[i - 1].first) || (i < n - 1 && s1[i].first < s1[i + 1].first)) can.push(i);
    }
    while (!can.empty())
    {
        int i = can.top();
        can.pop();
        need1.erase(i);
        int l = lft[i], r = rght[i];
        if (l != -1)
        {
            s1[l].first += s1[i].first;
            if (r != -1)
            {
                s1[l].first += s1[r].first;
            }
            rght[l] = r + 1;
            if (rght[l] == n) rght[l] = -1;
        }
        if (r != -1)
        {
            if (l != -1) s1[r].first = s1[l].first;
            else s1[r].first += s1[i].first;
            lft[r] = l - 1;
        }
        if (l > 0)
        {
            if (need1.find(l - 1) != need1.end() && s1[l - 1].first < s1[l].first)
            {
                can.push(l - 1);
            }
        }
        if (r < n - 1)
        {
            if (need1.find(r + 1) != need1.end() && s1[r + 1].first < s1[r].first)
            {
                can.push(r + 1);
            }
        }
    }
    if (need1.empty())
    {
        cout << "Yes\n";
    }
    else
    {
        cout << "No\n";
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    int q;
    cin >> q;
    for (int i = 0; i < q; i++)
    {
        solve();
    }
}
