# include <iostream>
# include <string>
# include <vector>
# include <stack>
# include <set>
# include <cstring>

using namespace std;

vector<pair<int, int> > get(const string &s)
{
    vector<pair<int, int> > ans;
    if (s[0] == '+') ans.push_back({1, 1});
    else ans.push_back({1, 0});
    for (int i = 1; i < (int)s.size(); i++)
    {
        if (s[i] == s[i - 1]) ++(*ans.rbegin()).first;
        else
        {
            if (s[i] == '+') ans.push_back({1, 1});
        else ans.push_back({1, 0});
        }
    }
    return ans;
}

const int MAX_N = 1e6;
int lft[MAX_N], rght[MAX_N];
int p[MAX_N], sz[MAX_N], num[MAX_N];

int get_p(int u)
{
    if (p[u] == u) return u;
    return p[u] = get_p(p[u]);
}

void unite(int v, int u)
{
    v = get_p(v); u = get_p(u);
    if (u == v) return;
    if (sz[u] == sz[v])
    {
        lft[v] = min(lft[v], lft[u]);
        rght[v] = max(rght[v], rght[u]);
        p[u] = v;
        num[v] += num[u];
        ++sz[v];
        return;
    }
    if (sz[u] > sz[v]) swap(u, v);
    lft[v] = min(lft[v], lft[u]);
    rght[v] = max(rght[v], rght[u]);
    num[v] += num[u];
    p[u] = v;
}

void solve()
{
    string s, t;
    cin >> s >> t;
    vector<pair<int, int> > s1 = get(s), t1 = get(t);
    vector<int> need;
    int n = s1.size(), m = t1.size();
    int cnt = 0;
    for (int i = 0; i < n; i++)
    {
        p[i] = i;
        sz[i] = 1;
        num[i] = s1[i].first;
        lft[i] = i;
        rght[i] = i;
        for (int j = 0; j < s1[i].first; j++)
        {
            if (t[cnt + j] != t[cnt])
            {
                cout << "No\n";
                return;
            }
        }
        if (t[cnt] != s[cnt]) need.push_back(i);
        cnt += s1[i].first;
    }
    int p = need.size();
    for (int i = 0; i < p - 1; i++)
    {
        if (need[i] == need[i + 1] - 1)
        {
            cout << "No\n";
            return;
        }
    }
    set<int> need1;
    stack<int> can;
    for (int i : need)
    {
        need1.insert(i);
        if ((i > 0 && s1[i].first < s1[i - 1].first) || (i < n - 1 && s1[i].first < s1[i + 1].first)) can.push(i);
    }
    while (!can.empty())
    {
        int i = can.top();
        can.pop();
        need1.erase(i);
        int pr1 = get_p(i);
        int pr2, pr3;
        if (lft[pr1] > 0) pr2 = get_p(lft[pr1] - 1);
        else pr2 = -1;
        if (rght[pr1] < n - 1) pr3 = get_p(rght[pr1] + 1);
        else pr3 = -1;
        if (pr2 != -1)
        {
            unite(pr1, pr2);
        }
        if (pr3 != -1)
        {
            unite(pr1, pr3);
        }
        int pr = get_p(i);
        int l = lft[pr] - 1, r = rght[pr] + 1;
        if (r == n) r = -1;
        if (need1.find(l) != need1.end() && num[l] < num[pr])
        {
            can.push(l);
        }
        if (need1.find(r) != need1.end() && num[r] < num[pr])
        {
            can.push(r);
        }
    }
    if (need1.empty())
    {
        cout << "Yes\n";
    }
    else
    {
        cout << "No\n";
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    int q;
    cin >> q;
    for (int i = 0; i < q; i++)
    {
        solve();
    }
}
