#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <vector>
#include <set>
#include <fstream>
#include <string>
#include <map>

using namespace std;

const long long MAX = 1e3 + 13, INF = (long long)1e18;

long long n, m;

long long d[MAX];

long long sqr[MAX];

vector<pair<long long, long long> > gr[MAX];

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	//ifstream cin("tests.txt");

	cin >> n >> m;
	
	fill(d + 1, d + n + 1, INF);
	fill(sqr + 1, sqr + n + 1, INF);

	for (long long i = 1; i <= m; i++) {
		long long kol;
		cin >> kol;
		vector<long long> vec(2 * kol + 2);

		for (int i = 1; i <= 2 * kol + 1; i++) {
			cin >> vec[i];
		}
		for (int i = 1; i <= 2 * kol + 1; i += 2) {
			long long sum = 0;
			for (int j = i + 2; j <= 2 * kol + 1; j += 2) {
				sum += vec[i + 1];
				gr[vec[i]].push_back(make_pair(vec[j], sum));
			}
		}
	}

	set<pair<long long, long long>> st;

	d[1] = 0;
	sqr[1] = 0;

	st.insert(make_pair(0, 1));

	while (!st.empty()) {
		long long v = st.begin()->second;
		st.erase(st.begin());
		for (long long i = 0; i < gr[v].size(); i++) {
			long long to = gr[v][i].first, len = gr[v][i].second;
			if (d[to] > d[v] + len || (d[to] == d[v] + len && sqr[to] < sqr[v] + len * len)) {
				if (st.find(make_pair(d[to], to)) != st.end()) {
					st.erase(make_pair(d[to], to));
				}
				d[to] = d[v] + len;
				sqr[to] = sqr[v] + len * len;
				st.insert(make_pair(d[to], to));
			}
		}
	}

	cout << d[n] << ' ' << sqr[n];
	return 0;
}

