#include <bits/stdc++.h>


using namespace std;

#define pb push_back
#define int long long
#define mp make_pair

typedef pair<int, int> pii;

int n, m;

struct SNM {
	vector<int> up;
	vector<int> rate;
	vector<int> min_ind;
	vector<int> max_ind;
	int largest_comp = -1;

	SNM(int n) {
		up.resize(n);
		rate.resize(n);
		min_ind.resize(n);
		max_ind.resize(n);
	}

	void add_vertex(int id, int rating) {
		up[id] = id;
		rate[id] = rating;
		min_ind[id] = id;
		max_ind[id] = id;
		if (largest_comp == -1) {
			largest_comp = id;
		}
		if (rate[largest_comp] < rate[id]) {
			largest_comp = id;
		}
	}

	int get_root(int v) {
		if (up[v] == v) return v;
		return up[v] = get_root(up[v]);
	}

	bool one_comp(int a, int b) {
		return get_root(a) == get_root(b);
	}

	void merge(int a, int b) {
		if (one_comp(a, b)) return;
		a = get_root(a);
		b = get_root(b);
		rate[a] += rate[b];
		min_ind[a] = min(min_ind[a], min_ind[b]);
		max_ind[a] = max(max_ind[a], max_ind[b]);
		up[b] = a;
		if (rate[a] > rate[largest_comp]) {
			largest_comp = a;
		}
	}
};

signed main() {
	// freopen("servers.in", "r", stdin);
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> m;
	vector<int> first_dis(n);
	vector<int> first_rating(n);
	for (int i = 0; i < n; i++) cin >> first_dis[i];
	for (int i = 0; i < n; i++) cin >> first_rating[i];
	vector<int> second_dis(m);
	vector<int> second_rating(m);
	for (int i = 0; i < m; i++) cin >> second_dis[i];
	for (int i = 0; i < m; i++) cin >> second_rating[i];
	vector<int> second_pos_of(n + m + 1, -1);
	for (int i = 0; i < m; i++) {
		second_pos_of[second_dis[i]] = i;
	}
	
	int best_rating = 0;
	pii best_first = mp(0, 0);
	pii best_second = mp(0, 0);


	auto relax = [&best_rating, &best_first, &best_second](int _subrate, pii sub_first, pii sub_second){
		sub_first.first++; sub_first.second++;
		sub_second.first++; sub_second.second++;
		if (sub_first.first > sub_first.second) {
			sub_first = mp(0, 0);
		}
		if (sub_second.first > sub_second.second) {
			sub_second = mp(0, 0);
		}
		if (best_rating < _subrate) {
			best_rating = _subrate;
			best_first = sub_first;
			best_second = sub_second;
		}
	};

	set<int> set_first_dis(first_dis.begin(), first_dis.end());

	// SNM sus(m);
	// vector<bool> enable_map(m, false);

	// auto add_vertex = [&second_rating, &sus, &enable_map, &second_pos_of](int dis_id){
	// 	int sind = second_pos_of[dis_id];
	// 	int m = enable_map.size();
	// 	if (sind != -1) {
	// 		sus.add_vertex(sind, second_rating[sind]);
	// 		enable_map[sind] = true;
	// 		if (sind > 0 && enable_map[sind - 1]) {
	// 			sus.merge(sind, sind - 1);
	// 		}
	// 		if (sind < m - 1 && enable_map[sind + 1]) {
	// 			sus.merge(sind, sind + 1);
	// 		}
	// 	}
	// };

	// add_vertex(1);
	// add_vertex(3);
	// add_vertex(2);
	// cout << sus.rate[sus.largest_comp] << endl;
	// return 0;

	SNM et_sus(m);
	vector<bool> et_enable_map(m, false);
	auto add_vertex = [&second_rating, &et_sus, &et_enable_map, &second_pos_of](int dis_id){
		int sind = second_pos_of[dis_id];
		int m = et_enable_map.size();
		if (sind != -1) {
			et_sus.add_vertex(sind, second_rating[sind]);
			et_enable_map[sind] = true;
			if (sind > 0 && et_enable_map[sind - 1]) {
				et_sus.merge(sind, sind - 1);
			}
			if (sind < m - 1 && et_enable_map[sind + 1]) {
				et_sus.merge(sind, sind + 1);
			}
		}
	};

	for (int i = 0; i < m; i++) {
		if (set_first_dis.find(second_dis[i]) == set_first_dis.end()) {
			add_vertex(second_dis[i]);		
		}
	}




	for (int i = 0; i < n; i++) {
		SNM sus = et_sus;
		vector<bool> enable_map = et_enable_map;

		auto add_vertex = [&second_rating, &sus, &enable_map, &second_pos_of](int dis_id) {
			int sind = second_pos_of[dis_id];
			int m = enable_map.size();
			if (sind != -1) {
				sus.add_vertex(sind, second_rating[sind]);
				enable_map[sind] = true;
				if (sind > 0 && enable_map[sind - 1]) {
					sus.merge(sind, sind - 1);
				}
				if (sind < m - 1 && enable_map[sind + 1]) {
					sus.merge(sind, sind + 1);
				}
			}
		};

		for (int j = 0; j < i; j++) {
			add_vertex(first_dis[j]);
		}
		
		int all = 0;
		for (int j = i; j < n; j++) {
			all += first_rating[j];
		}

		if (sus.largest_comp == -1) {
			relax(all, mp(i, n - 1), mp(-1, -1));
		} else {
			relax(all + sus.rate[sus.largest_comp], mp(i, n - 1), mp(sus.min_ind[sus.largest_comp], sus.max_ind[sus.largest_comp]));
		}

		for (int j = n - 1; j > i - 1; j--) {
			all -= first_rating[j];
			add_vertex(first_dis[j]);
			relax(all + sus.rate[sus.largest_comp], mp(i, j - 1), mp(sus.min_ind[sus.largest_comp], sus.max_ind[sus.largest_comp]));
		}
	}
	cout << best_rating << endl;
	cout << best_first.first << " " << best_first.second << endl;
	cout << best_second.first << " " << best_second.second << endl;
}