#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef vector <int> vint;
typedef pair <int, int> Pair;

const int inf = 1e9 + 7;

#define pb push_back
#define mp make_pair
#define F first
#define S second

#define FileName "order"

const int N = 1000001, M = 30, K = 1 << 21;

struct ftree{
    int f[N];
    ftree(){
        for (int i = 0; i < N; i++)
            f[i] = 0;
    }
    int lsb(int t){
        return t&-t;
    }
    int get(int i){
        int sum = 0;
        for (; i > 0; i -= lsb(i))
            sum += f[i];
        return sum;
    }
    int get(int l, int r){
        return get(r) - get(l - 1);
    }
    void change(int i, int key1){
        int key = key1 - get(i, i);
        for (; i < N; i += lsb(i))
            f[i] += key;
    }
};

int tree[K];

void tchange(int i, int key){
    tree[i + K / 2] = key;
    i /= 2;
    for (; i > 0; i /= 2)
        tree[i] = max(tree[i * 2], tree[i * 2 + 1]);
}

int getmax(int i, int tl, int tr, int l, int r){
    if (l <= tl && tr <= r)
        return tree[i];
    if (l >= tr || r <= tl)
        return 0;
    int tm = (tl + tr) / 2;
    return max(getmax(i * 2, tl, tm, l, r), getmax(i * 2 + 1, tm, tr, l, r));
}

ftree f[M];

int n;

map <ll, int> timec, ans;

int Time = 1;

void change(int j, int t){
    for (int i = 0; i < M; i++)
        f[i].change(j, int((t & (1 << i)) > 0));
    tchange(j, Time++);
}

int getb(int l, int r, int deep){
    if (l == r)
        return -2;
    if (deep < 0)
        return -2;
    ll t = l + r * N + deep * N * N;
    if (timec[t] != 0 && timec[t] > getmax(1, 0, K / 2, l, r + 1))
        return ans[t];
    timec[t] = Time;
    int s = f[deep].get(l, r);
    if (s == 0 || s == r - l + 1){
        ans[t] = getb(l, r, deep - 1);
        return ans[t];
    }
    int a;
    if (f[deep].get(r - s + 1, r) == s){
        int g1 = getb(l, r - s, deep - 1), g2 = getb(r - s + 1, r, deep - 1);
        if (g1 == -2 && g2 == -2)
            a = 0;
        else if (g1 == -1 || g2 == -1)
            a = -1;
        else if (g1 == -2)
            a = g2;
        else if (g2 == -2)
            a = g1;
        else if (g1 == g2)
            a = g1;
        else a = -1;
    } else if (f[deep].get(l, l + s - 1) == s){
        int g1 = getb(l, l + s - 1, deep - 1), g2 = getb(l + s, r, deep - 1);
        if (g1 == -2 && g2 == -2)
            a = (1 << deep);
        else if (g1 == -1 || g2 == -1)
            a = -1;
        else if (g1 == -2)
            a = (1 << deep) + g2;
        else if (g2 == -2)
            a = (1 << deep) + g1;
        else if (g1 == g2)
            a = (1 << deep) + g1;
        else a = -1;
    } else
        a = -1;
    ans[t] = a;
    return a;
}

int Getb(){
    int t = getb(1, n, 29);
    if (t == -2)
        return 0;
    return t;
}

int main()
{
    freopen("input.txt", "r", stdin);
    //freopen(FileName ".in", "r", stdin);
    //freopen(FileName ".out", "w", stdout);

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n;
    for (int i = 1; i <= n; i++){
        int a;
        cin >> a;
        change(i, a);
    }
    cout << Getb() << "\n";
    int q;
    cin >> q;
    for (; q > 0; q--){
        int i, t;
        cin >> i >> t;
        change(i, t);
        cout << Getb() << "\n";
    }
    return 0;
}
