#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int maxn = 1e3 + 100, inf = 1e9 + 100, mod = 1e9 + 993;

struct treap{
    ll v, x, y, sz;
    treap *l, *r;
};

typedef treap * ptr;

ptr create(ll v, ll x){
    ptr t = new treap;
    t->v = v;
    t->x = x;
    t->y = rand();
    t->sz = 1;
    t->l = nullptr;
    t->r = nullptr;
    return t;
}

ll sz(ptr t){
    return t == nullptr ? 0 : t->sz;
}

void upd(ptr &t){
    if (t != nullptr)
        t->sz = 1 + sz(t->l) + sz(t->r);
}

void split(ptr t, ptr &l, ptr &r, ll key){
    if (t == nullptr){
        l = nullptr;
        r = nullptr;
        return;
    }
    if (t->x <= key)
        split(t->r, t->r, r, key), l = t;
    else
        split(t->l, l, t->l, key), r = t;
    upd(l);
    upd(r);
}

void merge(ptr &t, ptr l, ptr r){
    if (l == nullptr){
        t = r;
        return;
    }
    if (r == nullptr){
        t = l;
        return;
    }
    if (l->y <= r->y)
        merge(l->r, l->r, r), t = l;
    else
        merge(r->l, l, r->l), t = r;
    upd(t);
}

ptr root = nullptr;

int n = maxn - 100;

int d[maxn][maxn];



int main(){
    #ifdef ONPC
    ifstream cin("a.in");
    ofstream cout("a.out");
    #else
    ifstream cin("sum.in");
    ofstream cout("sum.out");
    #endif // ONPC
    ios::sync_with_stdio(0);
    for (int i = 0; i < n; i++)
        for (int j = 0; j < n; j++)
            d[i][j] = rand();
    for (int k = 0; k < n; k++)
        for (int i = 0; i < n; i++)
            for (int j = 0; j < n; j++)
                d[i][j] = min(d[i][j], d[i][k] + d[k][j]);
    int a, b;
    cin >> a >> b;
    cout << a + b;
}

/*#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int maxn = 2e5 + 100, inf = 1e9 + 100, mod = 1e9 + 993;


struct treap{
    int v, x, y, sz;
    treap *l, *r;
};

typedef treap * ptr;

ptr create(int v, int x){
    ptr t = new treap;
    t->v = v;
    t->x = x;
    t->y = rand();
    t->sz = 1;
    t->l = nullptr;
    t->r = nullptr;
    return t;
}

int sz(ptr t){
    return t == nullptr ? 0 : t->sz;
}

void upd(ptr &t){
    if (t != nullptr)
        t->sz = 1 + sz(t->l) + sz(t->r);
}

void split(ptr t, ptr &l, ptr &r, int key){
    if (t == nullptr){
        l = nullptr;
        r = nullptr;
        return;
    }
    if (t->x <= key)
        split(t->l, t->l, r, key), l = t;
    else
        split(t->r, l, t->r, key), r = t;
    upd(l);
    upd(r);
}

void merge(ptr &t, ptr l, ptr r){
    if (l == nullptr){
        t = r;
        return;
    }
    if (r == nullptr){
        t = l;
        return;
    }
    if (l->y <= r->y)
        merge(l->r, l->r, r), t = l;
    else
        merge(r->l, l, r->l), t = r;
    upd(t);
}

ptr root = nullptr;

int main()
{
    #ifdef ONPC
    ifstream cin("a.in");
    ofstream cout("a.out");
    #else
    ifstream cin("sum.in");
    ofstream cout("sum.out");
    #endif // ONPC
    ios::sync_with_stdio(0);
    int a, b;
    cin >> a >> b;

}
*/
