#include <bits/stdc++.h>

#define int int64_t

using namespace std;

struct cht
{
    vector<int> b;
    vector<int> k;
    vector<int> bp;
    int size()
    {
        return b.size();
    }
    int get(int val)
    {
        //cerr << "get : " << val << "\n";
        //for (int i = 0; i < size(); i++)
        //   cerr << " " << k[i] << " x + " << b[i] << "\n";
        int idx = upper_bound(bp.begin(), bp.end(), val) - bp.begin();
        //cerr << "[" << idx << "] = " << k[idx] << " x + " << b[idx] << "\n";
        return k[idx] * val + b[idx];
    }
    int inter(int k1, int b1, int k2, int b2)
    {
        int p = k1 - k2;
        int q = b2 - b1;
        if (q <= 0)
        {
            return 0;
        }
        return (q + p - 1) / p;
    }
    void add(int K, int B)
    {
        if (b.size() == 0)
        {
            k.push_back(K);
            b.push_back(B);
            return;
        }
        while(bp.size() > 0)
        {
            if (inter(K, B, k.back(), b.back()) > bp.back())
                break;
            k.pop_back();
            b.pop_back();
            bp.pop_back();
        }
        bp.push_back(inter(K, B, k.back(), b.back()));
        k.push_back(K);
        b.push_back(B);
    }
};

struct edge
{
    int v, p, idx, w;
    explicit edge(int v = 0, int w = 0) : v(v), w(w) {};
};

vector<int> dist(int s, vector<vector<edge> > g)
{
    int n = g.size();
    vector<int> ans(n, 1e18);
    ans[s] = 0;
    set<pair<int, int> > q;
    q.insert({ 0, s });
    while(!q.empty())
    {
        int v = q.begin()->second;
        int w = q.begin()->first;
        q.erase({ w, v });
        for (edge e : g[v])
        {
            int na = w + e.w;
            if (ans[e.v] > na)
            {
                q.erase({ans[e.v], e.v});
                q.insert({na, e.v});
                ans[e.v] = na;
            }
        }
    }
    for (int &i : ans)
    {
        if (i > 1e16)
            i = -1;
    }
    return ans;
}

vector<int> used;
vector<int> ts;
vector<vector<int> > gg;

void ts_dfs(int v)
{
    if (used[v])
        return;
    used[v] = 1;
    for (int u : gg[v])
        ts_dfs(u);
    ts.push_back(v);
}

int32_t main()
{
    ios::sync_with_stdio(0);
    int n, m;
    cin >> n >> m;
    vector<vector<edge> > g(n);
    vector<vector<edge> > rg(n);
    vector<vector<pair<int, edge> > > paths(m);
    for (int i = 0; i < m; i++)
    {
        //cerr << i << "\n";
        int cnt;
        cin >> cnt;
        int prev;
        cin >> prev;
        prev--;
        for (int j = 0; j < cnt; j++)
        {
            int t;
            cin >> t;
            int nxt;
            cin >> nxt;
            //cerr << j << " : " << nxt << "\n";
            nxt--;
            g[prev].push_back(edge(nxt, t));
            rg[nxt].push_back(edge(prev, t));
            paths[i].push_back({prev, edge(nxt, t)});
            prev = nxt;
        }
    }
    //cerr << "read\n";
    auto dist1 = dist(0, g);
    auto dist2 = dist(n - 1, rg);
    //cerr << "dist\n";
    gg.resize(n);
    used.resize(n);
    int D = dist1[n - 1];
    //cerr << dist1[n - 1] << " " << dist2[0] << "\n";
    int pc = 0;
    vector<vector<int> > hpaths(n);
    for (int i = 0; i < m; i++)
    {
        hpaths[paths[i][0].first].push_back(pc);
        for (auto j : paths[i])
        {
            if (dist1[j.first] + dist2[j.second.v] + j.second.w == D)
                gg[j.first].push_back(j.second.v);
            else
                pc++;
            hpaths[j.second.v].push_back(pc);
        }
        pc++;
    }
    //cerr << "rec_paths\n";
    ts_dfs(0);
    reverse(ts.begin(), ts.end());
    //cerr << "ts\n";
    vector<cht> dp(pc + 1);
    vector<int> out(n);
    for (int i : ts)
    {
        for (int j : hpaths[i])
        {
            if (dp[j].size() > 0)
                out[i] = max(out[i], dp[j].get(dist2[i]) + dist2[i] * dist2[i]);
        }
        for (int j : hpaths[i])
        {
            dp[j].add(-2 * dist2[i], out[i] + dist2[i] * dist2[i]);
        }
        //cerr << -2 * dist2[i] << " x + " << out[i] + dist2[i] * dist2[i] << "\n";
    }
    cout << D << " " << out[n - 1];
    return 0;
}
