#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <bitset>
#include <unordered_set>
#include <set>

using namespace std;

struct pt {
    long long x, y;
};

inline bool cw(pt a, pt b, pt c) {
    return ((b.x - a.x) * (c.y - a.y) - (c.x - a.x) * (b.y - a.y)) < 0;
}

inline bool isin(pt a, pt b, pt c, pt t) {
    if(cw(a, b, c) == cw(a, b, t) && cw(a, b, c) == cw(a, t, c))
        if(cw(b, c, a) == cw(b, c, t) && cw(b, c, a) == cw(b, t, a))
            if(cw(c, a, b) == cw(c, a, t) && cw(c, a, b) == cw(c, t, b))
                return true;
    return false;
}

vector < pair <pt, int> > ret;
vector <int> isact;
int n;

pair <pt, int> one, two, three;

inline void answer(pair <pt, int> a, pair <pt, int> b, pair <pt, int> c) {
    cout << "! 3 " << a.second << " " << b.second << " " << c.second << endl;
}

void intriangle()
{
    string nowans;
    int active = n;
    isact.assign(active, 1);
    while(true) {
        for(int i = 0; i < n; i++)
            if(isact[i] != 0 && (ret[i].second == one.second || ret[i].second == two.second || ret[i].second == three.second || !isin(one.first, two.first, three.first, ret[i].first))) {
                isact[i] = 0;
                active--;
            }

        if(active == 0) {
            answer(one, two, three);
            return;
        }

        //go
        pair <pt, int> frontelem;
        for(int i = 0; i < n; i++) if(isact[i] == 1) {
            frontelem = ret[i];
            break;
        }

        cout << "? 3 " << one.second << " " << two.second << " " << frontelem .second << endl;
        cin >> nowans;
        if(nowans == "Yes") {
            three = frontelem;
            continue;
        }
        cout << "? 3 " << one.second << " " << three.second << " " << frontelem.second << endl;
        cin >> nowans;
        if(nowans == "Yes") {
            two = frontelem;
            continue;
        }
        cout << "? 3 " << two.second << " " << three.second << " " << frontelem.second << endl;
        cin >> nowans;
        if(nowans == "Yes") {
            one = frontelem;
            continue;
        }
    }
}

void find_ans()
{
    string nowans;
    for(int i = 0; i < n; i++) for(int j = i + 1; j < n; j++) for(int k = j + 1; k < n; k++) {
        cout << "? 3 " << i + 1 << " " << j + 1 << " " << k + 1 << endl;
        cin >> nowans;
        if(nowans == "Yes") {
            one = ret[i];
            two = ret[j];
            three = ret[k];
            intriangle();
            return;
        }
    }
}

int main()
{
    cin >> n;
    ret.resize(n);
    for(int i = 0; i < n; i++) {
        cin >> ret[i].first.x >> ret[i].first.y;
        ret[i].second = i + 1;
    }

    //go
    int q;
    cin >> q;
    for(int iter = 0; iter < q; iter++) {
        find_ans();
    }

    return 0;
}
