#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

const int MAXN = 505;

int n, m;
int disa[MAXN], disb[MAXN];
vector <long long> rata, ratb;
int rel[MAXN];

vector <int> ok;

struct segment_tree {
    vector <long long> t;
    int n;

    segment_tree(vector <long long> &arr) {
        n = 1;
        while(n < arr.size()) n *= 2;
        t.assign(2 * n, 0);
        for(int i = 0; i < n; i++) t[i + n] = (i < arr.size() ? arr[i] : 0);
        for(int i = n - 1; i > 0; i--) t[i] = t[2 * i] + t[2 * i + 1];
    }

    void update(int pos, long long val) {
        pos = pos + n - 1;
        t[pos] = val;
        while(pos >= 1) {
            pos /= 2;
            t[pos] = t[pos * 2] + t[pos * 2 + 1];
        }
    }

    long long nowget(int l, int r, int nowl, int nowr, int pos) {
        if(nowl > r || nowr < l) return 0;
        if(nowl >= l && nowr <= r) return t[pos];
        return nowget(l, r, nowl, (nowl + nowr) / 2, pos * 2) + nowget(l, r, (nowl + nowr) / 2 + 1, nowr, pos * 2 + 1);

    }

    long long get(int l, int r) {
        return nowget(l, r, 1, n, 1);
    }
};

int main()
{
    cin >> n >> m;
    rata.resize(n);
    ratb.resize(m);
    for(int i = 0; i < n; i++) cin >> disa[i];
    for(int i = 0; i < n; i++) cin >> rata[i];
    for(int i = 0; i < m; i++) cin >> disb[i];
    for(int i = 0; i < m; i++) cin >> ratb[i];

    //relative
    for(int i = 0; i < n; i++) {
        rel[i] = 0;
        for(int j = 0; j < m; j++) if(disb[j] == disa[i]) rel[i] = j + 1;
    }

    long long opt = 0;
    long long la = -1, lb = -1, ra = -1, rb = -1;

    //no a courses
    long long noaratb = 0;
    for(int i = 0; i < m; i++) noaratb += ratb[i];
    if(noaratb > opt) {
        opt = noaratb;
        lb = 0;
        rb = m - 1;
    }

    segment_tree btree(ratb);

    //go
    for(int i = 0; i < n; i++)
    {
        long long last = 0;
        set <int> poses = {0, m + 1};
        set < pair < long long, pair <int, int> > > brats;
        brats.insert({noaratb, {1, m}});
        for(int j = i; j < n; j++) {
            if(rel[j] == 0) last += rata[j];
            else {
                auto fol = poses.upper_bound(rel[j]);
                auto prev = fol;
                prev--;
                brats.erase({btree.get(*prev + 1, *fol - 1), {*prev + 1, *fol - 1}});
                brats.insert({btree.get(*prev + 1, rel[j] - 1), {*prev + 1, rel[j] - 1}});
                brats.insert({btree.get(rel[j] + 1, *fol - 1), {rel[j] + 1, *fol - 1}});
                poses.insert(rel[j]);
                last += rata[j];
            }

            if(last + (*brats.rbegin()).first > opt) {
                opt = last + (*brats.rbegin()).first;
                la = i;
                ra = j;
                lb = (*brats.rbegin()).second.first - 1;
                rb = (*brats.rbegin()).second.second - 1;
            }
        }
        //optimal
    }

    cout << opt << endl;
    cout << la + 1 << " " << ra + 1 << endl;
    cout << lb + 1 << " " << rb + 1 << endl;
    return 0;
}
