#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <stdio.h>
#include <math.h>
#include <cmath>
#include <queue>
#include <deque>


using namespace std;

#define ll long long

const int N = 1000100;

struct block {
    bool can;
    int l, r;
    block(bool a, int b, int c) {
        can = a;
        l = b;
        r = c;
    }
};

bool operator<(block x, block y) {
    return x.can > y.can;
}

bool need[N];

int lef[N], rig[N];

int main() {
    int q;
    cin >> q;
    for (int ev = 0; ev < q; ++ev) {
        string s, t;
        cin >> s >> t;
        vector< pair<int, int> > a;
        int n = (int)s.size(), m = (int)t.size();
        if (n != m) {
            cout << "No" << endl;
            continue;
        }
        if (s == t) {
            cout << "Yes" << endl;
            continue;
        }
        for (int i = 0; i <= n; ++i) {
            need[i] = false;
            lef[i] = 0;
            rig[i] = 0;
        }
        int i = 0;
        while (i < n) {
            int j = i;
            while (j < n - 1 && s[j + 1] == s[j]) {
                ++j;
            }
            a.push_back({i, j});
            rig[i] = j;
            lef[j] = i;
            i = j + 1;
        }
        bool good = true;
        int sz = (int)a.size();
        if (sz == 1) {
            cout << "No" << endl;
            continue;
        }
        vector<int> ch;
        for (int bl = 0; bl < sz; ++bl) {
            bool fir = false, sec = false;
            char c = '.';
            for (int i = a[bl].first; i <= a[bl].second; ++i) {
                if (s[i] != t[i]) {
                    fir = true;
                    c = t[i];
                } else {
                    sec = true;
                }
            }
            ch.push_back(c);
            if (fir && sec) {
                good = false;
                break;
            }
            if (c != '.') {
                for (int i = a[bl].first; i <= a[bl].second; ++i) {
                    need[i] = true;
                }
            }
        }
        for (int i = 0; i < (int)ch.size() - 1; ++i) {
            if (ch[i] != ch[i + 1] && ch[i] != '.' && ch[i + 1] != '.') {
                good = false;
                break;
            }
        }
        if (!good) {
            cout << "No" << endl;
            break;
        }
        set<block> S;
        for (int bl = 0; bl < sz; ++bl) {
            int i = a[bl].first, j = a[bl].second;
            if (!(i > 0 && need[i - 1]) && !need[j + 1]) {
                continue;
            }
            if (bl == 0) {
                int ir = a[bl + 1].first, jr = a[bl + 1].second;
                if (j - i + 1 > jr - ir + 1) {
                    S.insert(block(1, i, j));
                } else {
                    S.insert(block(0, i, j));
                }
            } else if (bl == sz - 1) {
                int l = a[bl - 1].first, r = a[bl - 1].second;
                if (j - i + 1 > r - l + 1) {
                    S.insert(block(1, i, j));
                } else {
                    S.insert(block(0, i, j));
                }
            } else {
                int il = a[bl - 1].first, jl = a[bl - 1].second;
                int ir = a[bl + 1].first, jr = a[bl + 1].second;
                if (j - i + 1 > jl - il + 1) {
                    S.insert(block(1, i, j));
                } else if (j - i + 1 > jr - ir + 1) {
                    S.insert(block(1, i, j));
                } else {
                    S.insert(block(0, i, j));
                }
            }
        }
        while (!S.empty()) {
            block p = *S.begin();
            bool can = p.can;
            if (!can) {
                break;
            }
            S.erase(S.begin());
            int i = p.l, j = p.r;
            //cout << "can = " << can << " l = " << i << " r = " << j << endl;
            if (j - i + 1 > (i - 1) - lef[i - 1] + 1) {
                for (int x = lef[i - 1]; x < i; ++x) {
                    need[x] = false;
                    if (s[x] == '-') {
                        s[x] = '+';
                    } else {
                        s[x] = '-';
                    }
                }
            }
             if (j - i + 1 > rig[j + 1] - (j + 1) + 1) {
                for (int x = j + 1; x <= rig[j + 1]; ++x) {
                    need[x] = false;
                    if (s[x] == '-') {
                        s[x] = '+';
                    } else {
                        s[x] = '-';
                    }
                }
            }
           // cout << s << endl;
            int l = i, r = j;
            while (l > 0 && s[l - 1] == s[l]) {
                --l;
            }
            while (r < n - 1 && s[r + 1] == s[r]) {
                ++r;
            }
            if (i != l || j != r) {
                i = l;
                j = r;
            }
            if (i > 0 && need[i - 1] && r - l + 1 > (i - 1) - lef[i - 1] + 1) {
                S.insert(block(1, i, j));
            } else if (i < sz - 1 && need[j + 1] && r - l + 1 > rig[j + 1] - (j + 1) + 1) {
                S.insert(block(1, i, j));
            }
        }
        for (int i = 0; i < n; ++i) {
            if (need[i]) {
                good = false;
                break;
            }
        }
        if (good) {
            cout << "Yes" << endl;
        } else {
            cout << "No" << endl;
        }
    }
    return 0;
}
