#include <iostream>
#include <vector>
#include <queue>

using namespace std;

bool goodPair(const string &s, const string &t) {
    for (int i = 1; i < t.size(); ++i) {
        if (t[i] != t[i - 1]) {
            if (t[i] != s[i] || t[i - 1] != s[i - 1]) {
                return false;
            }
        }
    }
    return true;
}

vector<vector<int>> split(const string &s, const string &t) {
    vector<vector<int>> ans;
    ans.push_back({});
    if (s[0] != t[0]) {
        ans.back().push_back(0);
    }
    int cntNow = 1;
    for (int i = 1; i < t.size(); ++i) {
        if (t[i] != t[i - 1]) {
            ans.back().push_back(cntNow);
            cntNow = 1;
            ans.push_back({});
        } else {
            if (s[i] != s[i - 1]) {
                ans.back().push_back(cntNow);
                cntNow = 1;
            } else {
                ++cntNow;
            }
        }
    }
    ans.back().push_back(cntNow);
    if (s.back() != t.back()) {
        ans.back().push_back(0);
    }
    return ans;
}

vector<int> pr, h;
vector<int> sum, lt;

int getPr(int v) {
    if (pr[v] == v) {
        return v;
    }
    return pr[v] = getPr(pr[v]);
}

void join(int u, int v) {
    u = getPr(u);
    v = getPr(v);
    if (u == v) {
        return;
    }
    if (h[u] < h[v]) {
        swap(u, v);
    }
    if (h[u] == h[v]) {
        ++h[u];
    }
    pr[v] = u;
    sum[u] += sum[v];
    lt[u] = min(lt[u], lt[v]);
}

void can(int i, const vector<int> &a) {
    if (i == -1) {
        return;
    }
    if (sum[getPr(i - 1)] > a[i] || sum[getPr(a[i + 1])] > a[i]) {
        join(i - 1, i);
        join(i, i + 1);
        can(lt[getPr(i - 1)] - 1, a);
    }
}

bool canToSame(const vector<int> &a) {
    if (a.size() == 1) {
        return true;
    }
    pr.resize(a.size());
    h.resize(a.size());
    sum.resize(a.size());
    lt.resize(a.size());
    for (int i = 0; i < a.size(); ++i) {
        pr[i] = i;
        h[i] = 0;
        sum[i] = a[i];
        lt[i] = i;
    }
    for (int i = 1; i < a.size(); i += 2) {
        can(i, a);
    }
    return lt[getPr(a.size() - 2)] == 0;
}

bool check(const string &s, const string &t) {
    if (!goodPair(s, t)) {
        return false;
    }
    auto fr = split(s, t);
    bool succ = true;
    for (auto a : fr) {
        succ &= canToSame(a);
    }
    return succ;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        string s, t;
        cin >> s >> t;
        if (check(s, t)) {
            cout << "Yes\n";
        } else {
            cout << "No\n";
        }
    }
    system("pause");
    return 0;
}