#include <iostream>
#include <list>
#include <queue>
#include <set>

#define sz(a_) int((a_).size())

using namespace std;

using ll = long long;

constexpr int maxa = 2e6+10;
constexpr int maxn = 120;
constexpr ll pr = 1000000000ll;
constexpr ll inf = 1e17;

struct ex {
    int l, r, c;
};

ll g[maxa];
ex exs[maxn];

struct el {
    int l, r;
    ll val;
};

el tr[maxa*2+100];

void build_tree(int i, int l, int r)
{
    tr[i] = el{l, r, inf};
    if (r-l > 1) {
        int m = (l+r)/2;
        build_tree(i*2+1, l, m);
        build_tree(i*2+2, m, r);
    }
}

void update(int i, int pos, ll nv)
{
    if (pos < tr[i].l || pos >= tr[i].r) {
        return;
    }
    tr[i].val = min(tr[i].val, nv);
    if (tr[i].r-tr[i].l > 1) {
        update(i*2+1, pos, nv);
        update(i*2+2, pos, nv);
    }
}

ll get(int i, int l, int r)
{
    if (l <= tr[i].l && r >= tr[i].r) {
        return tr[i].val;
    }
    if (l >= tr[i].r || r <= tr[i].l) {
        return inf;
    }
    return min(get(i*2+1, l, r), get(i*2+2, l, r));
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, a;
    cin >> n >> a;
    for (int i = 0; i < n; ++i) {
        cin >> exs[i].l >> exs[i].r >> exs[i].c;
    }
    build_tree(0, 0, a+1);
    for (int i = a; i >= 0; --i) {
        ll best = 0;
        for (int j = 0; j < n; ++j) {
            if (i+exs[j].r > a) {
                continue;
            }
            int l = i+exs[j].l, r = i+exs[j].r;
            ll nb = get(0, l, r+1);
            nb -= exs[j].c+pr*i;
            best = max(best, nb);
        }
        g[i] = best;
        update(0, i, pr*i+g[i]);
    }
    cout << g[0] << '\n';
    return 0;
}