#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>

using namespace std;
const long long MAXN = 1e3 * 5 + 100;
const long double EPS = 1e-9;
const long double PI = asin(1.0) * 2;

struct Point{
    long long x;
    long long y;
};

struct Vector{
    long long x;
    long long y;

    Vector(Point& a, Point& b){
        x = b.x - a.x;
        y = b.y - a.y;
    }

    long long cross_product(Vector b){
        return x * b.y - y * b.x;
    }
};

struct VectorLD{
    long double x;
    long double y;

    VectorLD(Point& a, Point& b){
        x = b.x - a.x;
        y = b.y - a.y;
    }

    long double angle(VectorLD& b){
        return atan2(x * b.y - y * b.x, x * b.x + y * b.y);
    }
};

Point mas[MAXN];
pair<Point, long long> mas2[MAXN];

struct Triangle{
    long long a;
    long long b;
    long long c;

    bool in_tr(Point& p){
        long double angle = 0;
        VectorLD va = VectorLD(p, mas[a]);
        VectorLD vb = VectorLD(p, mas[b]);
        VectorLD vc = VectorLD(p, mas[c]);

        angle += va.angle(vb);
        angle += vb.angle(vc);
        angle += vc.angle(va);

        angle = abs(angle);

        if (abs(angle - PI * 2) < EPS){
            return true;
        } else {
            return false;
        }
    }
};

long long min_p = 0;

bool cmt(pair<Point, long long>& a, pair<Point, long long>& b){
    return (a.first.x * b.first.y - a.first.y * b.first.x) > 0;
}

vector<Triangle> trian;

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0);

    long long n;
    cin >> n;

    for (long long i = 0; i < n; ++i){
        cin >> mas[i].x >> mas[i].y;
        mas2[i].first = mas[i];
        mas2[i].second = i;
    }

    for (long long i = 0; i < n; ++i){
        if (mas[i].y < mas[min_p].y){
            min_p = i;
        } else if (mas[i].y == mas[min_p].y && mas[i].x < mas[min_p].x){
            min_p = i;
        }
    }

    swap(mas2[0], mas2[min_p]);
    sort(mas2 + 1, mas2 + n, cmt);

    for (long long i = 0; i < n; ++i){
        mas[i] = mas2[i].first;
    }

    vector<long long> stck;
    stck.push_back(0);

    for (long long i = 1; i < n; ++i){
        while (stck.size() > 1 && Vector(mas[stck[stck.size() - 2]], mas[stck[stck.size() - 1]]).cross_product(Vector(mas[stck[stck.size() - 2]], mas[i])) < 0){
            stck.pop_back();
        }

        stck.push_back(i);
    }


    set<long long> st;

    for (long long i = 0; i < n; ++i){
        st.insert(i);
    }

    for (long long i = 0; i < stck.size(); ++i){
        st.erase(stck[i]);
    }

    for (long long i = 1; i < stck.size() - 1; ++i){
        trian.push_back(Triangle({0, stck[i], stck[i + 1]}));
    }

    for (auto e : st){
        long long j = 0;
        while (j < trian.size()){
            if (trian[j].in_tr(mas[e])){
                long long a = trian[j].a;
                long long b = trian[j].b;
                long long c = trian[j].c;

                swap(trian[trian.size() - 1], trian[j]);

                trian.pop_back();
                trian.push_back({e, a, b});
                trian.push_back({e, b, c});
                trian.push_back({e, a, c});
                break;
            }
            ++j;
        }
    }

    long long q;
    cin >> q;

    for (long long j = 0; j < q; ++j){
        for (long long i = 0; i < trian.size(); ++i){
            cout << "? " << mas2[trian[i].a].second + 1 << ' ' << mas2[trian[i].b].second + 1 << ' ' << mas2[trian[i].c].second + 1 << endl;

            string an;
            cin >> an;

            if (an == "Yes"){
                cout << "! " << mas2[trian[i].a].second + 1 << ' ' << mas2[trian[i].b].second + 1 << ' ' << mas2[trian[i].c].second + 1 << endl;
                break;
            }
        }
    }

    return 0;
}
