#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <cmath>
#include <cassert>
#include <climits>
#include <functional>
#include <vector>

using namespace std;

typedef unsigned int index;

int sd[30];

pair<index, int> ogr(int a, int b)
{
	int f, s;
	for (index i = 29; i != (index)-1; --i)
	{
		f = ((sd[i] & a) > 0 ? 1 : 0);
		s = ((sd[i] & b) > 0 ? 1 : 0);
		if (f < s)
		{
			return {i, 1};
		}
		if (s < f)
		{
			return {i, 2};
		}
	}
	return {0, 0};
}

int **sumo;

int ans()/*{{{*/
{
	int anss = 0;
	for (index i = 0; i < 30; i++)
	{
		if (sumo[i][1] > 0 and sumo[i][2] > 0)
		{
			return -1;
		}
		else if (sumo[i][2] > 0)
		{
			anss += sd[i];
		}
	}
	return anss;
}/*}}}*/

void regen_plus(int a, int b)/*{{{*/
{
	auto i = ogr(a, b);
	++sumo[i.first][i.second];
}/*}}}*/

void regen_minus(int a, int b)/*{{{*/
{
	auto i = ogr(a, b);
	--sumo[i.first][i.second];
}/*}}}*/

int main()
{
#ifdef ONPC
	assert(freopen("a.in", "r", stdin));
	assert(freopen("a.out", "w", stdout));
#else
	assert(freopen("order.in", "r", stdin));
	assert(freopen("order.out", "w", stdout));
#endif
	ios::sync_with_stdio(false);
	size_t n;
	scanf("%d", &n);
	int *mas = new int[n];
	for (index i = 0; i < n; i++)
		scanf("%d", &mas[i]);
	sumo = new int *[30];
	for (index i = 0; i < 30; i++)
	{
		sd[i] = (1 << i);
		sumo[i] = new int[3];
		for (index j = 0; j < 3; j++)
			sumo[i][j] = 0;
	}
	for (index i = 0; i < n - 1; i++)
	{
		regen_plus(mas[i], mas[i + 1]);
	}
	cout << ans() << "\n";
	size_t q;
	scanf("%d", &q);
	for (index io = 0; io < q; io++)
	{
		index i;
		int a;
		scanf("%d %d", &i, &a);
		i--;
		if (i > 0)
		{
			regen_minus(mas[i - 1], mas[i]);
		}
		if (i < n - 1)
		{
			regen_minus(mas[i], mas[i + 1]);
		}
		mas[i] = a;
		if (i > 0)
		{
			regen_plus(mas[i - 1], mas[i]);
		}
		if (i < n - 1)
		{
			regen_plus(mas[i], mas[i + 1]);
		}
		cout << ans() << "\n";
	}
}
