#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <cmath>
#include <climits>
#include <vector>
#include <functional>

using namespace std;

typedef unsigned int index;

vector<size_t> parse(const string &s)
{
	size_t cs = 1;
	vector<size_t> ans;
	for (index i = 1; i < s.size(); i++)
	{
		if (s[i] != s[i - 1])
		{
			ans.push_back(cs);
			cs = 1;
		}
		else
			cs++;
	}
	ans.push_back(cs);
	return ans;
}

bool can(vector<size_t> q)
{
	vector<size_t> cur = {q[0]};
	for (index i = 0; i < q.size() / 2; i++)
	{
		size_t nw1 = q[2 * i + 1], nw2 = q[2 * i + 2];
		if (nw1 >= nw2 and nw1 >= cur.back())
		{
			cur.push_back(nw1);
			cur.push_back(nw2);
		}
		else
		{
			nw1 = nw1 + nw2 + cur.back();
			cur.pop_back();
			while (cur.size() > 0)
			{
				if (nw1 > cur.back())
				{
					nw1 += cur[cur.size() - 1] + cur[cur.size() - 2];
					cur.pop_back();
					cur.pop_back();
				}
				else
				{
					break;
				}
			}
			cur.push_back(nw1);
		}
	}
	return cur.size() == 1;
}

int main()
{
#ifdef ONPC
	assert(freopen("a.in", "r", stdin));
	assert(freopen("a.out", "w", stdout));
#else
	assert(freopen("storage.in", "r", stdin));
	assert(freopen("storage.out", "w", stdout));
#endif
	ios::sync_with_stdio(false);
	size_t cnt_tests;
	cin >> cnt_tests;
	for (index test = 0; test < cnt_tests; test++)
	{
		string s1, s2;
		cin >> s1 >> s2;
		vector<size_t> from = parse(s1), to = parse(s2);
		index last = 0;
		bool flag = true;
		size_t sm = 0;
		for (index i = 0; i < to.size(); i++)
		{
			vector<size_t> q;
			size_t sum = 0;
			do
			{
				q.push_back(from[last]);
				sum += from[last];
				last++;
			} while (sum < to[i]);
			if (sum == to[i] and q.size() % 2 == 1 and can(q) and s1[sm] == s2[sm])
			{
				sm += to[i];
				continue;
			}
			sm += to[i];
			if (sum == to[i] and i == 0 and q.size() % 2 == 0 and s1[0] != s2[0])
			{
				q.insert(q.begin(), 0);
				if (can(q))
					continue;
			}
			if (sum == to[i] and i + 1 == to.size() and q.size() % 2 == 0 and s1.back() != s2.back())
			{
				q.push_back(0);
				if (can(q))
					continue;
			}
			if (sum == to[i] and to.size() == 1 and q.size() % 2 == 1 and s1[0] != s2[0])
			{
				q.push_back(0);
				q.insert(q.begin(), 0);
				if (can(q))
					continue;
			}
			cout << "No" << endl;
			flag = false;
			break;
		}
		if (flag)
			cout << "Yes" << endl;
	}
}
