#include <bits/stdc++.h>
using namespace std;
#define DB(v) cerr << #v << ' ' << v << endl
#define sz(v) int(v.size())
#define For(i, a, b) for(int i = a;i <= b; ++i)

template <typename T>
inline ostream &operator << (ostream &out, const vector <T> &v) {
    for(auto to: v)
        out << to << ' ';
    out << '\n';
    return out;
}

template <typename T>
inline ostream &operator << (ostream &out, const set <T> &v) {
    for(auto to: v)
        out << to << ' ';
    out << '\n';
    return out;
}

const int K = 30;
const int N = 1e6 + 2;
string pattern = "";

bool want [K][2][N];
int amount [K][2];
int n;

vector <string> arr;

inline bool bit (int mask, int pos) {
    return bool (mask & (1 << pos));
}

inline string to_str (int x) {
    string res = pattern;
    for(int i = 0;i < K; ++i) {
        res[i] = ((bit(x, i)) + '0');
    }
    return res;
}

inline int to_digit (string &s) {
    int P = 1, res = 0;
    for(int i = 0;i < K; ++i) {
        res += (s[i] - '0') * P;
        P *= 2;
    }
    return res;
}

inline int first_diff (int pos) {
    for(int i = K - 1;i >= 0;i--) {
        if(arr[pos][i] != arr[pos + 1][i])
            return i;
    }
    return -1;
}

inline void calc (int pos) {
    if(pos == n || pos == 0)
        return;
    int bit = first_diff(pos);
    if(bit == -1)
        return;
    if(arr[pos][bit] == '0') {
        if(!want[bit][0][pos])
            amount[bit][0]++;
        want[bit][0][pos] = true;
    }
    else {
         if(!want[bit][1][pos])
            amount[bit][1]++;
        want[bit][1][pos] = true;
    }
}

inline void erase_all(int pos) {
    for(int i = 0;i < K; ++i) {
        For(j, 0, 1) {
            amount[i][j] -= want[i][j][pos];
            want[i][j][pos] = false;
        }
    }
}

inline void update (int pos, int val) {
    erase_all(pos);
    erase_all(pos - 1);
    arr[pos] = to_str(val);
    calc(pos - 1);
    calc(pos);
}

inline int get_answer () {
    string res = pattern;
    for(int i = 0;i < K; ++i) {
        if(amount[i][0] && amount[i][1])
            return -1;
        if(amount[i][1])
            res[i] = '1';
    }
    return to_digit(res);
}

int main()
{
#ifdef HOME
    freopen("input.txt","r",stdin);
#else
    freopen("order.in","r",stdin);
    freopen("order.out","w",stdout);
#endif // HOME
    ios::sync_with_stdio(NULL); cin.tie(NULL);
    for(int i = 0;i < K; ++i)
        pattern += '0';
    scanf("%d", &n);
    arr.assign(n + 1, pattern);
    For(i, 1, n) {
        int val;
        scanf("%d", &val);
        update (i, val);
    }
    int Q; scanf("%d", &Q);
    printf("%d\n", get_answer());

    int pos, val;
    For(q, 1, Q) {
        scanf("%d%d", &pos, &val);
        update(pos, val);
        printf("%d\n", get_answer());
    }
    return 0;
}
