#include <bits/stdc++.h>
using namespace std;
#define DB(v) cerr << #v << ' ' << v << endl
#define sz(v) int(v.size())
#define For(i, a, b) for(int i = a;i <= b; ++i)

typedef long long i64;

const i64 INF = 5e18;

struct point
{
    i64 x, y;
    point (i64 a = 0, i64 b = 0) {
        x = a, y = b;
    }
    void get () {
        cin >> x >> y;
    }

    point operator + (const point &other) const {
        return point(x + other.x, y + other.y);
    }
    point operator - (const point &other) const {
        return point (x - other.x, y - other.y);
    }
};

i64 cross (point one, point two) {
    return one.x * two.y - two.x * one.y;
}

i64 doubled_square (point A, point B, point C) {
    point AB = B - A, AC = C - A;
    return abs(cross(AB, AC));
}

vector <point> radio;
int n;

bool solved (int x, int y, int z) {
    cout << "? " << 3 << ' ' << x << ' ' << y << ' ' << z << endl;
    string jury; cin >> jury;
    if(jury == "Yes")
        return true;
    else
        return false;
}

void ready(int x, int y, int z) {
    cout << "! " << 3 << ' ' <<  x << ' ' << y << ' ' << z << endl;
}

void find_rest (int x, int y) {
    i64 S_min = INF, z_res = -1;
    For(z, 1, n) {
        if(z == x || z == y)
            continue;
        i64 cur_S = doubled_square(radio[x], radio[y], radio[z]);
        if(cur_S < S_min) {
            if(solved(x, y, z)) {
                z_res = z;
                S_min = cur_S;
            }
        }
    }

    ready(x, y, z_res);
}

void find_tiger() {
    int x_res = -1, y_res = -1, z_res = -1;
    i64 S_min = INF;
    For(x, 1, n) {
        For(y, x + 1, n) {
            For(z, y + 1, n) {
                if(solved(x, y, z)) {
                    find_rest(x, y);
                    return;
                }
            }
        }
    }
}

int main()
{
#ifdef HOME
    //freopen("input.txt","r",stdin);
#endif // HOME
    ios::sync_with_stdio(NULL); cin.tie(NULL);
    cin >> n;
    radio.resize(n + 1);
    For(i, 1, n) {
        radio[i].get();
    }

    int Q; cin >> Q;
    For(q, 1, Q) {
        find_tiger();
    }
    return 0;
}
