#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <set>
#include <algorithm>
#define lint int64_t
using namespace std;
#define all(x) (x).begin(), (x).end()

const lint C = 1000000000;
const lint inf = 100000000000000000;

char mass[64000000];
int qwe = 0;
void* operator new(size_t x){
	void* ans = mass + qwe;
	qwe += x;
	return ans;
}

struct st {
	lint v;
	st* l, *r;
	st() : l(0), r(0), v(0) {}
};

lint getmin(st* p, int l, int r, int tl, int tr, lint minget = -inf) {
	if (r <= tl || tr <= l)
		return inf;
	if (l <= tl && tr <= r)
		return p->v;


	int tm = (tl + tr) / 2;
	lint ans = inf;
	if (tm < r) {
		lint q = getmin(p->r, l, r, tm, tr, minget);
		if (q < ans)
			ans = q;
	}
	if (ans < minget) return ans;
	if (l < tm) {
		lint q = getmin(p->l, l, r, tl, tm, minget);
		if (q < ans)
			ans = q;
	}
	return ans;
}
void setmin(st* p, int pos, lint val, int tl, int tr) {
	if (pos < tl || pos >= tr)
		return;
	if (tl + 1 == tr) {
		p->v = val;
		return;
	}

	int tm = (tl + tr) / 2;
	if (pos < tm)
		setmin(p->l, pos, val, tl, tm);
	else 
		setmin(p->r, pos, val, tm, tr);

	p->v = min(p->l->v, p->r->v);
}

st* build(int tl, int tr) {
	st* p = new st;
	p->v = inf;
	if (tl + 1 == tr) {
		return p;
	}

	int tm = (tl + tr) / 2;
	p->l = build(tl, tm);
	p->r = build(tm, tr);
	return p;
}

int32_t main() {
	ios::sync_with_stdio(false);
#ifdef _DEBUG
	//ifstream cin ("a.in");
	ofstream cout("a.out");
	freopen("a.in", "r", stdin);
#endif

	lint a;
	int n; cin >> n >> a;
	const int N = 100;
	int l[N], r[N]; lint c[N];
	for (int i = 0; i < n; i++) cin >> l[i] >> r[i] >> c[i];

	vector < pair<int, pair<int, lint>> > vv(n);
	for (int i = 0; i < n; i++)
		vv[i] = { r[i], {l[i], c[i]} };
	sort(all(vv));
	for (int i = 0; i < n; i++) {
		l[i] = vv[i].second.first;
		r[i] = vv[i].first;
		c[i] = vv[i].second.second;
	}

	st* root = build(0, a + 1);

	vector<lint> maxg(a + 1);
	vector<lint> sufmin(a + 1);
	for (int i = a; i >= 0; i--) {
		maxg[i] = i * C;
		for (int j = 0; j < n; j++) {
			if (i + r[j] > a)
				break;
			lint ac = getmin(root, i + l[j], i + r[j] + 1, 0, a + 1, maxg[i] + c[j]);
			if (maxg[i] < ac - c[j])
				maxg[i] = ac - c[j];
		}

		setmin(root, i, maxg[i], 0, a + 1);

		sufmin[i] = maxg[i];
		if (i < a && sufmin[i] > sufmin[i + 1])
			sufmin[i] = sufmin[i + 1];
	}

	 

	cout << maxg[0];

	return 0;
}
