#include <bits/stdc++.h>
using namespace std;

struct tree
{
    int sz, y, c, sum;
    tree* left, *right;
    tree()
    {
        sz = 1;
        y = rand();
        left = NULL;
        right = NULL;
        c = 0;
        sum = 0;
    }
};

int size(tree* a)
{
    return (a == NULL ? 0 : a->sz);
}

int get_sum(tree* a)
{
    return a == NULL ? 0 : a->sum;
}

void recalc(tree* a)
{
    a->sz = size(a->left) + size(a->right) + 1;
    a->sum = get_sum(a->left) + get_sum(a->right) + a->c;
}

void split(tree* treap, int x, tree*& tree1, tree*& tree2)
{
    if (treap == NULL)
    {
        tree1 = NULL;
        tree2 = NULL;
        return;
    }
    if (size(treap->left) < x)
    {
        tree1 = treap;
        split(treap->right, x - size(treap->left) - 1, treap->right, tree2);
        recalc(treap);
    }
    else
    {
        tree2 = treap;
        split(treap->left, x, tree1, treap->left);
        recalc(treap);
    }
}

tree* merge(tree* tree1, tree* tree2)
{
    if (tree1 == NULL) return tree2;
    if (tree2 == NULL) return tree1;
    if (tree1->y < tree2->y)
    {
        tree1->right = merge(tree1->right, tree2);
        recalc(tree1);
        return tree1;
    }
    else
    {
        tree2->left = merge(tree1, tree2->left);
        recalc(tree2);
        return tree2;
    }
}

void insert(tree*& treap, int x, int ind)
{
    tree* tree1, *tree2;
    split(treap, ind, tree1, tree2);
    tree* nt = new tree;
    nt->c = x;
    recalc(nt);
    tree1 = merge(tree1, nt);
    treap = merge(tree1, tree2);
}

void erase(tree*& treap, int ind)
{
    tree* tree1, *tree2;
    split(treap, ind, treap, tree2);
    split(tree2, 1, tree1, tree2);
    treap = merge(treap, tree2);
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int a, b;
    cin >> a >> b >> a;
    tree* treap = NULL;
    insert(treap, a, 0);
    insert(treap, -1, 1);
    insert(treap, b, 2);
    erase(treap, 1);
    cout << get_sum(treap) << endl;
    return 0;
};

