#include <bits/stdc++.h>

#define size(a) (int(a.size()))

using namespace std;

typedef long long llong;
const llong inf = (llong) 1e9 + 7ll;
static char buff[(int) 1e6 + 17];
const int maxn = (int) 1e6 + 17;

int n;
llong t[maxn];
llong l[maxn], r[maxn], lq[maxn], rq[maxn];
bool pf[maxn], sf[maxn];

bool read()
{
    if (scanf("%d", &n) != 1)
        return false;

    for (int i = 0; i < n; ++i)
        scanf("%lld", &t[i]);

    for (int i = 0; i < n - 1; ++i)
        scanf("%lld %lld", &l[i], &r[i]);

    return true;
}

bool inter(int l1, int r1, int l2, int r2)
{
    return max(l1, l2) <= min(r1, r2);
}

bool go_l(int i, int s)
{
    if (i == 0)
        return true;

    if (inter(l[i - 1], r[i - 1], s, s + t[i]))
        return go_l(i - 1, max((int) l[i - 1], s));
    else
        return false;
}

bool go_r(int i, int s)
{
    if (i == n - 1)
        return true;

    if (inter(l[i], r[i], s, s + t[i]))
        return go_r(i + 1, max((int) l[i], s));
    else
        return false;
}

void naive()
{
    for (int i = 0; i < n; ++i)
    {
        bool good = false;

        for (int s = 0; s < 1000; ++s)
            if (go_l(i, s) && go_r(i, s))
            {
                good = true;
                printf("%d\n", s);
                break;
            }

        if (!good)
            printf("-1\n");
    }
}

void solve_t()
{
    for (int j = 0; j < n; ++j)
    {
        lq[j] = 0;
        rq[j] = inf;
        bool good = true;

        for (int i = j; i < n - 1; ++i)
        {
            lq[i + 1] = max(lq[i], l[i]);
            rq[i + 1] = min(rq[i] + t[i], r[i]);

            if (lq[i + 1] > rq[i + 1])
                good = false;
        }

        if (!good)
        {
            printf("-1\n");
            continue;
        }

        for (int i = j - 1; i >= 0; --i)
        {
            lq[i] = max(lq[i + 1], l[i]);
            rq[i] = min(rq[i + 1] + t[i + 1], r[i]);

            if (lq[i] > rq[i])
                good = false;
        }

        if (!good)
        {
            printf("-1\n");
            continue;
        }

        llong L, R;
        L = lq[0];

        for (int i = 1; i <= j; ++i)
            L = max(L - t[i], lq[i]);

        //cout << "L = " << L << endl;

        llong ans = L;
        L = lq[n - 1];

        for (int i = n - 2; i >= j; --i)
            L = max(L - t[i], lq[i]);

        //cout << "L = " << L << endl;
        printf("%lld\n", max(0ll, max(ans, L)));
    }
}

void solve()
{
    if (n <= 500 && *max_element(t, t + n) <= 500 && *max_element(r, r + n) <= 500)
    {
        naive();
        return ;
    }

    if (n <= 5000 && *max_element(t, t + n) == *min_element(t, t + n) && t[0] == 5000)
    {
        solve_t();
        return ;
    }

    for (int i = 0; i < n; ++i)
    {
        int l = 0, r = 5000;

        for (; l < r; )
        {
            int m = (l + r) / 2;

            if (go_l(i, m))
                r = m;
            else
                l = m + 1;
        }

        int L1 = l;
        l = 0, r = 5000;

        for (; l < r; )
        {
            int m = (l + r) / 2;

            if (go_r(i, m))
                r = m;
            else
                l = m + 1;
        }

        int L2 = l;

        if (!go_l(i, L1) || !go_r(i, L2))
        {
            printf("-1\n");
            continue;
        }

        printf("%d\n", max(L1, L2));
    }
}

int main()
{
#ifdef SEREZHKA
    freopen("file.in", "r", stdin);
#endif // SEREZHKA

    while (read())
        solve();

    return 0;
}
