#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>

using namespace std;

typedef vector<int> ints;
typedef vector<char> chars;

int init() {
    int n;
    cin >> n;
    return n;
}

unordered_map<pair<int, int>, bool> cache;

bool ask(int l, int r) {
    auto p = {l, r};
    if (cache.find(p) == cache.end()) {
        cout << "? " << (l + 1) << ' ' << (r + 1) << endl;
        string res;
        cin >> res;
        bool cor = res == "Yes";
        cache[p] = cor;
        return cor;
    }
    return cache[p];
}

void finish(chars c) {
    cout << "! ";
    for (auto it : c) cout << it;
    cout << endl;
    exit(0);
}


int n;
chars ans;

int main() {
    n = init();
    ans = chars(n, '_');
    int cnt = 0;

    cache[{0, n - 1}] = true;

    for (int l = 0; l < n - 1; ++l) {
        bool cor = ask(l, l + 1);
        if (cor) {
            ans[l] = '(';
            ans[l + 1] = ')';
            cnt++;
            l++;
        }
    }

    while (cnt < n / 2) {
        for (int l = 1; l < n - 2; ++l) {
            if (ans[l] == '(' && ans[l - 1] == '_') {
                for (int r = l + 1; r < n; ++r) {
                    if (ans[r] == ')' && ans[r + 1] == '_') {
                        bool cor = ask(l - 1, r + 1);
                        if (cor) {
                            ans[l - 1] = '(';
                            ans[r + 1] = ')';
                            cnt++;
                        }

                        break;
                    }
                }
            }
        }
    }

    finish(ans);
}