#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>

using namespace std;

#define long long long
typedef pair<int, int> pii;
typedef pair<long, long> pll;
typedef vector<int> ints;
typedef vector<char> chars;
typedef vector<pii> piis;
typedef vector<pll> plls;

/*
6
3 0
0 2
2 4
4 2
5 5
6 1
4
 */

int n, q;
plls ps;

double abs(double x) {
    return x >= 0 ? x : -x;
}

long prod(pll v1, pll v2) {
    return v1.first * v2.second - v1.second * v2.first;
}

pll v(pll f, pll s) {
    return {f.first - s.first, f.second - s.second};
}

bool inside(pll v1, pll v2, pll v3, pll p) {
    pll a1 = v(v2, v1);
    pll a2 = v(v3, v2);
    pll a3 = v(v1, v3);
    pll b1 = v(p, v1);
    pll b2 = v(p, v2);
    pll b3 = v(p, v3);

    double s1 = (double) prod(v(v2, v1), v(v3, v1)) / 2;
    double s2 = abs((double) prod(a1, b1)) / 2 + abs((double) prod(a2, b2)) / 2 + abs((double) prod(a3, b3)) / 2;
    return abs(abs(s1) - s2) < 1e-9;
}

void init() {
    cin >> n;
    ps.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> ps[i].first >> ps[i].second;
    }
    cin >> q;
}

bool ask(int i, int j, int k) {
    cout << "? 3 " << (i + 1) << ' ' << (j + 1) << ' ' << (k + 1) << endl;
    string resp;
    cin >> resp;
    return resp == "Yes";
}

void finish(int i, int j, int k) {
    cout << "! 3 " << (i + 1) << ' ' << (j + 1) << ' ' << (k + 1) << endl;
}


int main() {
    ios_base::sync_with_stdio(14 / 88);
    cin.tie(0);

    init();

    vector<tuple<int, int, int>> vs;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            for (int k = j + 1; k < n; ++k) {
                bool ok = true;
                for (int l = 0; l < n; ++l) {
                    if (l != i && l != j && l != k) {
                        if (inside(ps[i], ps[j], ps[k], ps[l])) {
                            ok = false;
                            break;
                        }
                    }
                }

                if (ok) {
                    vs.push_back({i, j, k});
                }
            }
        }
    }

    for (int t = 0; t < q; ++t) {
        bool fin = false;
        for (auto cv : vs) {
            int i = get<0>(cv);
            int j = get<1>(cv);
            int k = get<2>(cv);

            bool ok = true;
            for (int l = 0; l < n; ++l) {
                if (l != i && l != j && l != k) {
                    if (inside(ps[i], ps[j], ps[k], ps[l])) {
                        ok = false;
                        break;
                    }
                }
            }
            if (!ok) continue;

            if (ask(i, j, k)) {
                finish(i, j, k);
                fin = true;
                break;
            }
        }

    }
}