#include <bits/stdc++.h>
using namespace std;
typedef long long int ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

int n;
vector<pll> vec;

struct pt {
    ll first;
    ll second;
    int index;

    pt (ll first, ll second) {
        this->first = first;
        this->second = second;
    }

    pt (ll first, ll second, int index) {
        this->first = first;
        this->second = second;
        this->index = index;
    }
};

bool cw(pt a, pt b, pt c) {
    ll ank = a.first * (b.second - c.second) +
             b.first * (c.second - a.second) +
             c.first * (a.second - b.second);
    return ank < 0;
}

bool ccw(pt a, pt b, pt c) {
    ll ank = a.first * (b.second - c.second) +
             b.first * (c.second - a.second) +
             c.first * (a.second - b.second);
    return ank > 0;
}

vector<pt> convex_hull(vector<pt> vec) {
    int n = vec.size();
    if (n <= 3)
        return vec;
    sort(vec.begin(), vec.end());

    vector<pt> a;
    vector<pt> b;

    a.push_back(vec[0]);

    b.push_back(vec[0]);

    for (int i = 1; i < n - 1; i++) {
        if (cw(vec[0], vec[i], vec[n - 1])) {
            while (a.size() > 3 && !cw(a[a.size() - 2], a[a.size() - 1], vec[i]))
                a.erase(a.begin() + a.size() - 1);
            a.push_back(vec[i]);
        } else {
            while (b.size() > 3 && !ccw(b[b.size() - 2], b[b.size() - 1], vec[i]))
                b.erase(b.begin() + b.size() - 1);
            b.push_back(vec[i]);
        }
    }

    vector<pt> ret;
    for (int i = 0; i < a.size(); i++)
        ret.push_back(a[i]);
    ret.push_back(vec[n - 1]);
    for (int i = b.size() - 1; i >= 1; i--)
        ret.push_back(b[i]);

    return ret;
}

ll sqr(int a, int b, int c) {
    ll ank = vec[a].first * (vec[b].second - vec[c].second) +
             vec[b].first * (vec[c].second - vec[a].second) +
             vec[c].first * (vec[a].second - vec[b].second);
    return abs(ank);
}

bool correct(pt a, pt b, pt c) {
    ll sq = sqr(a.index, b.index, c.index);
    for (int i = 0; i < n; i++) {
        if (i == a.index || i == b.index || i == c.index)
            continue;

        ll tmp = sq;

        tmp -= sqr(a.index, b.index, i);
        if (tmp < 0)
            continue;

        tmp -= sqr(a.index, i, c.index);
        if (tmp < 0)
            continue;

        tmp -= sqr(i, b.index, c.index);
        if (tmp < 0)
            continue;

        if (tmp == 0)
            return false;
    }

    return true;
}

bool can(pt a, pt b, pt c) {
    cout << "? 3 " << a.index + 1 << " " << b.index + 1 << " " << c.index + 1 << endl;
    string s;
    cin >> s;
    return s == "Yes";
}

bool can(vector<pt> vec) {
    cout << "? " << vec.size() << " ";
    for (auto it : vec)
        cout << it.index + 1 << " ";
    cout << endl;
    cin >> s;
    return s == "Yes";
}

void ans(pt a, pt b, pt c) {
    cout << "! 3 " << a.index + 1 << " " << b.index + 1 << " " << c.index + 1 << endl;
}

int main() {
    cin >> n;
    vec.resize(n);
    vector<pt> vecc;
    for (int i = 0; i < n; i++) {
        cin >> vec[i].first >> vec[i].second;
        vecc.push_back(pt(vec[i].first, vec[i].second, i));
    }
    int q; cin >> q;

    for (int i = 0; i < q; i++) {
        if (!can(convex_hull(vecc)))
            throw 0;
        bool cc = false;
        for (int a = 0; a < n && !cc; a++) {
            for (int b = a + 1; b < n && !cc; b++) {
                for (int c = b + 1; c < n && !cc; c++) {
                    if (!correct(a, b, c))
                        continue;
                    if (can(a, b, c)) {
                        ans(a, b, c);
                        cc = true;
                    }
                }
            }
        }
    }
}