#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
typedef long long int ll;
typedef pair<int, int> pii;

template <typename T> using ordered_set = tree<T, null_type, less<T>,
        rb_tree_tag, tree_order_statistics_node_update>;

int n;

int g_left(ordered_set<pii> & st, string & s, int v) {
    if (v == 0)
        return 0;
    int order = st.order_of_key({v, -1});
    pii res = (*st.find_by_order(order - 1));
    return res.second - res.first + 1;
}

int g_right(ordered_set<pii> & st, string & s, int v) {
    if (v == s.size() - 1)
        return 0;
    int order = st.order_of_key({v, INT_MAX});
    pii res = (*st.find_by_order(order));
    return res.second - res.first + 1;
}

void color(ordered_set<pii> & st, string & s, int a, int b) {
    if (a != 0 && b != s.size() - 1) {
        int order = st.order_of_key({a, -1});
        pii res_a = (*st.find_by_order(order - 1));
        order = st.order_of_key({b, INT_MAX});
        pii res_b = (*st.find_by_order(order));

        st.erase({a, b});
        st.erase(res_a);
        st.erase(res_b);
        st.insert({res_a.first, res_b.second});
    } else if (b != s.size() - 1) {
        int order = st.order_of_key({b, INT_MAX});
        pii res_b = (*st.find_by_order(order));

        st.erase({0, b});
        st.erase(res_b);
        st.insert({0, res_b.second});
    } else {
        int order = st.order_of_key({a, -1});
        pii res_a = (*st.find_by_order(order - 1));

        st.erase({a, s.size() - 1});
        st.erase(res_a);
        st.insert({res_a.first, s.size() - 1});
    }
}

bool can_simple(string a, string b) {
    if (b[0] == '-') {
        for (auto & it : a) {
            if (it == '+')
                it = '-';
            else
                it = '+';
        }
    }

    int n = a.size();

    ordered_set<pii> not_cools;
    ordered_set<pii> cools;

    int cur = 0;
    for (int i = 0; i < n; i++) {
        if (a[i] != '-') {
            if (cur < i)
                not_cools.insert({cur, i - 1});
            cur = i + 1;
        }
    }
    if (cur < n)
        not_cools.insert({cur, n - 1});

    cur = 0;
    for (int i = 0; i < n; i++) {
        if (a[i] != '+') {
            if (cur < i)
                cools.insert({cur, i - 1});
            cur = i + 1;
        }
    }
    if (cur < n)
        cools.insert({cur, n - 1});

    for (int i = 0; i < not_cools.size(); ) {
        pii kz = *not_cools.find_by_order(i);
        int aa = g_left(cools, a, kz.first);
        int bb = g_right(cools, b, kz.second);
        if (max(aa, bb) > kz.second - kz.first + 1) {
            color(cools, a, kz.first, kz.second);
            not_cools.erase(kz);
            i--; i = max(0, i);
        } else {
            i++;
        }
    }

    return not_cools.size() == 0;
}

bool is_correct(string & a, string & b) {
    int len = (int) a.size();

    vector<pii> res_b;
    char ch = b[0];
    int cur = 0;
    for (int i = 0; i < len; i++) {
        if (b[i] != ch) {
            res_b.push_back({cur, i - 1});
            cur = i;
            ch = b[i];
        }
    }
    res_b.push_back({cur, len - 1});

    vector<pii> res_a;
    ch = a[0];
    cur = 0;
    for (int i = 0; i < len; i++) {
        if (a[i] != ch) {
            res_a.push_back({cur, i - 1});
            cur = i;
            ch = a[i];
        }
    }
    res_a.push_back({cur, len - 1});


    vector<string> vec_str_a;
    vector<string> vec_str_b;
    int ptr = 0;
    for (int i = 0; i < res_b.size(); i++) {
        pii pb = res_b[i];
        vector<pii> as;
        while (ptr < res_a.size()) {
            pii p = res_a[ptr];
            if (p.first <= pb.second && p.second > pb.second)
                return false;
            if (p.first > pb.second)
                break;
            ptr++;
            as.push_back(p);
        }

        string tmp_a, tmp_b;
        for (int z = pb.first; z <= pb.second; z++)
            tmp_a += a[z];
        for (int z = pb.first; z <= pb.second; z++)
            tmp_b += b[z];

        if (!can_simple(tmp_a, tmp_b))
            return false;

        vec_str_a.push_back(tmp_a);
        vec_str_b.push_back(tmp_b);
    }

    for (int i = 1; i < vec_str_a.size(); i++) {
        char res = vec_str_b[i][0];
        char diff = (res == '-' ? '+' : '-');
        if (vec_str_a[i][0] == diff && vec_str_a[i - 1][vec_str_a[i - 1].size() - 1] == res)
            return false;
    }

    return true;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    for (int i = 0; i < n; i++) {
        string a, b;
        cin >> a >> b;

        if (is_correct(a, b))
            cout << "Yes" << endl;
        else
            cout << "No" << endl;
    }
}

/*
 1
 ----+++++
 ++++-----

 1
 ++-+--+-+-++
 ++++----++++

 3
 ++- +++
 ++-- ++++
 ++-+--+- ++++++++

 1
 ++-+--+- ++++++++

 3
 ++-+-- ++----
 ++-+-- +++---
 -++- -++-
 */