import java.io.*;
import java.util.*;

public class Main {
    FastScanner in;
    PrintWriter out;

    int query(int v) {
        out.println(v);
        return in.nextInt();
    }

    void solve() {
        int n = in.nextInt();
        int step = 1 << 29;
        int cur = 0;
        while (step != 0) {
            cur += step;
            if (cur > n) {
                cur -= n;
                step >>= 1;
                continue;
            }
            int val = query(cur);
            if (val == -1)
                cur -= step;
            if (val == 0)
                break;
            step >>= 1;
        }
    }

    void run() {
        in = new FastScanner();
        out = new PrintWriter(System.out);

        solve();

        out.close();
    }

    public static void main(String[] args) {
        (new Main()).run();
    }

    class FastScanner {
        StringTokenizer st;
        BufferedReader br;

        FastScanner() {
            br = new BufferedReader(new InputStreamReader(System.in));
        }

        String next() {
            while (st == null || !st.hasMoreElements())
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }

        long nextLong() {
            return Long.parseLong(next());
        }

        double nextDouble() {
            return Double.parseDouble(next());
        }
    }
}
