#include <iostream>
#include <string>
#include <vector>
#include <bitset>
#include <random>
#include <algorithm>
using namespace std;

const int maxN = 1000 + 100;
const long long LINF = 1e18;

mt19937_64 gen;

long long random(long long l, long long r)
{
	uniform_int_distribution<long long> dist(l, r);
	return dist(gen);
}

vector<pair<int, long long> > e[maxN];
bool used[maxN];
pair<long long, long long> d[maxN];


int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios::sync_with_stdio(false);
	cin.tie(0);
	int n, m;
	cin >> n >> m;

	for (int i = 0; i < m; i++)
	{
		vector<int> t, v;
		int s;
		cin >> s;
		for (int i = 0; i < s; i++)
		{
			int x, y;
			cin >> x >> y;
			v.push_back(x - 1);
			t.push_back(y);
		}
		int x;
		cin >> x;
		x--;
		v.push_back(x);
		for (int j = 0; j < v.size(); j++)
		{
			long long d = 0;
			for (int k = j + 1; k < v.size(); k++)
			{
				d += t[k - 1];
				e[v[j]].push_back(make_pair(v[k], d));
			}
		}
	}
	for (int i = 0; i < n; i++)
	{
		d[i] = make_pair(LINF, LINF);
	}
	d[0] = make_pair(0, 0);
	for (int i = 0; i < n; i++)
	{
		int v = -1;
		for (int j = 0; j < n; j++)
		{
			if (!used[j] && (v == -1 || d[j] < d[v]))
				v = j;
		}

		used[v] = true;
		for (auto ed : e[v])
		{
			int u = ed.first;
			long long c = ed.second;
			if (!used[u] && d[u] > make_pair(d[v].first + c, d[v].second - c * c))
			{
				d[u] = make_pair(d[v].first + c, d[v].second - c * c);
			}
		}
	}

	cout << d[n - 1].first << " " << -d[n - 1].second;

    return 0;
}

