#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
using namespace std;

const int maxN = 2e5 + 100;
const int maxM = 5000 + 100;
const long long LINF = 1e16;

long long t[maxN];
long long l[maxN], r[maxN];
pair<long long, long long> pref[maxN], suff[maxN];

vector<long long> slow(int n)
{
	vector<long long> res(n, -1);
	for (int i = 0; i < n; i++)
	{
		for (int x = 0; x < maxM; x++)
		{
			bool flag = true;
			long long tm = x;
			for (int j = i; j > 0; j--)
			{
				if (tm >= l[j - 1] && tm <= r[j - 1])
				{
					continue;
				}
				else if (tm > r[j - 1])
				{
					flag = false;
					break;
				}
				else if (l[j - 1] - tm <= t[j])
				{
					tm = l[j - 1];
				}
				else
				{
					flag = false;
					break;
				}
			}
			if (!flag)
				continue;
			tm = x;
			for (int j = i; j < n - 1; j++)
			{
				if (tm >= l[j] && tm <= r[j])
				{
					continue;
				}
				else if (tm > r[j])
				{
					flag = false;
					break;
				}
				else if (l[j] - tm <= t[j])
				{
					tm = l[j];
				}
				else
				{
					flag = false;
					break;
				}
			}
			if (flag)
			{
				res[i] = x;
				break;
			}
		}
	}
	return res;
}

vector<long long> solution(int n)
{
	vector<long long> res(n, -1);
	pref[0] = make_pair(0LL, LINF);
	suff[n - 1] = make_pair(0LL, LINF);

	for (int i = 1; i < n; i++)
	{
		pair<long long, long long> curr = make_pair(max(pref[i - 1].first, l[i - 1]), min(pref[i - 1].second, r[i - 1]));
		if (curr.second < curr.first)
		{
			pref[i] = make_pair(LINF, -LINF);
		}
		else
		{
			curr = make_pair(max(pref[i - 1].first, l[i - 1] - t[i]), min(pref[i - 1].second, r[i - 1]));
			pref[i] = curr;
		}
	}

	for (int i = n - 2; i >= 0; i--)
	{
		pair<long long, long long> curr = make_pair(max(suff[i + 1].first, l[i]), min(suff[i + 1].second, r[i]));
		if (curr.second < curr.first)
		{
			suff[i] = make_pair(LINF, -LINF);
		}
		else
		{
			curr = make_pair(max(suff[i + 1].first, l[i] - t[i]), min(suff[i + 1].second, r[i]));
			suff[i] = curr;
		}
	}

	for (int i = 0; i < n; i++)
	{
		pair<long long, long long> curr = make_pair(max(pref[i].first, suff[i].first), min(pref[i].second, suff[i].second));
		if (curr.second < curr.first)
		{
			res[i] = -1;
		}
		else
		{
			if (curr.second >= 0)
				res[i] = max(0LL, curr.first);
			else
				res[i] = -1;
		}
	}
	return res;
}


int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n;
	cin >> n;
	for (int i = 0; i < n; i++)
	{
		cin >> t[i];
	}
	for (int i = 0; i < n - 1; i++)
	{
		cin >> l[i] >> r[i];
	}

	vector<long long> ans;
	if (n <= 500)
	{
		ans = slow(n);
	}
	else
	{
		ans = solution(n);
	}

	for (auto x : ans)
	{
		cout << x << '\n';
	}

	

	return 0;
}