#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
using namespace std;

const int maxN = 2e4 + 100;
const int maxA = 1000 + 100;
const long long LINF = 1e18;

int a[maxN], b[maxN];
long long x[maxN], y[maxN];
int posa[maxN], posb[maxN];
bool used[maxN];

int parent[maxN];
int rnk[maxN];
long long sum[maxN];
int l[maxN], r[maxN];

long long mx = 0;
int ml = 0, mr = 0;

void refresh(int n)
{
	mx = 0;
	ml = 0;
	mr = 0;
	for (int i = 0; i < n; i++)
	{
		used[i] = false;
		parent[i] = i;
		rnk[i] = 0;
		sum[i] = y[i];
		l[i] = i + 1;
		r[i] = i + 1;
	}
}

int get_parent(int v)
{
	return v == parent[v] ? v : parent[v] = get_parent(parent[v]);
}

void join(int a, int b)
{
	a = get_parent(a);
	b = get_parent(b);
	if (a == b)
		return;
	if (rnk[a] < rnk[b])
		swap(a, b);
	parent[b] = a;
	sum[a] += sum[b];
	l[a] = min(l[a], l[b]);
	r[a] = max(r[a], r[b]);
	if (mx < sum[a])
	{
		mx = sum[a];
		ml = l[a];
		mr = r[a];
	}
	if (rnk[a] == rnk[b])
		rnk[a]++;
}


int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	for (int i = 0; i < maxN; i++)
	{
		posb[i] = -1;
		posa[i] = -1;
	}
	int n, m;

	cin >> n >> m;

	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
		posa[a[i]] = i;
	}
	for (int i = 0; i < n; i++)
	{
		cin >> x[i];
	}
	for (int i = 0; i < m; i++)
	{
		cin >> b[i];
		posb[b[i]] = i;
	}
	for (int j = 0; j < m; j++)
	{
		cin >> y[j];
	}

	long long ans = 0;
	int al = 0, ar = 0, bl = 0, br = 0;

	for (int i = 0; i < n; i++)
	{
		refresh(m);
		long long currsum = 0;
		for (int j = i; j < n; j++)
		{
			int pos = posb[a[j]];
			if (pos != -1)
			{
				used[posb[a[j]]] = true;
			}
			currsum += x[j];
		}
		for (int j = 0; j < m; j++)
		{
			if (j != 0 && !used[j] && !used[j - 1])
			{
				join(j - 1, j);
			}
			if (!used[j])
			{
				if (mx < y[j])
				{
					mx = y[j];
					ml = j + 1;
					mr = j + 1;
				}
			}
		}

		if (mx + currsum > ans)
		{
			ans = mx + currsum;
			al = i + 1, ar = n;
			bl = ml, br = mr;
		}

		for (int j = n - 1; j >= i; j--)
		{
			int pos = posb[a[j]];
			if (pos != -1)
			{
				used[pos] = false;
				if (pos != 0)
				{
					if (!used[pos - 1])
						join(pos, pos - 1);
				}
				if (pos != m - 1)
				{
					if (!used[pos + 1])
						join(pos, pos + 1);
				}
				if (mx < y[pos])
				{
					mx = y[pos];
					ml = pos + 1;
					mr = pos + 1;
				}
			}
			currsum -= x[j];
			if (mx + currsum > ans)
			{
				ans = mx + currsum;
				al = i + 1, ar = j;
				bl = ml, br = mr;
			}
		}
	}

	cout << ans << "\n";
	cout << al << " " << ar << "\n" << bl << " " << br << "\n";

	return 0;
}