#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>

using namespace std;

int q;
string s, t;

inline void push(int l, int r, set <pair <int, int> > &ms)
{
    int last = l;

    for (int i = l; i <= r; i++)
    {
        if (i == r && s[i] == t[i])
        {
            ms.insert({last, i});
        }
        else
        {
            if (i > l)
            {
                if (s[i - 1] != s[i])
                {
                    if (s[i] == t[l])
                        last = i;
                    else
                        ms.insert({last, i - 1});
                }
            }
        }
    }
}

inline void make(int l, int r, set <pair <int, int> > &ms)
{
    while (l <= r)
    {
        bool check = true;
        auto it = ms.lower_bound({l, -1e9});

        if (it == ms.end())
            break;

        auto p = *it;
        while (check)
        {
            check = false;
            int pl = p.first, pr = p.second;
            it = ms.find(p);

            if (it != ms.begin())
            {
                it--;

                auto p2 = *it;
                int p2l = p2.first, p2r = p2.second;

                if (pr - pl + 1 > pl - p2r - 1)
                {
                    check = true;
                    ms.erase({pl, pr});
                    ms.erase({p2l, p2r});

                    p.first = p2l;
                    ms.insert(p);
                }
            }

            pl = p.first, pr = p.second;
            it = ms.find(p);
            it++;
            if (it != ms.end())
            {
                auto p2 = *it;
                int p2l = p2.first, p2r = p2.second;

                if (pr - pl + 1 > p2l - pr - 1)
                {
                    check = true;
                    ms.erase({pl, pr});
                    ms.erase({p2l, p2r});

                    p.second = p2r;
                    ms.insert(p);
                }
            }
        }

        l = p.first + 1;
    }
}

int main()
{
    ios_base::sync_with_stdio(false), cin.tie(nullptr);

    cin >> q;
    while (q--)
    {
        cin >> s >> t;

        int n = s.size();
        bool check = true;
        for (int i = 1; i < n; i++)
        {
            if (t[i] != t[i - 1] && s[i] == s[i - 1])
                check = false;
            if (t[i] != t[i - 1] && s[i] != s[i - 1] && t[i] != s[i])
                check = false;
        }


        if (!check)
        {
            cout << "No\n";
            continue;
        }

        int it = 0, it2;
        for (int i = 1; i <= n && check; i++)
        {
            if (i == n || t[i] != t[i - 1])
            {
                it2 = i - 1;

                set <pair <int, int> > ms;
                push(it, it2, ms);

                if (s[it] != t[it])
                    ms.insert({it, it - 1});
                if (s[it2] != t[it2])
                    ms.insert({it2 + 1, it2});

                //for (auto a : ms)
                //    cout << a.first << ' ' << a.second << endl;

                make(it, it2, ms);

                if (ms.size() != 1)
                    check = false;

                it = it2 + 1;
            }
        }

        if (!check)
        {
            cout << "No\n";
            continue;
        }

        cout << "Yes\n";
    }
    return 0;
}

/*

1
+-+-+-+-+- ++++++++++

3
++- +++
++-- ++++
++-+--+- ++++++++

3
++-+-- ++----
++-+-- +++---
-++- -++-

*/
