#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef double ld;

struct Node
{
    int x;
    int priority;
    Node *left;
    Node *right;
    bool pl;
    int num;
    Node(int x, int num, bool pl):
        x(x),
        priority((rand() << 15) + rand()),
        left(0),
        right(0),
        num(num),
        pl(pl) {}
};

pair<Node*, Node*> split(Node *v, int x)
{
    if (!v)
        return {v, v};
    if (v->x <= x)
    {
        auto a = split(v->right, x);
        v->right = a.first;
        return {v, a.second};
    }
    auto a = split(v->left, x);
    v->left = a.second;
    return {a.first, v};
}

Node* merge(Node *l, Node *r)
{
    if (!l)
        return r;
    if (!r)
        return l;
    if (l->priority < r->priority)
    {
        l = merge(l, r->left);
        r->left = l;
        return r;
    }
    r = merge(l->right, r);
    l->right = r;
    return l;
}

int go_left(Node *v)
{
    if (v->left)
        return go_left(v->left);
    return v->num;
}

int go_right(Node *v)
{
    if (v->right)
        return go_right(v->right);
    return v->num;
}

int go_left1(Node *v)
{
    if (v->left)
        return go_left(v->left);
    return v->x;
}

int go_right1(Node *v)
{
    if (v->right)
        return go_right(v->right);
    return v->x;
}

vector<int> used;

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int qq;
    cin >> qq;
    for (int ui = 0; ui < qq; ui++)
    {
        string s, t;
        cin >> s >> t;
        int n = s.size();
        used.assign(n, 0);
        Node *root = 0;
        for (int i = 0; i < s.size(); i++)
        {
            int j = 0;
            while (j < n && s[j] == s[i])
                j++;
            bool pl = true;
            if (s[i] == '-')
                pl = false;
            else
                used[i] = 1;
            root = merge(root, new Node(i, j - i, pl));
        }
        queue<int> q;
        for (int i = 0; i < n; i++)
        {
            if (used[i])
                continue;
            auto a = split(root, i);
            auto b = split(a.first, i - 1);
            bool ok = false;
            if (b.first && go_right(b.first) > b.second->num)
                ok = true;
            if (a.second && go_left(a.second) > b.second->num)
                ok = true;
            if (ok)
            {
                q.push(i);
                used[i] = 1;
            }
            root = merge(b.first, merge(b.second, a.second));
        }
        while (!q.empty())
        {
            int i = q.front();
            q.pop();
            auto a = split(root, i);
            auto b = split(a.first, i - 1);
            int t = b.second->num;
            int X = b.second->x;
            if (b.first)
            {
                int tau = go_right(b.first);
                t += tau;
                int x = go_right1(b.first);
                auto c = split(b.first, x - 1);
                if (a.second)
                {
                    int tau = go_left(a.second);
                    t += tau;
                    int x = go_left1(a.second);
                    auto d = split(a.second, x);
                    root = merge(c.first, merge(new Node(X, t, true), d.second));
                }
                else
                    root = merge(b.first, new Node(X, t, true));
            }
            else
            {
                int tau = go_left(a.second);
                t += tau;
                int x = go_left1(a.second);
                auto d = split(a.second, x);
                root = merge(new Node(X, t, true), d.second);
            }
            a = split(root, X);
            b = split(a.first, X - 1);
            if (b.first)
            {
                if (!used[go_right1(b.first)] && go_right(b.first) < t)
                    q.push(go_right1(b.first)), used[go_right1(b.first)] = 1;
            }
            if (a.second)
            {
                if (!used[go_left1(a.second)] && go_left(a.second) < t)
                    q.push(go_left1(a.second)), used[go_left1(a.second)] = 1;
            }
        }
        //cout << s << " ";
        cout << ((root->left || root->right) ? "No" : "Yes") << endl;
    }
    return 0;
}
/*
3
++- +++
++-- ++++
++-+--+- ++++++++
*/
