#define make_pair mp
#define push_back pb
#define pop_back pob
#define first X
#define second Y
#define _p(x, y) pair<x, y>

#include <iostream>
#include <vector>
#include <string>
#include <stdio.h>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <iterator>
#include <queue>
#include <climits>

using namespace std;

typedef long long i64;
const int INF = 1000000007;
const i64 LINF = 1000000000000000007;
#define endl '\n'

struct dsu {
	
	vector < int > data, size, left, right;
	vector < char > rig;

	explicit dsu(int n) {
		data.resize(n);
		size.resize(n, 1);
		rig.resize(n, false);
		left.resize(n);
		right.resize(n);
		for (int i = 0; i < n; i++) {
			data[i] = i;
			left[i] = right[i] = i;
		}
	}

	int get(int a) {
		if (data[a] == a)
			return a;
		return data[a] = get(data[a]);
	}

	void unite(int a, int b) {
		a = get(a);
		b = get(b);
		if (a == b)
			return;

		if (size[a] > size[b]) {
			data[b] = a;
			size[a] += size[b];
			rig[a] |= rig[b];
			right[a] = max(right[a], right[b]);
			left[a] = min(left[a], left[b]);
		}
		else {
			data[a] = b;
			size[b] += size[a];
			rig[b] |= rig[a];
			right[b] = max(right[a], right[b]);
			left[b] = min(left[a], left[b]);
		}
	}

	int gr(int a) {
		a = get(a);
		return rig[a];
	}

	_p(int, int) glr(int a) {
		a = get(a);
		return mp(left[a], right[a]);
	}

	int gs(int a) {
		a = get(a);
		return size[a];
	}

	void reass(int a, int &l, int &r) {
		a = get(a);
		l = left[a];
		r = right[a];
	}
};

void quest(int l, int r) {
	cout << "? " << l + 1 << " " << r + 1 << endl;
	fflush(stdout);
}

int main() {
	
#ifdef _DEBUG
	//freopen("A.txt", "r", stdin);
#endif

	int n;
	cin >> n;

	vector < char > seq(n, '#');
	int left = n;
	string buff;
	vector < int > last_id(n, -1);

	dsu desu(n);

	int l = 0 , r = 1;
	while (r < n) {
		
		quest(l, r);
		cin >> buff;

		while (buff == "Yes") {
			seq[l] = '(';
			seq[r] = ')';
			desu.unite(l, l + 1);
			desu.unite(r, r - 1);
			desu.reass(l + 1, l, r);
			l--; r++;
			if (l < 0 || r > n - 1)
				break;
			quest(l, r);
			cin >> buff;
		}

		l = r;
		r = l + 1;
	}

	cout << "! ";
	for (char c : seq) {
		cout << c;
	}
	cout << endl;
	return 0;
}