#define first X
#define second Y
#define push_back pb
#define pop_back pob
#define make_pair mp
#define _p(x, y) pair<x, y>

#include <iostream>
#include <set>
#include <map>
#include <stdio.h>
#include <string>
#include <vector>
#include <queue>
#include <algorithm>
#include <cmath>
#include <iterator>
#include <climits>

using namespace std;

typedef long long i64;
#define endl '\n'

const int INF = 1000000007;
const i64 LINF = 1000000000000000007;

struct dsu {

	vector < int > data, sz;

	explicit dsu(int n) {
		data.resize(n);
		sz.resize(n, 1);
		for (int i = 0; i < n; i++) {
			data[i] = i;
		}
	}

	int get(int a) {
		if (data[a] == a) {
			return a;
		}

		return data[a] = get(data[a]);
	}

	int unite(int a, int b) {

		if (a == -1)
			return b;
		if (b == -1)
			return a;

		a = get(a);
		b = get(b);

		if (a == b)
			return a;

		if (sz[a] > sz[b]) {
			data[b] = a;
			sz[a] += sz[b];
			return a;
		}
		else {
			data[a] = b;
			sz[b] += sz[a];
			return b;
		}

		return -1;
	}

};

struct seg {

	int l, r;
	int size;
	char c;
	bool ch;

	explicit seg(int tc, bool tch) {
		size = 0;
		ch = tch;
		c = tc;
	}

};

void solve() {
	
	string s1, s2;
	cin >> s1 >> s2;

	if (s1 == s2) {
		cout << "Yes" << endl;
		return;
	}

	vector < seg > sg;
	bool bad = false;
	for (int i = 0; i < s1.size() && !bad; i++) {
		if (!i || s1[i] != s1[i - 1]) {
			sg.pb(seg(s1[i], s1[i] != s2[i]));
		}

		if ((s1[i] == s2[i] && sg.back().ch) || (s1[i] != s2[i] && !sg.back().ch)) {
			bad = true;
		}
		sg[sg.size() - 1].size++;
	}

	queue < int > q;
	for (int i = 0; i < sg.size() && !bad; i++) {
		sg[i].l = i - 1;
		sg[i].r = i + 1;
		if (i == sg.size() - 1) {
			sg[i].r = -1;
		}
		if (i && sg[i].ch && sg[i - 1].ch) {
			bad = true;
		}

		if (!sg[i].ch) {
			q.push(i);
		}
	}

	dsu desu(sg.size());

	int cur, nid, pid;
	int nl, nr, ns, nc;
	bool changed;
	while (q.size() && !bad) {
		changed = false;
		cur = q.front();
		q.pop();

		if (sg[cur].l != -1) {
			nid = sg[cur].l;
			if (sg[nid].ch && sg[nid].size < sg[cur].size) {
				
				nr = sg[cur].r;
				nl = sg[nid].l;
				ns = sg[cur].size + sg[nid].size;
				if (nl != -1) {
					ns += sg[nl].size;
					nl = sg[nl].l;
				}

				nc = sg[cur].c;
				cur = desu.unite(sg[nid].l, desu.unite(nid, cur));
				sg[cur].ch = false;
				sg[cur].c = nc;
				sg[cur].r = nr;
				sg[cur].l = nl;
				sg[cur].size = ns;

				if ((nl != -1 && sg[nl].c == sg[cur].c) || (nr != -1 && sg[nr].c == sg[cur].c)) {
					bad = true;
					continue;
				}

				changed = true;
			}
		}

		if (sg[cur].r != -1) {
			nid = sg[cur].r;
			if (sg[nid].ch && sg[nid].size < sg[cur].size) {

				nl = sg[cur].l;
				nr = sg[nid].r;
				ns = sg[cur].size + sg[nid].size;
				if (nr != -1) {
					ns += sg[nr].size;
					nr = sg[nr].r;
				}

				nc = sg[cur].c;
				cur = desu.unite(sg[nid].r, desu.unite(nid, cur));
				sg[cur].ch = false;
				sg[cur].c = nc;
				sg[cur].r = nr;
				sg[cur].l = nl;
				sg[cur].size = ns;

				if ((nl != -1 && sg[nl].c == sg[cur].c) || (nr != -1 && sg[nr].c == sg[cur].c)) {
					bad = true;
					continue;
				}

				changed = true;
			}
		}

		if (changed) {
			q.push(cur);
		}
	}

	string cock = "";
	for (int i = 0; i < sg.size() && !bad; i++) {
		pid = desu.get(i);
		if (sg[pid].ch)
			bad = true;
		if (i == pid) {
			for (int j = 0; j < sg[pid].size; j++) {
				cock += sg[pid].c;
			}
		}
	}


	if (bad) {
		cout << "No" << endl;
	}
	else {
		cout << "Yes" << endl;
	}
}

int main() {

#ifdef _DEBUG
	freopen("A.txt", "r", stdin);
#endif

	ios::sync_with_stdio(NULL);
	cin.tie(0);
	cout.tie(0);

	int n;
	cin >> n;
	
	for (int tc = 0; tc < n; tc++) {
		solve();
	}

	return 0;
}