#include <bits/stdc++.h>

using namespace std;

struct kek
{
    int a, b, c;
    kek(int a_ = 0, int b_ = 0, int c_ = 0): a(a_), b(b_), c(c_) {};
    bool operator <(const kek x)const
    {
        if (a != x.a)
            return a < x.a;
        if (b != x.b)
            return b < x.b;
        if (c != x.c)
            return c < x.c;
    }
};

struct point
{
    long long x, y;
    point(long long x_ = 0, long long y_ = 0): x(x_), y(y_) {};
    long long operator *(const point a)const
    {
        return x * a.y - y * a.x;
    }
    point operator -(const point a)const
    {
        return {x - a.x, y - a.y};
    }
    long long len()
    {
        return x * x + y * y;
    }
    bool operator ==(const point a)const
    {
        return ((x == a.x) && (y == a.y));
    }
};

struct line
{
    long long a, b, c;
    line(): a(0), b(0), c(0) {};
    line(point q, point w)
    {
        a = q.y - w.y;
        b = w.x - q.x;
        c = -q.x * a - q.y * b;
    }
    long long dist(point q)
    {
        return a * q.x + b * q.y + c;
    }
};

point mas[5001], mx;
int used[5001];

bool cmp(point a, point b)
{
    if ((a - mx) * (b - mx) != 0)
        return (a - mx) * (b - mx) > 0;
    return (a - mx).len() < (b - mx).len();
}

int main()
{
    srand(228);
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    for (int i = 0; i < n; i++)
    {
        cin >> mas[i].x >> mas[i].y;
    }
    fill(used, used + n, 1);
    vector<vector<int> > kek;
    while (true)
    {
        mx = point((long long)1e9 + 1, (long long)1e9 + 1);
        vector<point> v;
        int t = -1;
        for (int i = 0; i < n; i++)
        {
            if (used[i])
            {
                v.push_back(mas[i]);
                if (mas[i].y < mx.y || (mas[i].y == mx.y && mas[i].x < mx.x))
                {
                    mx = mas[i];
                    t = v.size() - 1;
                }
            }
        }
        swap(v[0], v[t]);
        sort(v.begin() + 1, v.end(), cmp);
        vector<point> arr;
        vector<int> vv;
        for (int i = 0; i < v.size(); i++)
        {
            while (arr.size() > 1)
            {
                int t = arr.size() - 1;
                if ((arr[t] - arr[t - 1]) * (v[i] - arr[t]) <= 0)
                {
                    arr.pop_back();
                }
                else
                    break;
            }
            arr.push_back(v[i]);
        }
        for (auto a: arr)
        {
            for (int i = 0; i < n; i++)
            {
                if (mas[i] == a)
                {
                    used[i] = 0;
                    vv.push_back(i + 1);
                    break;
                }
            }
        }
        kek.push_back(vv);
    }
    int qq;
    cin >> qq;
    for (int qqq = 0; qqq < qq; qqq++)
    {
        int le = 0, ri = kek.size();
        while (ri - le > 1)
        {
            int mi = (le + ri) / 2;
            if (kek[mi].size() >= 3)
            {
                cout << "? " << kek[mi].size() << " ";
                for (int v: kek[mi])
                    cout << v << " ";
                cout << endl;
                string s;
                cin >> s;
                if (s == "Yes")
                    le = mi;
                else
                    ri = mi;
            }
            else
                ri = mi;
        }
        if (ri == kek.size())
        {
            cout << "! " << kek[le].size() << " ";
            for (int v: kek[le])
                cout << v << " ";
            cout << endl;
            continue;
        }
        vector<pair<point, int> > v1, v2;
        for (int v: kek[le])
            v1.push_back({mas[v], v});
        for (int v: kek[ri])
            v2.push_back({mas[v], v});
        v1.push_back(v1[0]);
        v2.push_back(v2[0]);
        long long ss = (long long)9e18;
        int q = 0, w = 0, e = 0;
        for (int i = 0; i + 1 < v1.size(); i++)
        {
            for (int j = 0; j + 1 < v2.size(); j++)
            {
                cout << "? 3 " << v1[i].second << " " << v1[i + 1].second << " " << v2[j].second << endl;
                string s;
                cin >> s;
                if (s == "Yes")
                {
                    long long sss = abs((v1[i].first - v2[j].first) * (v1[i + 1].first - v2[j].first));
                    if (sss < ss)
                    {
                        ss = sss;
                        q = v1[i].second;
                        w = v1[i + 1].second;
                        e = v2[j].second;
                    }
                }
                cout << "? 3 " << v1[i].second << " " << v2[j].second << " " << v2[j + 1].second << endl;
                cin >> s;
                if (s == "Yes")
                {
                    long long sss = abs((v2[j].first - v1[i].first) * (v2[j + 1].first - v1[i].first));
                    if (sss < ss)
                    {
                        ss = sss;
                        q = v1[i].second;
                        w = v2[j].second;
                        e = v2[j + 1].second;
                    }
                }
            }
        }
        cout << "! 3 " << q << " " << w << " " << e << endl;
    }
    return 0;
}
