#include <bits/stdc++.h>

using namespace std;

void toBin(int n, vector<int> &d)
{
    for (int i = 29; i >= 0; i--)
    {
        d[i] = n & 1;
        n >>= 1;
    }
}

vector< vector<int> > arr;
vector<int> ans(30);
int n;

struct Sh
{
    int sl = n, sr = -1, bl = n, br = -1;

    Sh() {}

    Sh(int v1, int v2, int v3, int v4)
    {
        sl = v1, sr = v2, bl = v3, br = v4;
    }

    Sh(int val, int pos)
    {
        if (val == 0)
            sl = sr = pos;
        else
            bl = br = pos;
    }
};

Sh Un(Sh s1, Sh s2)
{
    return Sh(min(s1.sl, s2.sl), max(s1.sr, s2.sr), min(s1.bl, s2.bl), max(s1.br, s2.br));
}

struct Tree
{
    vector<Sh> T;
    int k = 1;

    Tree(int pos)
    {
        while (k < n)
            k *= 2;

        T.resize(2 * k, Sh());

        for (int i = 0; i < n; i++)
            T[k + i] = Sh(arr[i][pos], i);

        for (int i = k - 1; i > 0; i--)
            T[i] = Un(T[2 * i], T[2 * i + 1]);
    }

    void setEl(int ind, int val)
    {
        T[ind + k] = Sh(val, ind);
        ind += k;

        while ((ind /= 2) > 0)
            T[ind] = Un(T[2 * ind], T[2 * ind + 1]);
    }

    Sh getVal(int l, int r)
    {
        return getVal(1, 0, k - 1, l, r);
    }

    Sh getVal(int v, int lv, int rv, int l, int r)
    {
        if (l <= lv && rv <= r)
            return T[v];
        if (rv < l || r < lv)
            return Sh();

        int mv = (lv + rv) / 2;

        return Un(getVal(2 * v, lv, mv, l, r), getVal(2 * v + 1, mv + 1, rv, l, r));
    }
};

vector<Tree> F;

void getAns(int pos, int l, int r)
{
    if (ans[pos] == -1)
        return;

    Sh SS = F[pos].getVal(l, r);
    int sl = SS.sl, sr = SS.sr, bl = SS.bl, br = SS.br;

    if (sr == -1 || br == -1)
    {
        if (pos + 1 < 30)
        getAns(pos + 1, l, r);

        return;
    }

    if (sr < bl)
    {
        if (ans[pos] == 1)
        {
            ans[pos] = -1;
            return;
        }

        ans[pos] = 0;

        if (pos + 1 < 30)
        {
            getAns(pos + 1, sl, sr);
            getAns(pos + 1, bl, br);
        }

        return;
    }

    if (br < sl)
    {
        if (ans[pos] == 0)
        {
            ans[pos] = -1;
            return;
        }

        ans[pos] = 1;

        if (pos + 1 < 30)
        {
            getAns(pos + 1, bl, br);
            getAns(pos + 1, sl, sr);
        }

        return;
    }

    ans[pos] = -1;
}

int getAns()
{
    fill(ans.begin(), ans.end(), -2);
    getAns(0, 0, n - 1);

    for (int i = 0; i < 30; i++)
    {
        if (ans[i] == -1)
            return -1;

        if (ans[i] == -2)
            ans[i] = 0;
    }

    int res = 0;

    for (int i = 0; i < 30; i++)
        res = res * 2 + ans[i];

    return res;
}

void show()
{
    cout << "-1: " << F[29].T[1].sl << ' ' << F[29].T[1].sr << ' ' << F[29].T[1].bl << ' ' << F[29].T[1].br << '\n';
    cout << "-2: " << F[28].T[1].sl << ' ' << F[28].T[1].sr << ' ' << F[28].T[1].bl << ' ' << F[28].T[1].br << '\n';
    cout << "-3: " << F[27].T[1].sl << ' ' << F[27].T[1].sr << ' ' << F[27].T[1].bl << ' ' << F[27].T[1].br << '\n';
    cout << "-4: " << F[26].T[1].sl << ' ' << F[26].T[1].sr << ' ' << F[26].T[1].bl << ' ' << F[26].T[1].br << '\n';
    cout << '\n';
}

int main()
{
    /// freopen("input.txt", "r", stdin);

    cin >> n;
    arr.resize(n, vector<int>(30));

    int a;

    for (int i = 0; i < n; i++)
    {
        cin >> a;
        toBin(a, arr[i]);
    }

    for (int i = 0; i < 30; i++)
        F.push_back(Tree(i));

    int q, ind;
    cin >> q;

    cout << getAns() << endl;

    while (--q >= 0)
    {
        cin >> ind >> a;
        toBin(a, arr[ind - 1]);

        for (int i = 0; i < 30; i++)
            F[i].setEl(ind - 1, arr[ind - 1][i]);

        cout << getAns() << endl;
    }

    return 0;
}
