#include <iostream>
#include <set>
#include <string>
#include <vector>
#include <algorithm>
#include <unordered_map>
#include <queue>
#include <ctime>

std::vector<int> p, size, l, r;

int dsuGet(int v) {
	return (v == p[v]) ? v : p[v] = dsuGet(p[v]);
}

void dsuUnite(int a, int b) {
	a = dsuGet(a);
	b = dsuGet(b);
	if (a == b) {
		return;
	}
	if (rand() % 2) {
		std::swap(a, b);
	}
	p[a] = b;
	size[b] += size[a];
	l[b] = std::min(l[a], l[b]);
	r[b] = std::max(r[a], r[b]);
}

bool bad(std::string s, std::string t) {
	std::vector<std::pair<int, int>> intervals;
	char c = s[0];
	int len = 0;
	for (int i = 0; i < s.size(); ++i) {
		if (s[i] != c) {
			intervals.push_back({ i - len, len });
			c = s[i];
			len = 0;
		}
		++len;
	}
	if (len > 0) {
		intervals.push_back({ (int)s.size() - len, len });
	}
	p.resize(intervals.size());
	size.resize(intervals.size());
	for (int i = 0; i < intervals.size(); ++i) {
		p[i] = i;
	}
	std::vector<std::pair<int, int>> update;
	for (int i = 0; i < s.size(); ++i) {
		int len = 0, start = i;
		if (s[i] != t[i]) {
			while (i < s.size() && s[i] != t[i]) {
				++len;
				++i;
			}
			--i;
			update.push_back({ start, len });
		}
	}
	int cnt = 0;
	std::vector<bool> need(intervals.size()), used(intervals.size());
	for (int i = 0; i < update.size(); ++i) {
		auto it = std::lower_bound(intervals.begin(), intervals.end(), std::make_pair(update[i].first, -1));
		if (it == intervals.end() || it->first != update[i].first || it->second != update[i].second) {
			return false;
		}
		need[it - intervals.begin()] = true;
		++cnt;
	}
	for (int i = 0; i < intervals.size(); ++i) {
		size[i] = intervals[i].second;
	}
	std::queue<int> q;
	for (int i = 0; i < intervals.size(); ++i) {
		if (need[i] && (i - 1 >= 0 && intervals[i - 1].second > intervals[i].second || i + 1 < intervals.size() && intervals[i + 1].second > intervals[i].second)) {
			q.push(i);
			used[i] = true;
		}
	}
	int res = 0;
	l.resize(intervals.size());
	r.resize(intervals.size());
	for (int i = 0; i < intervals.size(); ++i) {
		l[i] = i - 1, r[i] = i + 1;
	}
	while (!q.empty()) {
		++res;
		int v = q.front();
		used[v] = true;
		q.pop();
		int i = intervals[v].first;
		if (s[i] == '-') {
			s[i] = '+';
		}
		else {
			s[i] = '-';
		}
		//int len = intervals[v].second;
		if (l[v] >= 0 && s[intervals[l[v]].first] == s[i]) {
			//len += intervals[v - 1].second;
			dsuUnite(v, l[v]);
			//--l[v];
		}
		if (r[v] < intervals.size() && s[intervals[r[v]].first] == s[i]) {
			//len += intervals[v + 1].second;
			//++r[v];
			dsuUnite(v, r[v]);
		}
		int len = size[dsuGet(v)];
		/*if (l[v] >= 0 && s[intervals[l[v]].first] == s[i]) {
		//intervals[l[v]].second = len;
		if (v - 2 >= 0 && need[v - 2] && len > intervals[v - 2].second && !used[v - 2]) {
		q.push(v - 2);
		used[v - 2] = true;
		}
		}
		if (v + 1 < intervals.size() && s[intervals[v + 1].first] == s[i]) {
		intervals[v + 1].second = len;
		if (v + 2 < intervals.size() && need[v + 2] && len > intervals[v + 2].second && !used[v + 2]) {
		q.push(v + 2);
		used[v + 2] = true;
		}
		}
		intervals[v].second = len;*/
		/*for (int allah = v - 1; allah >= 0; --allah) {
		if (s[intervals[allah].first] != s[i] && need[allah] && len > intervals[allah].second && !used[allah]) {
		q.push(allah);
		used[allah] = true;
		}
		}
		for (int allah = v + 1; allah < intervals.size(); ++allah) {
		if (s[intervals[allah].first] != s[i] && need[allah] && len > intervals[allah].second && !used[allah]) {
		q.push(allah);
		used[allah] = true;
		}
		}*/
		int new_v = dsuGet(v);
		if (l[new_v] >= 0 && s[intervals[l[new_v]].first] != s[i] && need[l[new_v]] && len > intervals[l[new_v]].second && !used[l[new_v]]) {
			q.push(l[new_v]);
			used[l[new_v]] = true;
		}
		if (r[new_v] < intervals.size() && s[intervals[r[new_v]].first] != s[i] && need[r[new_v]] && len > intervals[r[new_v]].second && !used[r[new_v]]) {
			q.push(r[new_v]);
			used[r[new_v]] = true;
		}
	}
	if (res == cnt) {
		return true;
	}
	else {
		return false;
	}
}

bool good(std::string s, std::string t) {
	std::unordered_map<std::string, int> d;
	d[s] = 0;
	std::queue<std::string> q;
	q.push(s);
	bool fl = false;
	while (!q.empty()) {
		std::string cur = q.front();
		q.pop();
		if (cur == t) {
			fl = true;
			break;
		}
		std::vector<std::pair<int, char>> shit;
		char c = cur[0];
		int len = 0;
		for (int i = 0; i < cur.size(); ++i) {
			if (cur[i] != c) {
				shit.push_back({ len, c });
				c = cur[i];
				len = 0;
			}
			++len;
		}
		if (len > 0) {
			shit.push_back({ len, c });
		}
		int index = shit[0].first;
		for (int i = 1; i < shit.size(); ++i) {
			if (shit[i].first != shit[i - 1].first) {
				std::string lol = cur;
				if (shit[i].first < shit[i - 1].first) {
					for (int j = index; j < index + shit[i].first; ++j) {
						lol[j] = shit[i - 1].second;
					}
				}
				else {
					for (int j = index - 1; j >= index - shit[i - 1].first; --j) {
						lol[j] = shit[i].second;
					}
				}
				if (d.find(lol) == d.end()) {
					d[lol] = d[cur] + 1;
					q.push(lol);
				}
			}
			index += shit[i].first;
		}
	}
	if (fl) {
		return true;
	}
	else {
		return false;
	}
}

int main(void) {
	srand(time(NULL));
	/*for (int i = 0; i < (1 << 8); ++i) {
		std::string s, t;
		for (int j = 0; j < 8; ++j) {
			if (((i >> j) & 1) == 1) {
				s += '+';
			}
			else {
				s += '-';
			}
		}
		for (int k = 0; k < (1 << 8); ++k) {
			for (int lll = 0; lll < 8; ++lll) {
				if (((k >> lll) & 1) == 1) {
					t += '+';
				}
				else {
					t += '-';
				}
			}
			if (good(s, t) != bad(s, t)) {
				std::cout << s << ' ' << t << ' ' << good(s, t) << ' ' << bad(s, t);
				return 0;
			}
			t.clear();
		}
	}*/
	int q;
	std::cin >> q;
	for (int test = 0; test < q; ++test) {
	lbl:
		std::string s, t;
		std::cin >> s >> t;
		std::vector<std::pair<int, int>> intervals;
		char c = s[0];
		int len = 0;
		for (int i = 0; i < s.size(); ++i) {
			if (s[i] != c) {
				intervals.push_back({ i - len, len });
				c = s[i];
				len = 0;
			}
			++len;
		}
		if (len > 0) {
			intervals.push_back({ (int)s.size() - len, len });
		}
		p.assign(intervals.size(), 0);
		size.assign(intervals.size(), 0);
		for (int i = 0; i < intervals.size(); ++i) {
			p[i] = i;
		}
		std::vector<std::pair<int, int>> update;
		for (int i = 0; i < s.size(); ++i) {
			int len = 0, start = i;
			if (s[i] != t[i]) {
				while (i < s.size() && s[i] != t[i]) {
					++len;
					++i;
				}
				--i;
				update.push_back({ start, len });
			}
		}
		int cnt = 0;
		std::vector<bool> need(intervals.size()), used(intervals.size());
		for (int i = 0; i < update.size(); ++i) {
			auto it = std::lower_bound(intervals.begin(), intervals.end(), std::make_pair(update[i].first, -1));
			if (it == intervals.end() || it->first != update[i].first || it->second != update[i].second) {
				std::cout << "No\n";
				++test;
				goto lbl;
			}
			need[it - intervals.begin()] = true;
			++cnt;
		}
		for (int i = 0; i < intervals.size(); ++i) {
			size[i] = intervals[i].second;
		}
		std::queue<int> q;
		for (int i = 0; i < intervals.size(); ++i) {
			if (need[i] && (i - 1 >= 0 && intervals[i - 1].second > intervals[i].second || i + 1 < intervals.size() && intervals[i + 1].second > intervals[i].second)) {
				q.push(i);
				used[i] = true;
			}
		}
		int res = 0;
		l.assign(intervals.size(), 0);
		r.assign(intervals.size(), 0);
		for (int i = 0; i < intervals.size(); ++i) {
			l[i] = i - 1, r[i] = i + 1;
		}
		while (!q.empty()) {
			++res;
			int v = q.front();
			used[v] = true;
			q.pop();
			int i = intervals[v].first;
			if (s[i] == '-') {
				s[i] = '+';
			} else {
				s[i] = '-';
			}
			//int len = intervals[v].second;
			if (l[v] >= 0 && s[intervals[l[v]].first] == s[i]) {
				//len += intervals[v - 1].second;
				dsuUnite(v, l[v]);
				//--l[v];
			}
			if (r[v] < intervals.size() && s[intervals[r[v]].first] == s[i]) {
				//len += intervals[v + 1].second;
				//++r[v];
				dsuUnite(v, r[v]);
			}
			int len = size[dsuGet(v)];
			/*if (l[v] >= 0 && s[intervals[l[v]].first] == s[i]) {
				//intervals[l[v]].second = len;
				if (v - 2 >= 0 && need[v - 2] && len > intervals[v - 2].second && !used[v - 2]) {
					q.push(v - 2);
					used[v - 2] = true;
				}
			}
			if (v + 1 < intervals.size() && s[intervals[v + 1].first] == s[i]) {
				intervals[v + 1].second = len;
				if (v + 2 < intervals.size() && need[v + 2] && len > intervals[v + 2].second && !used[v + 2]) {
					q.push(v + 2);
					used[v + 2] = true;
				}
			}
			intervals[v].second = len;*/
			/*for (int allah = v - 1; allah >= 0; --allah) {
				if (s[intervals[allah].first] != s[i] && need[allah] && len > intervals[allah].second && !used[allah]) {
					q.push(allah);
					used[allah] = true;
				}
			}
			for (int allah = v + 1; allah < intervals.size(); ++allah) {
				if (s[intervals[allah].first] != s[i] && need[allah] && len > intervals[allah].second && !used[allah]) {
					q.push(allah);
					used[allah] = true;
				}
			}*/
			int new_v = dsuGet(v);
			if (l[new_v] >= 0 && s[intervals[l[new_v]].first] != s[i] && need[l[new_v]] && len > intervals[l[new_v]].second && !used[l[new_v]]) {
				q.push(l[new_v]);
				used[l[new_v]] = true;
			}
			if (r[new_v] < intervals.size() && s[intervals[r[new_v]].first] != s[i] && need[r[new_v]] && len > intervals[r[new_v]].second && !used[r[new_v]]) {
				q.push(r[new_v]);
				used[r[new_v]] = true;
			}
		}
		if (res == cnt) {
			std::cout << "Yes\n";
		} else {
			std::cout << "No\n";
		}
	}
	return 0;
}