#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <iostream>

using namespace std;

const int INF = 2e9;

struct vec
{
	int x, y, num;
	vec(int _x = 0, int _y = 0)
	{
		x = _x;
		y = _y;
	}
	vec operator-(vec &a)
	{
		return vec(x - a.x, y - a.y);
	}
	vec operator+(vec &a)
	{
		return vec(x + a.x, y + a.y);
	}
	long long operator*(vec &a)
	{
		return 1ll * x * a.x + 1ll * y * a.y;
	}
	long long operator%(vec &a)
	{
		return 1ll * x * a.y - 1ll * y * a.x;
	}
};

vec c;

bool comp(vec &a, vec &b)
{
	vec ca = a - c;
	vec cb = b - c;
	return ca % cb > 1ll * 0;
}

bool in_tr(vec x, vec a, vec b, vec c)
{
	vector < vec > point(4);
	point[0] = a, point[1] = b, point[2] = c, point[3] = a;
	bool f1 = true, f2 = true;
	for (int i = 0; i < 3; ++i)
	{
		vec a1 = point[i + 1] - point[i];
		vec a2 = x - point[i];
		if (a1 % a2 > 0)
			f1 = false;
		else
			f2 = false;
	}
	return (f1 || f2);
}

int main()
{
	//freopen("input.txt", "rt", stdin);
	int n;
	scanf("%d", &n);
	if (n > 20)
	{
		vector < vec > a(n);
		for (int i = 0; i < n; ++i)
		{
			scanf("%d%d", &a[i].x, &a[i].y);
			a[i].num = i;
		}
		for (int i = 1; i < n; ++i)
		{
			if ((a[i].x < a[0].x) || ((a[i].x == a[0].x) && (a[i].y < a[0].y)))
				swap(a[i], a[0]);
		}
		c = a[0];
		sort(a.begin() + 1, a.end(), comp);
		vector < vec > cur(1, a[0]);
		cur.push_back(a[1]);
		for (int i = 2; i < n; ++i)
		{
			vec ab = cur[cur.size() - 1] - cur[cur.size() - 2];
			vec bc = a[i] - cur.back();
			while (ab % bc < 1ll * 0)
			{
				cur.pop_back();
				ab = cur[cur.size() - 1] - cur[cur.size() - 2];
				bc = a[i] - cur.back();
			}
			cur.push_back(a[i]);
		}

		int q;
		scanf("%d", &q);
		for (int w = 0; w < q; ++w)
		{
			vector < vec > ob = cur;
			vector < vec > b = a;
			int l = 1, r = ob.size() - 1;
			while (r - l > 1)
			{
				int m = (r + l) / 2;
				printf("? 3 %d %d %d\n", ob[0].num + 1, ob[m].num + 1, ob[l].num + 1);
				fflush(stdout);
				string s;
				cin >> s;
				if (s[0] == 'Y')
					r = m;
				else
					l = m;
			}
			vec a1 = ob[0], a2 = ob[l], a3 = ob[r];
			vector < vec > c = b;
			b.clear();
			for (int i = 0; i < c.size(); ++i)
			{
				if (in_tr(c[i], a1, a2, a3))
					b.push_back(c[i]);
			}
			while (!b.empty())
			{
				//random_shuffle(b.begin(), b.end());
				vec x = b[0];
				printf("? 3 %d %d %d\n", x.num + 1, a1.num + 1, a2.num + 1);
				fflush(stdout);
				string s;
				cin >> s;
				if (s[0] == 'Y')
				{
					a3 = x;
					c = b;
					b.clear();
					for (int i = 0; i < c.size(); ++i)
					{
						if (in_tr(c[i], a1, a2, a3))
							b.push_back(c[i]);
					}
				}
				else
				{
					printf("? 3 %d %d %d\n", x.num + 1, a1.num + 1, a3.num + 1);
					fflush(stdout);
					string s1;
					cin >> s1;
					if (s1[0] == 'Y')
						a2 = x;
					else
						a1 = x;
					c = b;
					b.clear();
					for (int i = 0; i < c.size(); ++i)
					{
						if ((c[i].num != a1.num) && (c[i].num != a2.num) && (c[i].num != a3.num) && (in_tr(c[i], a1, a2, a3)))
							b.push_back(c[i]);
					}
				}
			}
			printf("! 3 %d %d %d\n", a1.num + 1, a2.num + 1, a3.num + 1);
			fflush(stdout);
		}
	}
	else
	{
		vector < vec > a(n);
		for (int i = 0; i < n; ++i)
		{
			scanf("%d%d", &a[i].x, &a[i].y);
		}
		int q;
		scanf("%d", &q);
		for (int w = 0; w < q; ++w)
		{
			bool write = false;
			for (int i = 0; i < n; ++i)
			{
				if (write)
					break;
				for (int j = i + 1; j < n; ++j)
				{
					if (write)
						break;
					for (int k = j + 1; k < n; ++k)
					{
						bool f = true;
						for (int k1 = 0; k1 < n; ++k1)
						{
							if ((in_tr(a[k1], a[i], a[j], a[k])) && (k1 != i) && (k1 != j) && (k1 != k))
								f = false;
						}
						if (f)
						{
							printf("? 3 %d %d %d\n", i + 1, j + 1, k + 1);
							fflush(stdout);
							string s;
							cin >> s;
							if (s[0] == 'Y')
							{
								printf("! 3 %d %d %d\n", i + 1, j + 1, k + 1);
								fflush(stdout);
								write = true;
								break;
							}
						}
					}
				}
			}
		}
	}
	return 0;
}
