#include <algorithm>
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>

using namespace std;
#define ff first
#define ss second
#define mp make_pair
#define pb push_back
#define pii pair <int, int> 

const int MAXA = (1 << 30), MAXLEN = 30;
int n;
vector <int> a;
map <int, <set <int> > pr[MAXLEN];
unordered_set <int> whynotok0[MAXLEN];
unordered_set <int> whynotok1[MAXLEN];


void init() {
	for (int ind = 0; ind < n; ++ind) {
		int i = a[ind];
		for (int j = 0; j < MAXLEN; ++j) {
			int pref = ((i >> j) << j);
			pr[j][pref].insert(ind);
		}
	}

	for (int j = 0; j < MAXLEN; ++j) {
		for (auto & it : pr[j]) {
			int i = it.ff;
			if (i & (1 << j))
				continue;
			int pref0 = i, pref1 = i + (1 << j);
			if (pr[j][pref0].empty()  || pr[j][pref1].empty())
				continue;
			int mn0, mn1, mx0, mx1;
			mn0 = *(pr[j][pref0].begin());
			mn1 = *(pr[j][pref1].begin());
			mx0 = *(--pr[j][pref0].end());
			mx1 = *(--pr[j][pref1].end());
			if (mn0 < mx1) 
				whynotok1[j].insert(pref0);
			if (mn1 < mx0) 
				whynotok0[j].insert(pref0);
		}
	}
}

int solve() {
	int ans = 0;
	for (int j = 0; j < MAXLEN; ++j) {
		if (whynotok0[j].empty())
			continue;
		else if (whynotok1[j].empty())
			ans += (1 << j);
		else
			return -1;
	}
	return ans;
} 

void rem(int i, int ind) {
	for (int j = 0; j < MAXLEN; ++j) {
		int pref = ((i >> j) << j);
		pr[j][pref].erase(ind);
		
		int pref0 = pref, pref1 = (pref ^ (1 << j));
		if (pref0 > pref1)
			swap(pref0, pref1);
		if (pr[j][pref0].empty()  || pr[j][pref1].empty()) {
			whynotok0[j].erase(pref0);
			whynotok1[j].erase(pref0);
			continue;
		}
		int mn0, mn1, mx0, mx1;
		mn0 = *(pr[j][pref0].begin());
		mn1 = *(pr[j][pref1].begin());
		mx0 = *(--pr[j][pref0].end());	
		mx1 = *(--pr[j][pref1].end());
		if (mn0 >= mx1) 
			whynotok1[j].erase(pref0);
		if (mn1 >= mx0) 
			whynotok0[j].erase(pref0);
	}
}

void add(int i, int ind) {
	for (int j = 0; j < MAXLEN; ++j) {
		int pref = ((i >> j) << j);
		pr[j][pref].insert(ind);
		
		int pref0 = pref, pref1 = (pref ^ (1 << j));
		if (pref0 > pref1)
			swap(pref0, pref1);
		if (pr[j][pref0].empty()  || pr[j][pref1].empty()) {
			continue;
		}
		int mn0, mn1, mx0, mx1;
		mn0 = *(pr[j][pref0].begin());
		mn1 = *(pr[j][pref1].begin());
		mx0 = *(--pr[j][pref0].end());	
		mx1 = *(--pr[j][pref1].end());
		if (mn0 < mx1) 
			whynotok1[j].insert(pref0);
		if (mn1 < mx0) 
			whynotok0[j].insert(pref0);
	}
}


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	cin >> n;
	a.resize(n);
	for (auto & i : a)
		cin >> i;

	init();
	cout << solve() << "\n";
	int q;
	cin >> q;
	while (q--) {
		int p, v;
		cin >> p >> v;
		p--;
		rem(a[p], p);
		a[p] = v;
		add(a[p], p);
		cout << solve() << "\n";
	}
}