#include <algorithm>
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>

using namespace std;
#define x first
#define y second
#define mp make_pair
#define pb push_back
#define pt pair <pair <int, int>, int>
#define int long long

vector <pt> g, in, lft, old_lft;

bool cw(pt a, pt b, pt c) {
	return (b.x.x - a.x.x) * (c.x.y - a.x.y) - (c.x.x - a.x.x) * (b.x.y - a.x.y) > 0;
} 

bool ccw(pt a, pt b, pt c) {
	return (b.x.x - a.x.x) * (c.x.y - a.x.y) - (c.x.x - a.x.x) * (b.x.y - a.x.y) < 0;
} 


void convex_hull() {
	int m = g.size();
	sort(g.begin(), g.end());
	vector <pt> up, down;
	up.pb(g[0]); down.pb(g[0]);
	for (int i = 1; i < m; ++i) {
		if (cw(g[0], g[i], g[m - 1]) || i + 1 == m) {
			while (up.size() > 2 && !cw(up[(int)up.size() - 2], up.back(), g[i])) {
				lft.pb(up.back());
				up.pop_back();
			}
			up.pb(g[i]);
		}
		if (ccw(g[0], g[i], g[m - 1]) || i + 1 == m) {
			while (down.size() > 2 && !ccw(down[(int)down.size() - 2], down.back(), g[i])) {
				lft.pb(down.back());
				down.pop_back();
			}
			down.pb(g[i]);
		}
	}
	g = up;
	for (int i = ((int)down.size()) - 2; i > 0; --i)
		g.pb(down[i]);
}


int area(pt a, pt b, pt c) {
	return abs((b.x.x - a.x.x) * (c.x.y - a.x.y) - (c.x.x - a.x.x) * (b.x.y - a.x.y));
}


bool is_in(pt a, pt b, pt c, pt p) {
	return area(a, b, p) + area(b, c, p) + area(c, a, p) == area(a, b, c);
}


void solve() {
	int m = g.size();
	lft = old_lft;
	int l = 1, r = m - 1;
	while (l + 1 < r) {
		int mm = (l + r) / 2;
		cout << "? " << mm + 1 << ' ';
		for (int i = 0; i <= mm; ++i)
			cout << g[i].y << ' ';
		cout << endl;
		string ans;
		cin >> ans;
		if (ans == "Yes")
			r = mm;
		else
			l = mm;
	}
	pt a = g[0], b = g[r - 1], c = g[r];
	for (auto i : lft) {
		if (is_in(a, b, c, i))
			in.pb(i);
	}
	lft.clear();
	while (!in.empty()) {
		pt p = in[0];
		cout << "? " << a.y << ' ' << b.y << ' ' << p.y << endl;
		string ans;
		cin >> ans;
		if (ans == "Yes") {
			c = p;
			lft = in;
			in.clear();
			for (int i = 1; i < lft.size(); ++i)
				if (is_in(a, b, c, lft[i]))
					in.pb(lft[i]);
			continue;
		}
		cout << "? " << a.y << ' ' << p.y << ' ' << c.y << endl;
		cin >> ans;
		if (ans == "Yes") {
			b = p;
			lft = in;
			in.clear();
			for (int i = 1; i < lft.size(); ++i)
				if (is_in(a, b, c, lft[i]))
					in.pb(lft[i]);
		} else {
			a = p;
			lft = in;
			in.clear();
			for (int i = 1; i < lft.size(); ++i)
				if (is_in(a, b, c, lft[i]))
					in.pb(lft[i]);
		}
	}
	in.clear(); lft.clear();
	cout << "! 3 " << a.y << ' ' << b.y << ' ' << c.y << endl;
}


int32_t main() {
	int n;
	cin >> n;
	g.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> g[i].x.x >> g[i].x.y;
		g[i].y = i + 1;
	}
	convex_hull();
	old_lft = lft;
	int q;
	cin >> q;
	while (q--)
		solve();
}