#include <iostream>
#include <fstream>
#include <cstdio>
#include <vector>

using namespace std;

typedef unsigned int uint;

const int MAX_N = 1e6 + 11;
const int MAX_LOGX = 31;

int n, sz;
uint nums[MAX_N * 2];
uint ans[MAX_N * 2 + 2];
uint mask[MAX_N * 2 + 2];

int solveStupid() {
    for (int ans = 0; ans < (1<<9); ans++) {
        bool good = true;
        for (int i = 1; i < n; i++)
            if ((nums[i - 1] ^ ans) > (nums[i] ^ ans)) {
                good = false;
                break;
            }
        if (good)
            return ans;
    }
    return -1;
}

void printBin(uint x) {
    for (int i = 3; i >= 0; i--) {
        cout << ((x >> i) & 1);
    }
    cout << endl;
}

void mergeAnss(uint a, uint ma, uint b, uint mb, uint &c, uint &mc) {
    if (a == -1 || b == -1) {
        c = mc = -1;
        return;
    }

    uint mAnd = ma & mb;
    if ((a & mAnd) != (b & mAnd)) {
        c = mc = -1;
        return;
    }
    mc = ma | mb;
    c = (a | b) & mc;
}

void nbAns(uint a, uint b, uint &ans, uint &mask) {
    uint x = a ^ b;

    uint lastDiff = (1 << MAX_LOGX);

    while (lastDiff && (x & lastDiff) == 0)
        lastDiff >>= 1;
    //printf("ld: %d\n", lastDiff);
    if (lastDiff == 0) {
        ans = mask = 0;
        return;
    }

    mask = lastDiff;
    ans = 0;
    if (a & lastDiff) {
        ans = lastDiff;
    }
}

void updateK(int l, int r, int k) {
    uint aL = ans[k * 2 + 1], mL = mask[k * 2 + 1];
    uint aR = ans[k * 2 + 2], mR = mask[k * 2 + 2];
    uint aLR, mLR;
    mergeAnss(aL, mL, aR, mR, aLR, mLR);

    int m = (l + r) / 2;
    uint a = nums[m - 1], b = nums[m];
    uint nba, nbm;
    nbAns(a, b, nba, nbm);
    mergeAnss(nba, nbm, aLR, mLR, ans[k], mask[k]);
}

void setNum(int i, uint x, int l, int r, int k) {
    if (l == r - 1)
        return;

    int m = (l + r) / 2;
    if (i < m)
        setNum(i, x, l, m, k * 2 + 1);
    else
        setNum(i, x, m, r, k * 2 + 2);

    updateK(l, r, k);
}

void setNum(int i, int x) {
    nums[i] = x;
    setNum(i, x, 0, sz, 0);
}

int solve() {
    uint ansFin = 0, maskFin = 0;
    for (int i = 1; i < n; i++) {
        uint a = nums[i - 1], b = nums[i];
        uint ans, mask;
        nbAns(a, b, ans, mask);

        //printBin(ans);
        //printBin(mask);
        //cout << endl;

        mergeAnss(ans, mask, ansFin, maskFin, ansFin, maskFin);
    }
    return ansFin;
}

int main() {
    ifstream fin("order.in");

    fin >> n;
    for (int i = 0; i < n; i++) {
        fin >> nums[i];
    }
    /*
    sz = 1;
    while (sz < n)
        sz *= 2;

    for (int i = 0; i < sz * 2; i++)
        ans[i] = mask[i] = 0;

    for (int i = 0; i < n; i++) {
        setNum(i, nums[i]);
    }
    */
    //printf("%d (%d)\n", solve(), solveStupid());
    cout << solve() << endl;
    int q;
    fin >> q;
    for (int queryI = 0; queryI < q; queryI++) {
        int i, x;
        fin >> i >> x;
        i--;
        //printf("\n");
        nums[i] = x;
        //pr();
        cout << solve() << endl;
        //printf("%d (%d)\n", solve(), solveStupid());
    }

    fin.close();
    return 0;
}
