#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

bool possToPlus(const string &s) {
    vector<pair<char, int>> segStack;
    int n = s.size();
    int left = 0;
    int right = 0;
    while (left < n) {
        while (right < n && s[left] == s[right])
            right++;

        int len = right - left;
        segStack.push_back(make_pair(s[left], len));

        int sz = segStack.size();
        while (sz >= 2) {
            pair<char, int> &curr = segStack[sz - 1];
            pair<char, int> &prev = segStack[sz - 2];
            if ((curr.first == '-' && prev.second > curr.second) ||
                (curr.first == '+' && prev.first == '+')) {
                prev.second += curr.second;
                segStack.pop_back();
                sz--;
            } else if (curr.first == '+' && curr.second > prev.second) {
                prev.first = '+';
                prev.second += curr.second;
                segStack.pop_back();
                sz--;
            } else {
                break;
            }
        }
        /*
        for (auto x : segStack)
            cout << x.first << x.second << " ";
        cout << endl;
        */
        left = right;
    }
    return segStack.size() == 1 && segStack.back().first == '+';
}

int main() {
    vector<pair<char, int>> segStack;

    ifstream fin("storage.in");
    int q;
    fin >> q;
    for (int i = 0; i < q; i++) {
        string s, t;
        fin >> s >> t;
        //cout << s << " " << t << endl;
        int n = t.size();
        int left = 0, right = 0;
        bool possible = true;
        while (left < n) {
            while (right < n && t[left] == t[right])
                right++;
            if (left > 0 && (s[left - 1] == s[left] || s[left] != t[left])) {
                possible = false;
                break;
            }

            string sSub = s.substr(left, right - left);
            if (t[left] == '-')
                for (int i = 0; i < right - left; i++)
                    sSub[i] = (sSub[i] != '+' ? '+' : '-');

            //cout << "ss: " << sSub << endl;

            possible = possToPlus(sSub);
            if (!possible)
                break;

            left = right;
        }

        if (possible)
            cout << "Yes" << endl;
        else
            cout << "No" << endl;
    }
}
