#include <iostream>
#include <fstream>

using namespace std;

const int MAX_N = 2e5;
const int INF = 1e9 + 2;

int tH[MAX_N];
int tL[MAX_N];
int tR[MAX_N];
int mustLtoL[MAX_N];
int mustRtoL[MAX_N];
int mustLtoR[MAX_N];
int mustRtoR[MAX_N];
bool possibleToL[MAX_N];
bool possibleToR[MAX_N];

int main() {
    ifstream fin("servers.in");
    int n;
    fin >> n;
    for (int i = 0; i < n; i++) {
        fin >> tH[i];
        possibleToL[i] = false;
        possibleToR[i] = false;
    }
    for (int i = 0; i < n - 1; i++)
        fin >> tL[i] >> tR[i];
    fin.close();

    mustLtoL[0] = 0;
    mustRtoL[0] = INF;
    possibleToL[0] = true;
    for (int i = 1; i < n; i++) {
        if (!possibleToL[i - 1] || mustRtoL[i - 1] < tL[i - 1] || tR[i - 1] < mustLtoL[i - 1])
            break;

        possibleToL[i] = true;

        mustRtoL[i] = min(mustRtoL[i - 1], tR[i - 1]);
        if (tL[i - 1] < mustLtoL[i - 1])
            mustLtoL[i] = mustLtoL[i - 1];
        else
            mustLtoL[i] = max(0, tL[i - 1] - tH[i]);

        //cout << "[" << mustLtoL[i] << " " << mustRtoL[i] << "]" << endl;
    }
    //cout << endl;
    mustLtoR[n - 1] = 0;
    mustRtoR[n - 1] = INF;
    possibleToR[n - 1] = true;
    for (int i = n - 2; i >= 0; i--) {
        if (!possibleToR[i + 1] || mustRtoR[i + 1] < tL[i] || tR[i] < mustLtoR[i + 1])
            break;
        possibleToR[i] = true;

        mustRtoR[i] = min(mustRtoR[i + 1], tR[i]);
        if (tL[i] < mustLtoR[i + 1])
            mustLtoR[i] = mustLtoR[i + 1];
        else
            mustLtoR[i] = max(0, tL[i] - tH[i]);

        //cout << "[" << mustLtoR[i] << " " << mustRtoR[i] << "]" << endl;
    }

    for (int i = 0; i < n; i++) {
        int minToL = mustLtoL[i], maxToL = mustRtoL[i];
        int minToR = mustLtoR[i], maxToR = mustRtoR[i];
        int tMin = max(minToL, minToR);
        int tMax = min(maxToL, maxToR);
        if (possibleToL[i] && possibleToR[i] && tMin <= tMax) {
            cout << tMin << endl;
        } else {
            cout << -1 << endl;
        }
    }
}
