#include <iostream>
#include <fstream>
#include <cstdio>

using namespace std;

const int MAX_N = 5e5;

int qa, qb;
int numsA[MAX_N];
int ratA[MAX_N];
int numsB[MAX_N];
int ratB[MAX_N];

bool used[MAX_N * 2];

void solveStupid() {
    for (int i = 0; i < qa + qb; i++)
        used[i] = false;

    long long sum = 0;
    long long bestSum = 0;
    int bestLa = 0, bestRa = 0, bestLb = 0, bestRb = 0;
    for (int la = 0; la < qa; la++) {
        for (int ra = la; ra <= qa; ra++) {



            for (int lb = 0; lb < qb; lb++) {
                int rb = lb;
                for (; rb <= qb; rb++) {
                    if (sum > bestSum) {
                        bestSum = sum;
                        bestLa = la, bestRa = ra;
                        bestLb = lb, bestRb = rb;
                    }

                    if (rb < qb) {
                        if (used[numsB[rb]])
                            break;
                        used[numsB[rb]] = true;
                        sum += ratB[rb];
                    }
                }

                for (rb--; rb >= lb; rb--) {
                    used[numsB[rb]] = false;
                    sum -= ratB[rb];
                }
            }



            if (ra < qa) {
                sum += ratA[ra];
                used[numsA[ra]] = true;
            }
        }
        for (int ra = qa - 1; ra >= la; ra--) {
            sum -= ratA[ra];
            used[numsA[ra]] = false;
        }
    }

    cout << bestSum << endl;
    if (bestLa < bestRa)
        cout << bestLa + 1 << " " << bestRa << endl;
    else
        cout << "0 0" << endl;

    if (bestLb < bestRb)
        cout << bestLb + 1 << " " << bestRb << endl;
    else
        cout << "0 0" << endl;
}

void solve2() {
    for (int i = 0; i < qa + qb; i++)
        used[i] = false;

    long long sum = 0;
    long long bestSum = 0;
    int bestLa = 0, bestRa = 0, bestLb = 0, bestRb = 0;
    for (int la = 0; la < qa; la++) {
        for (int ra = la; ra <= qa; ra++) {

            int lb = 0, rb = 0;
            while (lb < qb) {
                if (used[numsB[lb]]) {
                    lb++, rb++;
                    continue;
                }

                int sumB = 0;
                while (rb < qb && !used[numsB[rb]]) {
                    sumB += ratB[rb];
                    rb++;
                }

                if (sum + sumB > bestSum) {
                    bestSum = sum + sumB;
                    bestLa = la, bestRa = ra;
                    bestLb = lb, bestRb = rb;
                }

                lb = rb;
            }

            if (ra < qa) {
                sum += ratA[ra];
                used[numsA[ra]] = true;
            }
        }
        for (int ra = qa - 1; ra >= la; ra--) {
            sum -= ratA[ra];
            used[numsA[ra]] = false;
        }
    }

    cout << bestSum << endl;
    if (bestLa < bestRa)
        cout << bestLa + 1 << " " << bestRa << endl;
    else
        cout << "0 0" << endl;

    if (bestLb < bestRb)
        cout << bestLb + 1 << " " << bestRb << endl;
    else
        cout << "0 0" << endl;
}

int main() {
    ifstream fin("internship.in");
    fin >> qa >> qb;
    for (int i = 0; i < qa; i++)
        fin >> numsA[i];
    for (int i = 0; i < qa; i++)
        fin >> ratA[i];
    for (int i = 0; i < qb; i++)
        fin >> numsB[i];
    for (int i = 0; i < qb; i++)
        fin >> ratB[i];
    fin.close();

    //solveStupid();
    //cout << endl;
    solve2();
}
