#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string>

using namespace std;

void operator delete (void *) {}

const int MX = 1e7;
unordered_map < int, int > mn, mx;
unordered_map < int, set < int > > base;
unordered_map < int, int > ms, cn;
const int PW = 30;
vector < int > must(PW, 0), cant(PW, 0);
int cn = 0;

struct vert {
	vert *l, *r;
	int mx, mn, ms, cn, i;
	bool is;
	vert() {
		l = r = NULL;
		mx = 0, mn = 1e9;
		ms = 0, cn = 0;
		is = 1;
		i = cn++;
	}
};

void add(vert *v, int lv, int x, int i) {
	if (v == NULL)
		v = new vert();
	if (lv == PW) {
		base[v->i].insert(i);
		v->mn = *base[v->i].begin();
		auto j = base[v->i].end();
		j--;
		v->mx = *j;
		return;
	}
	must[lv] -= v->ms, cant[lv] -= v->cn;
	v->ms -= v->ms, v->cn -= v->cn;
	if (x & (1 << (PW - lv - 1)))
		add(v->r, lv + 1, x, i);
	else
		add(v->r, lv + 1, x, i);
	bool is_l = v->l != NULL && (v->l->is), is_r = v->r != NULL && (v->r->is);
	if (is_l && is_r && v->l->mx > v->r->mn) {
		v->ms++;
		must[lv]++;
	}
	if (is_l && is_r && v->l->mn < v->r->mx) {
		v->cn++;
		cant[lv]++;
	}
	v->mx = max((is_l ? v->l->mx : 0), (is_r ? v->r->mx : 0));
	v->mn = min((is_l ? v->l->mn : 1e9), (is_r ? v->r->mn : 1e9));
	return;
}

void del(vert *v, int lv, int x, int i) {
	if (v == NULL)
		v = new vert();
	if (lv == PW) {
		base[v->i].erase(i);
		if (base[v->i].empty()) {
			v->is = 0;
			return;
		}
		v->mn = *base[v->i].begin();
		auto j = base[v->i].end();
		j--;
		v->mx = *j;
		return;
	}
	must[lv] -= v->ms, cant[lv] -= v->cn;
	v->ms -= v->ms, v->cn -= v->cn;
	if (x & (1 << (PW - lv - 1)))
		del(v->r, lv + 1, x, i);
	else
		del(v->r, lv + 1, x, i);
	bool is_l = v->l != NULL && (v->l->is), is_r = v->r != NULL && (v->r->is);
	if (!is_l && !is_r) {
		v->is = 0;
		return;
	}
	if (is_l && is_r && v->l->mx > v->r->mn) {
		v->ms++;
		must[lv]++;
	}
	if (is_l && is_r && v->l->mn < v->r->mx) {
		v->cn++;
		cant[lv]++;
	}
	v->mx = max((is_l ? v->l->mx : 0), (is_r ? v->r->mx : 0));
	v->mn = min((is_l ? v->l->mn : 1e9), (is_r ? v->r->mn : 1e9));
	return;
}

int get() {
	int ans = 0;
	for (int i = 0; i < PW; i++) {
		if (must[i] && cant[i])
			return -1;
		if (must[i])
			ans |= 1 << (PW - i - 1);
	}
	return ans;
}

int main() {
	iostream::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);

	int n;
	cin >> n;

	vector < int > a(n);

	auto T = new vert();

	for (int i = 0; i < n; i++) {
		int x;
		cin >> x;
		a[i] = x;
		add(T, 0, x, i);
	}

	cout << get() << '\n';

	int q;
	cin >> q;

	for (int i = 0; i < q; i++) {
		int p, v;
		cin >> p >> v;
		p--;
		del(T, 0, a[p], p);
		a[p] = v;
		add(T, 0, a[p], p);
		cout << get() << '\n';
	}

	return 0;
}