#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>
#include <stack>

using namespace std;

const int MAX_MEM = 3e7;
char buf[MAX_MEM];
char * cur = buf;
void * operator new(size_t tr){
	if (cur + tr > buf + MAX_MEM)
		cur = buf + (int)2e7;
	cur += tr;
	return cur - tr;
}

const long long MX = 1e5 + 1;
long long dp[MX];
const long long INF = 1e9, IINF = 1e18;

struct min_queue {
	stack < long long > r, rm, l, lm;
	void push(long long x) {
		r.push(x);
		rm.push(min(rm.empty() ? IINF : rm.top(), x));
	}
	void pop() {
		if (l.empty()) {
			while (!r.empty()) {
				long long x = r.top();
				l.push(x);
				lm.push(min(lm.empty() ? IINF : lm.top(), x));
				r.pop();
				rm.pop();
			}
		}
		l.pop();
		lm.pop();
	}
	long long get() {
		return min((lm.empty() ? IINF : lm.top()), (rm.empty() ? IINF : rm.top()));
	}
};

int main() {
	iostream::sync_with_stdio(0);

	int n, a;
	cin >> n >> a;

	vector < pair < pair < long long, long long >, long long > > q(n);
	vector < pair < pair < int, int >, long long > > ev;
	for (int i = 0; i < n; i++) {
		long long l, r, c;
		cin >> l >> r >> c;
		q[i] = { { l, r }, c };
	}	

	vector < min_queue > all(n);
	for (int i = 0; i <= a; i++) {
		for (int j = 0; j < n; j++) {
			int l = q[j].first.first, r = q[j].first.second, c = q[j].second;
			if (i - r < 0) {
				if (i - l + 1 >= 0)
					all[j].push(dp[i - l + 1] - (i - l + 1) * INF);
				continue;
			}		
			long long worst = all[j].get();
			worst += i * INF;
			dp[i] = max(dp[i], worst - c);
			if (i - l + 1 >= 0)
				all[j].push(dp[i - l + 1] - (i - l + 1) * INF);
			all[j].pop();
		}
	}

	long long mx = 0;
	for (long long i = 0; i <= a; i++)
		mx = max(mx, dp[i]);

	cout << mx;

	return 0;
}