#include <iostream>
#include <string>
#include <algorithm>
#include <map>
#include <vector>

using namespace std;

int n;
vector<int> inp;

int solve_stupid()
{
	for (int m = 0; m < 1024; ++m)
	{
		int last = inp[0] ^ m;
		for (int i = 1; i < n; ++i)
		{
			int x = inp[i] ^ m;
			if (x >= last)
				last = x;
			else
				goto br;
		}
		return m;
	br:;
	}
	return -1;
}

const int BITS = 32;

struct stree
{
	vector<char> w; // intitital
	vector<char> t; // computed equality
	vector<char> e; // computed majority

	void init()
	{
		t.resize(w.size() * 4, false);
		e.resize(w.size() * 4, false);
	}

	void build(int v, int l, int r)
	{
		if (r - l == 1)
		{
			t[v] = true;
			e[v] = w[l];
			return;
		}
		int m = (l + r) / 2;
		build(2 * v + 1, l, m);
		build(2 * v + 2, m, r);
		t[v] = (t[2 * v + 1] && t[2 * v + 2]) && (e[2 * v + 1] == e[2 * v + 2]);
		e[v] = e[2 * v + 1]; // it does not matter if t[v] is false anyway
	}

	bool get(int v, int vl, int vr, int l, int r)
	{
		if ((l <= vl) && (r >= vr))
		{
			return t[v];
		}
		if ((r <= vl) || (l >= vr))
		{
			return true;
		}
		int vm = (vl + vr) / 2;
		return (
			get(2 * v + 1, vl, vm, l, r) &&
			get(2 * v + 2, vm, vr, l, r)
			) && (w[l] == w[r - 1]);
	}

	void modify(int v, int vl, int vr, int idx, bool val)
	{
		if ((idx < vl) || (idx >= vr))
		{
			return;
		}
		if (vr - vl == 1)
		{
			if (vl == idx)
			{
				w[idx] = val;
				t[v] = true;
				e[v] = val;
			}
			return;
		}

		int vm = (vl + vr) / 2;
		modify(2 * v + 1, vl, vm, idx, val);
		modify(2 * v + 2, vm, vr, idx, val);
		t[v] = (t[2 * v + 1] && t[2 * v + 2]) && (e[2 * v + 1] == e[2 * v + 2]);
		e[v] = e[2 * v + 1]; // it does not matter if t[v] is false anyway
	}

	int getedge(int l, int r)
	{
		int L = l;
		int R = r;
		while (r - l > 1)
		{
			int m = (l + r) / 2;
			if (get(0, 0, n, L, m))
				l = m;
			else
				r = m;
		}
		return l;
	}
};

vector<stree> bits;

int vote(int l, int r, int bit)
// 0 - we need to NOT flip
// 1 - we need to flip
// 2 - we don't care
// 3 - we failed
{
	if (bit == -1)
		return 2;
	int ans = 0;
	// first, check if we don't care
	bool id = bits[bit].get(0, 0, n, l, r);
	if (id)
		return 2;
	int edge = bits[bit].getedge(l, r);
	if (bits[bit].get(0, 0, n, l, edge) && bits[bit].get(0, 0, n, edge, r))
	{
		if (bits[bit].w[l])
			return 1;
		return 0;
	}
	else
	{
		return 3;
	}
}


int solve(int l, int r, int bit, int v, bool q)
{
	if (bit == -1)
		return 0;
	if (v == 3)
		return -1;
	int ans = 0;
	if ((v == 1) || ((v == 2) && q))
		ans = (1 << bit);
	if (v != 2)
	{
		int edge = bits[bit].getedge(l, r);
		int v1 = vote(l, edge, bit - 1);
		int v2 = vote(edge, r, bit - 1);
		if (v1 == 3) return -1;
		if (v2 == 3) return -1;
		if (v1 != 2 && v2 != 2 && v1 != v2) return -1;
		int qn = 0;
		if (v1 == 1)
			qn = 1;
		if (v2 == 1)
			qn = 1;
		int s1 = solve(l, edge, bit - 1, v1, qn);
		int s2 = solve(edge, r, bit - 1, v2, qn);
		return ans | s1 | s2;
	}
	else
	{
		return ans | solve(l, r, bit - 1, vote(l, r, bit - 1), 0);
	}
	return ans;
}

int main()
{
	cin >> n;
	for (int i = 0; i < n; ++i)
	{
		int t;
		cin >> t;
		inp.push_back(t);
	}

	bits.resize(BITS);
	for (int i = 0; i < BITS; ++i)
	{
		bits[i].w.resize(n);
		for (int b = 0; b < n; ++b)
		{
			bits[i].w[b] = (inp[b] >> i) & 1;
		}
		bits[i].init();
		bits[i].build(0, 0, n);
	}
	int sol = solve(0, n, BITS - 1, vote(0, n, BITS - 1), 0);
	cout << sol << endl;
	if (sol != solve_stupid())
	{
		throw std::exception("oops");
		cout << "TOO BAD!" << endl;
		cout << "Should be " << sol << endl;
	}
	int q;
	cin >> q;
	for (int i = 0; i < q; ++i)
	{
		int v, x;
		cin >> v >> x;
		v--;
		inp[v] = x;
		for (int bit = 0; bit < BITS; ++bit)
		{
			bits[bit].modify(0, 0, n, v, (x >> bit) & 1);
		}
		int sol = solve(0, n, BITS - 1, vote(0, n, BITS - 1), 0);
		cout << sol << endl;
		if (sol != solve_stupid())
		{
			throw std::exception("oops");
			cout << "TOO BAD!" << endl;
			cout << "Should be " << sol << endl;
		}
	}
	return 0;
}