#include <iostream>
#include <vector>
#include <bitset>
#include <set>

using namespace std;

struct diff
{
	vector<int> w;
	vector<bitset<512>> b;
	void init()
	{
		b.resize(w.size() * 4);
	}

	void build(int v, int vl, int vr)
	{
		int vm = (vl + vr) / 2;
		if (vr - vl == 1)
		{
			b[v].set(w[vl], true);
			return;
		}
		build(2 * v + 1, vl, vm);
		build(2 * v + 2, vm, vr);
		b[v] = b[2 * v + 1] | b[2 * v + 2];
	}

	bitset<512> get(int v, int vl, int vr, int l, int r)
	{
		if (vl >= l && vr <= r)
			return b[v];
		if (r <= vl || l >= vr)
			return bitset<512>();
		int vm = (vl + vr) / 2;
		return get(2 * v + 1, vl, vm, l, r) | get(2 * v + 2, vm, vr, l, r);
	}
};

struct sum
{
	vector<int> w;
	vector<int> b;
	void init()
	{
		b.resize(w.size() * 4);
	}

	void build(int v, int vl, int vr)
	{
		int vm = (vl + vr) / 2;
		if (vr - vl == 1)
		{
			b[v] = w[vl];
			return;
		}
		build(2 * v + 1, vl, vm);
		build(2 * v + 2, vm, vr);
		b[v] = b[2 * v + 1] + b[2 * v + 2];
	}

	int get(int v, int vl, int vr, int l, int r)
	{
		if (vl >= l && vr <= r)
			return b[v];
		if (r <= vl || l >= vr)
			return 0;
		int vm = (vl + vr) / 2;
		return get(2 * v + 1, vl, vm, l, r) + get(2 * v + 2, vm, vr, l, r);
	}
};

int main()
{
	int n, m;
	cin >> n >> m;
	vector<int> d1(n);
	vector<int> d2(m);
	vector<int> p1(n);
	vector<int> p2(m);

	int sp1 = 0;
	int sp2 = 0;

	for (int i = 0; i < n; ++i)
	{
		cin >> d1[i];
	}
	for (int i = 0; i < n; ++i)
	{
		cin >> p1[i];
		sp1 += p1[i];
	}
	for (int i = 0; i < m; ++i)
	{
		cin >> d2[i];
	}
	for (int i = 0; i < m; ++i)
	{
		cin >> p2[i];
		sp2 += p2[i];
	}

	/*diff dt1;
	dt1.w = d1;
	dt1.init();
	dt1.build(0, 0, n);
	diff dt2;
	dt2.w = d2;
	dt2.init();
	dt2.build(0, 0, m);

	sum pt1;
	pt1.w = p1;
	pt1.init();
	pt1.build(0, 0, n);
	sum pt2;
	pt2.w = p2;
	pt2.init();
	pt2.build(0, 0, m);*/

	int mp = -1;
	int ml1, ml2, mr1, mr2;

	for (int l1 = 0; l1 < n; ++l1)
	{
		for (int r1 = l1; r1 < n; ++r1)
		{
			for (int l2 = 0; l2 < m; ++l2)
			{
				for (int r2 = l2; r2 < m; ++r2)
				{
					int total = (r1 - l1 + 1) + (r2 - l2 + 1);
					set<int> buf;
					int dist;
					for (int i = l1; i <= r1; ++i)
					{
						if (buf.find(d1[i]) == buf.end())
							buf.insert(d1[i]);
						else
							break;
					}
					for (int i = l2; i <= r2; ++i)
					{
						if (buf.find(d2[i]) == buf.end())
							buf.insert(d2[i]);
						else
							break;
					}
					dist = buf.size();
					//dist = (dt1.get(0, 0, n, l1, r1 + 1) | dt2.get(0, 0, m, l2, r2 + 1)).count();
					if (dist < total)
						continue;
					//int pr = pt1.get(0, 0, n, l1, r1 + 1) + pt2.get(0, 0, m, l2, r2 + 1);
					int pr = 0;
					for (int i = l1; i <= r1; ++i)
					{
						pr += p1[i];
					}
					for (int i = l2; i <= r2; ++i)
					{
						pr += p2[i];
					}
					if (mp < pr)
					{
						mp = pr;
						ml1 = l1;
						ml2 = l2;
						mr1 = r1;
						mr2 = r2;
					}
				}
			}
		}
	}

	if (sp1 > mp)
	{
		mp = sp1;
		ml1 = 0;
		mr1 = n - 1;
		ml2 = -1;
		mr2 = -1;
	}

	if (sp2 > mp)
	{
		mp = sp2;
		ml1 = -1;
		mr1 = -1;
		ml2 = 0;
		mr2 = m - 1;
	}

	cout << mp << endl;
	cout << ml1 + 1 << " " << mr1 + 1 << endl;
	cout << ml2 + 1 << " " << mr2 + 1 << endl;
	return 0;
}