#include <bits/stdc++.h>

#define pb push_back
#define X first
#define Y second
#define all(v) v.begin(), v.end()
#define fors(i, a, b) for (int i = a; i < b; ++i)

using namespace std;

mt19937 rnd(218);

struct Treap {
    Treap *l, *r;
    int cnts, val, key;
    bool rev;

    Treap(int val) : l(0), r(0), cnts(1), val(val), key(rnd() | (rnd() << 16)), rev(false) {
    }
};

int get_cnts(Treap *t) {
    if (t == 0) {
        return 0;
    }

    return t->cnts;
}

void up_cnts(Treap *t) {
    if (t != 0)
        t->cnts = 1 + get_cnts(t->l) + get_cnts(t->r);
}

void push(Treap *t) {
    if (t == 0)
        return;

    if (t->rev) {
        swap(t->l, t->r);
        if (t->l != 0)
            t->l->rev = !t->l->rev;
        if (t->r != 0)
            t->r->rev = !t->r->rev;
        t->rev = false;
    }
}

Treap * merges(Treap *l, Treap *r) {
    if (l == 0) {
        return r;
    }
    if (r == 0) {
        return l;
    }
    push(l);
    push(r);

    if (l->key > r->key) {
        l->r = merges(l->r, r);
        up_cnts(l);

        return l;
    } else {
        r->l = merges(l, r->l);
        up_cnts(r);

        return r;
    }
}

void print(Treap *t) {
    if (t == 0)
        return;

    push(t);
    print(t->l);
    cout << t->val << " ";
    print(t->r);
}

int main() {
    int x;
    Treap *t = 0;
    int cnts = 0;
    while (cin >> x) {
        t = merges(t, new Treap(x));
        cnts++;
    }
    if (cnts > 1e4)
        cout << -1;

    t->rev = true;
    print(t);

    return 0;
}
