#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int INF = (int) 1e9 + 123;
const ll LINF = (ll) 1e18 + 123;

void run();

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	run();
	return 0;
}

const int N = (int) 1e6 + 123;

int n;
int prv[N], nxt[N];
bool vis[N];

int get_prv(int v) {
	if (prv[v] == v) {
		return v;
	}
	
	return prv[v] = get_prv(prv[v]);
}

int get_nxt(int v) {
	if (nxt[v] == v) {
		return v;
	}
	
	return nxt[v] = get_nxt(nxt[v]);
}

bool ok(int pos, int l, int r) {
	int rpos = get_nxt(pos);
	
	if (pos - 1 >= l) {
		if (pos - 1 - get_prv(pos - 1) + 1 > rpos - pos + 1) {
			return true;
		}
	}
	
	if (rpos + 1 <= r) {
		if (get_nxt(rpos + 1) - rpos + 1 > rpos - pos + 1) {
			return true;
		}
	}
	
	return false;
}

bool solve(const string &s, const string &t) {
	n = (int) s.size();
	for (int i = 0; i < n; i++) {
		prv[i] = i;
		nxt[i] = i;
		vis[i] = 0;
	}
	
	for (int i = 0; i < n; i++) {
		int j = i;
		while (j + 1 < n && s[j + 1] == s[j]) j++;
		
		for (int k = i; k <= j; k++) {
			prv[k] = i;
			nxt[k] = j;
		}
		
		i = j;
	}
	
	vector<pair<int, int>> segs;
	
	for (int i = 0; i < n; i++) {
		int j = i;
		while (j + 1 < n && t[j + 1] == t[j]) j++;
		
		if (prv[i] != i || (s[i] != t[i] && i > 0)) {
			return false;
		}
		if (nxt[j] != j || (s[j] != t[j] && j != n - 1)) {
			return false;
		}
		
		segs.push_back({i, j});
		
		i = j;
	}
	
	for (auto &seg : segs) {
		int l = seg.first;
		int r = seg.second;
		
		queue<int> q;
		
		{
			int pos = l;
			while (pos <= r) {
				if (s[pos] != t[pos] && ok(pos, l, r)) {
					vis[pos] = 1;
					q.push(pos);
				}
				
				pos = get_nxt(pos) + 1;
			}
		}
		
		while (!q.empty()) {
			int x = q.front();
			q.pop();
			int y = get_nxt(x);
			
			int xx = x;
			int yy = y;
			
			if (x - 1 >= l) {
				xx = get_prv(x - 1);
			}
			
			if (y + 1 <= r) {
				yy = get_nxt(y + 1);
			}
			
			nxt[xx] = yy;
			prv[yy] = xx;
			
			if (xx - 1 >= l) {
				int x1 = get_prv(xx - 1);
				int y1 = xx - 1;
				if (y1 - x1 < yy - xx && !vis[x1]) {
					q.push(x1);
				}
			}
			
			if (yy + 1 <= r) {
				int x1 = yy + 1;
				int y1 = get_nxt(yy + 1);
				if (y1 - x1 < yy - xx && !vis[x1]) {
					q.push(x1);
				}
			}
		}
		
		if (get_nxt(l) != r) {
			return false;
		}
	}
	
	return true;
}

void run() {
	int q;
	cin >> q;
	for (int i = 0; i < q; i++) {
		string s, t;
		cin >> s >> t;
		cout << (solve(s, t) ? "Yes\n" : "No\n");
	}
}
