#include <bits/stdc++.h>
 
using namespace std;
using pii = pair<int, int>;
using ld = long double;

#define eps 0.0000001

struct Point
{
	ld x, y;
	Point() : x(0), y(0) {}
	Point(ld _x, ld _y) : x(_x), y(_y) {}
};

struct Line
{
	ld a, b, c;

	Line() : a(1), b(0), c(0) {}
	Line(Point p1, Point p2)
	{
		ld v_x = p1.x - p2.x;
		ld v_y = p1.y - p2.y;
		a = -v_y;
		b = v_x;
		c = p1.x * a + p1.y * b;
	}

	int get_point_pos(Point p)
	{
		if (fabs(a * p.x + b * p.y - c) < eps)
			return 0;
		if (a * p.x + b * p.y < c)
			return -1;
		return 1;
	}
};

struct Triangle
{
	Point p1, p2, p3;
	
	Triangle() {}
	Triangle(Point _p1, Point _p2, Point _p3) : p1(_p1), p2(_p2), p3(_p3) {}
	bool point_inside(Point p)
	{
		if (Line(p1, p2).get_point_pos(p3) * Line(p1, p2).get_point_pos(p) < 0)
			return false;
		if (Line(p1, p3).get_point_pos(p2) * Line(p1, p3).get_point_pos(p) < 0)
			return false;
		if (Line(p3, p2).get_point_pos(p1) * Line(p3, p2).get_point_pos(p) < 0)
			return false;
		return true;
	}
};

bool ask(int i, int j, int k)
{
	cout << 3 << " " << i + 1 << " " << j + 1 << " " << k + 1 << endl;
	fflush(stdout);
	string s;
	cin >> s;
	if (s[0] == 'Y')
		return true;
	return false;
}

int main()
{
	int n;
	cin >> n;
	vector<Point> arr(n);
	for (auto &x : arr)
		cin >> x.x >> x.y;
	int q;
	cin >> q;
	for (int z = 0; z < q; ++z)
	{
		bool was_found = false;
		for (int i = 0; i < n; ++i)
		{
			for (int j = i + 1; j < n; ++j)
			{
				for (int k = j + 1; k < n; ++k)
				{
					bool good = true;
					for (int l = 0; l < n; ++l)
						if (l != i && l != j && l != k && Triangle(arr[i], arr[j], arr[k]).point_inside(arr[l]))
						{
							good = false;
							break;
						}
					if (good)
						if (ask(i, j, k))
						{
							was_found = true;
							cout << "! " << 3 << " " << i + 1 << " " << j + 1 << " " << k + 1 << endl;
							break;
						}
				}
				if (was_found)
					break;
			}
			if (was_found)
				break;
		}
	}
}