import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Locale;
import java.util.StringTokenizer;
import java.util.TreeSet;

public class Main {
    public class Edge {
        int u, v, w, color;

        public Edge(int a, int b, int c, int d) {
            u = a;
            v = b;
            w = c;
            color = d;
        }
    }

    public class pair implements Comparable<pair> {
        long d;
        int id;

        public int compareTo(pair p) {
            if (d != p.d) {
                return (int)(d - p.d);
            }
            return id - p.id;
        }

        public pair(long a, int b) {
            d = a;
            id = b;
        }
    }

    public void dxt(int n) {
        for (int i = 1; i < n; i++) {
            d[i] = Long.MAX_VALUE;
        }
        TreeSet<pair> w = new TreeSet<>();
        for (int i = 1; i < n; i++) {
            w.add(new pair(Long.MAX_VALUE, i));
        }
        w.add(new pair(0, 0));
        while (w.size() > 0) {
            pair p = w.pollFirst();
            for (int i = 0; i < q.get(p.id).size(); i++) {
                int u = q.get(p.id).get(i).u;
                int v = q.get(p.id).get(i).v;
                int we = q.get(p.id).get(i).w;
                int color = q.get(p.id).get(i).color;
                if (d[v] > d[u] + we) {
                    w.remove(new pair(d[v], v));
                    d[v] = d[u] + we;
                    for(int j = 0; j < m; j++){
                        predr[v][j] = 0;
                        preds[v][j] = 0;
                    }
                    for (int j = 0; j < m; j++) {
                        if (j != color) {
                            if (preds[u][j] + we * we > preds[v][color]) {
                                preds[v][color] = preds[u][j] + we * we;
                                predr[v][color] = we;
                            }
                        } else {
                            if (preds[v][color] < preds[u][color] - predr[u][color] * predr[u][color] + (predr[u][color] + we) * (predr[u][color] + we)) {
                                predr[v][color] = predr[u][color] + we;
                                preds[v][color] = preds[u][color] - predr[u][color] * predr[u][color] + (predr[u][color] + we) * (predr[u][color] + we);
                            }
                        }
                    }
                    w.add(new pair(d[v], v));
                }
                if (d[v] == d[u] + we) {
                    for (int j = 0; j < m; j++) {
                        if (j != color) {
                            if (preds[u][j] + we * we > preds[v][color]) {
                                preds[v][color] = preds[u][j] + we * we;
                                predr[v][color] = we;
                            }
                        } else {
                            if (preds[v][color] < preds[u][color] - predr[u][color] * predr[u][color] + (predr[u][color] + we) * (predr[u][color] + we)) {
                                predr[v][color] = predr[u][color] + we;
                                preds[v][color] = preds[u][color] - predr[u][color] * predr[u][color] + (predr[u][color] + we) * (predr[u][color] + we);
                            }
                        }
                    }
                }
            }
        }

    }

    int m;
    long[] d;
    long[][] predr;
    long[][] preds;
    ArrayList<ArrayList<Edge>> q = new ArrayList<>();

    public void solve() throws IOException {
        int n = nextInt();
        m = nextInt();
        q = new ArrayList<>();
        for (int i = 0; i < n; i++) {
            q.add(new ArrayList<>());
        }
        for (int i = 0; i < m; i++) {
            int s = nextInt();
            int a = nextInt() - 1;
            for (int j = 0; j < s; j++) {
                int b = nextInt();
                int c = nextInt() - 1;
                q.get(a).add(new Edge(a, c, b, i));
                a = c;
            }
        }
        d = new long[n];

        predr = new long[n][m];
        preds = new long[n][m];
        dxt(n);
        long x = -1;
        for (int i = 0; i < m; i++) {
            x = Math.max(x, preds[n - 1][i]);
        }
        out.print(d[n - 1] + " " + x);
    }

    BufferedReader br;
    StringTokenizer sc;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (sc == null || !sc.hasMoreTokens()) {
            try {
                sc = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                return null;
            }
        }
        return sc.nextToken();
    }

    public Integer nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public Long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }
}