#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

struct point {
	long long x, y;

	point() {}
	point(long long x, long long y) : x(x), y(y) {}

	long long operator %(const point v1) {
		return x * v1.y - y * v1.x;
	}

	point operator +(const point v1) {
		return point(x + v1.x, y + v1.y);
	}

	point operator -(const point v1) {
		return point(x - v1.x, y - v1.y);
	}

	bool operator <(const point v1) {
		return (x * v1.y - y * v1.x < 0);
	}
};



pair <point, int> a[6000];
int n;

inline bool cmp( pair <point, int> v1, pair <point, int> v2) {
	return (v1.first - a[0].first) < (v2.first - a[0].first);
}

vector < pair <point, int> > vip;
vector < pair <point, int> > zp[6000];
vector <int> razn[6000];
int m, l, r, tl, tr, i;
string s;
int cur = 0;

inline void solv() {
	l = 1, r = n - 1;
	while (r - l > 1) {
		m = (r + l) / 2;
		cur++; cout << "? " << zp[m].size() << " ";
		for (i = 0; i < zp[m].size(); i++) {
			cur++; cout << zp[m][i].second + 1 << " ";
		}
		cur++; cout << endl;
		cin >> s;
		if (s[0] == 'Y') {
			r = m;
		}
		else {
			l = m;
		}
	}
	if (r == 2) {
		cur++; cout << "! " << 3 << " " << a[0].second + 1 << " ";
		cur++; cout << a[1].second + 1 << " " << a[2].second + 1 << endl;
		return;
	}
	tl = 0, tr = int(razn[r].size()) - 1;
	while (tr - tl > 1) {
		m = (tl + tr) / 2;
		cur++; cout << "? " << 3 << " " << a[0].second + 1 << " ";
		cur++; cout << razn[r][m] + 1 << " " << a[r].second + 1 << endl;
		cin >> s;
		if (s[0] == 'Y') {
			tl = m;
		}
		else {
			tr = m;
		}
	}
	cur++; cout << "! " << 3 << " " << razn[r][tl + 1] + 1 << " ";
	cur++; cout << razn[r][tl] + 1 << " " << a[r].second + 1 << endl;
	return;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cur++; cout.tie(0);
	cerr.tie(0);
	cin >> n;
	point mini = point((long long)(1e9 + 50000), (long long)(1e9 + 500000));
	int nom;
	for (i = 0; i < n; i++) {
		cin >> a[i].first.x >> a[i].first.y;
		if (a[i].first.x < mini.x || (a[i].first.x == mini.x && a[i].first.y < mini.y)) {
			mini = a[i].first;
			nom = i;
		}
		a[i].second = i;
	}
	swap(a[0], a[nom]);
	sort(a + 1, a + n, cmp);
	vip.push_back(a[0]);
	for (i = 1; i < n; i++) {
		razn[i].assign(n, 0);
		razn[i].resize(0);
		while (vip.size() > 1 && (a[i].first - vip[int(vip.size()) - 2].first) < (vip[int(vip.size()) - 1].first - vip[int(vip.size()) - 2].first)) {
			razn[i].push_back(vip.back().second);
			vip.pop_back();
		}
		razn[i].push_back(vip.back().second);
		reverse(razn[i].begin(), razn[i].end());
		razn[i].push_back(a[0].second);
		vip.push_back(a[i]);
		zp[i] = vip;
	}
	int q;
	cin >> q;
	/*if (q * n == 1e6 + 1000000) {
		return 0;
	}*/
	while (q--) {
		l = 1, r = n - 1;
		while (r - l > 1) {
			m = (r + l) / 2;
			cur++; cout << "? " << zp[m].size() << " ";
			for (i = 0; i < zp[m].size(); i++) {
				cur++; cout << zp[m][i].second + 1 << " ";
			}
			cur++; cout << endl;
			cin >> s;
			if (s[0] == 'Y') {
				r = m;
			}
			else {
				l = m;
			}
		}
		if (cur > 1e7) {
			return 0;
		}
		if (r == 2) {
			cur++; cout << "! " << 3 << " " << a[0].second + 1 << " ";
			cur++; cout << a[1].second + 1 << " " << a[2].second + 1 << endl;
			continue;
		}
		tl = 0, tr = int(razn[r].size()) - 1;
		while (tr - tl > 1) {
			m = (tl + tr) / 2;
			cur++; cout << "? " << 3 << " " << a[0].second + 1 << " ";
			cur++; cout << razn[r][m] + 1 << " " << a[r].second + 1 << endl;
			cin >> s;
			if (s[0] == 'Y') {
				tl = m;
			}
			else {
				tr = m;
			}
		}
		cur++; cout << "! " << 3 << " " << razn[r][tl + 1] + 1 << " ";
		cur++; cout << razn[r][tl] + 1 << " " << a[r].second + 1 << endl;
		continue;
	}
	
}