#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

struct point {
	long long x, y;

	point() {}
	point(long long x, long long y) : x(x), y(y) {}

	long long operator %(const point v1) {
		return x * v1.y - y * v1.x;
	}

	point operator +(const point v1) {
		return point(x + v1.x, y + v1.y);
	}

	point operator -(const point v1) {
		return point(x - v1.x, y - v1.y);
	}

	bool operator <(const point v1) {
		return (x * v1.y - y * v1.x < 0);
	}
};



pair <point, int> a[6000];
int n;

bool cmp( pair <point, int> v1, pair <point, int> v2) {
	return (v1.first - a[0].first) < (v2.first - a[0].first);
}

vector < pair <point, int> > vip;
vector < pair <point, int> > zp[6000];
string s;

vector <int> getr(int nom) {
	vector <int> ret;
	if (zp[nom].size() == zp[nom - 1].size() + 1) {
		ret.push_back(zp[nom - 1].back().second);
		ret.push_back(a[0].second);
		return ret;
	}
	int j = 0;
	for (j = 0; j < n; j++) {
		if (zp[nom][j].second != zp[nom - 1][j].second) {
			break;
		}
	}
	for (; j < zp[nom - 1].size(); j++) {
		ret.push_back(zp[nom - 1][j].second);
	}
	ret.push_back(a[0].second);
	return ret;
}

void solv() {
	int l = 1, r = n - 1;
	while (r - l > 1) {
		int m = (r + l) / 2;
		cout << "? " << zp[m].size() << " ";
		for (int i = 0; i < zp[m].size(); i++) {
			cout << zp[m][i].second + 1 << " ";
		}
		cout << endl;
		cin >> s;
		if (s[0] == 'Y') {
			r = m;
		}
		else {
			l = m;
		}
	}
	vector <int> razn = getr(r);
	if (r == 2) {
		cout << "! " << 3 << " " << a[0].second + 1 << " ";
		cout << a[1].second + 1 << " " << a[2].second + 1 << endl;
		return;
	}
	int tl = 0, tr = int(razn.size()) - 1;
	while (tr - tl > 1) {
		int m = (tl + tr) / 2;
		cout << "? " << 3 << " " << a[0].second + 1 << " ";
		cout << razn[m] + 1 << " " << a[r].second + 1 << endl;
		cin >> s;
		if (s[0] == 'Y') {
			tl = m;
		}
		else {
			tr = m;
		}
	}
	cout << "! " << 3 << " " << razn[tl + 1] + 1 << " ";
	cout << razn[tl] + 1 << " " << a[r].second + 1 << endl;
	return;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cerr.tie(0);
	cin >> n;
	point mini = point((long long)(1e9), (long long)(1e9));
	int nom;
	for (int i = 0; i < n; i++) {
		cin >> a[i].first.x >> a[i].first.y;
		if (a[i].first.x < mini.x || (a[i].first.x == mini.x && a[i].first.y < mini.y)) {
			mini = a[i].first;
			nom = i;
		}
		a[i].second = i;
	}
	swap(a[0], a[nom]);
	sort(a + 1, a + n, cmp);
	/*for (int i = 0; i < n; i++) {
		cout << a[i].first.x << " " << a[i].first.y << endl;
	}*/
	vip.push_back(a[0]);
	for (int i = 1; i < n; i++) {
		while (vip.size() > 1 && (a[i].first - vip[int(vip.size()) - 2].first) < (vip[int(vip.size()) - 1].first - vip[int(vip.size()) - 2].first)) {
			vip.pop_back();
		}
		vip.push_back(a[i]);
		zp[i] = vip;
	}
	/*for (int i = 0; i < vip.size(); i++) {
		cout << vip[i].first.x << " " << vip[i].first.y << endl;
	}*/
	int q;
	cin >> q;
	while (q--) {
		solv();
	}
	
}