#include <stdio.h>
#include <assert.h>
#include <string.h>
#include <inttypes.h>
#include <vector>
#include <random>
#include <algorithm>
#include <functional>

const int N = 1<<20;

int arr[N];
struct node {
    int imp, b;
    node() : imp(0), b(0) {};
} sgt[2*N];

void sgt_merge(int p, int mid)
{
    int l_son = p*2 + 1;
    int r_son = p*2 + 2;

    if (sgt[l_son].b == -1 || sgt[r_son].b == -1) {
        sgt[p].b = -1;
        return;
    }

    int b = arr[mid-1]^arr[mid];
    int imp;
    if (!b) {
        imp = 0;
    } else {
        while (b&(b-1)) b &= (b-1);
        imp = b;
        if (arr[mid]&imp)
            b = 0;
    }

    sgt[p].imp = imp | sgt[l_son].imp | sgt[r_son].imp;
    sgt[p].b = b | sgt[l_son].b | sgt[r_son].b;
    if ( (sgt[p].b & imp) != b ||
         (sgt[p].b & sgt[l_son].imp) != sgt[l_son].b ||
         (sgt[p].b & sgt[r_son].imp) != sgt[r_son].b)
        sgt[p].b = -1;
}

void sgt_build(int p, int l, int r)
{
    if (r - l == 1)
        return;
    int mid = (l+r)/2;
    sgt_build(p*2 + 1, l, mid);
    sgt_build(p*2 + 2, mid, r);
    sgt_merge(p, mid);
}

void sgt_set_val(int p, int l, int r, int i, int val)
{
    if (r - l == 1) {
        assert(i == l);
        arr[i] = val;
    } else {
        int mid = (l+r)/2;
        if (i < mid)
            sgt_set_val(p*2 + 1, l, mid, i, val);
        else
            sgt_set_val(p*2 + 2, mid, r, i, val);
        sgt_merge(p, mid);
    }
}

int main()
{
    int n; scanf("%d", &n);
    for (int i = 0; i < n; ++i)
        scanf("%d", arr+i);

    sgt_build(0, 0, n);
    printf("%d\n", sgt[0].b);

    int q; scanf("%d", &q);
    while (q --> 0) {
        int p, v; scanf("%d%d", &p, &v), --p;
        sgt_set_val(0, 0, n, p, v);
        printf("%d\n", sgt[0].b);
    }

    return 0;
}
