#include <stdio.h>
#include <assert.h>
#include <string.h>
#include <inttypes.h>
#include <vector>
#include <random>
#include <algorithm>
#include <functional>

const int N = 1<<10;

struct edge_t {
    int v, u, tm;
} edges[N];

struct dist_t {
    int tm;
    int64_t qu;
    dist_t() : tm(1<<30), qu(-1) {};
    dist_t(int _tm, int64_t _qu) :
        tm(_tm), qu(_qu) {};
} dists[N];

bool operator<(const dist_t& a, const dist_t& b)
{
    if (a.tm != b.tm) return a.tm < b.tm;
    return a.qu > b.qu;
}

dist_t add(const dist_t& d, int tm)
{
    return dist_t(d.tm + tm, d.qu + (int64_t)tm*tm);
}

int main()
{
    int n, m; scanf("%d%d", &n, &m);

    for (int i = 0; i < m; ++i) {
        int s; scanf("%d", &s);
        assert(s == 1);
        int v, t, u; scanf("%d%d%d", &v, &t, &u), --v, --u;
        edges[i] = {v, u, t};
    }

    dists[0] = dist_t(0, 0);

    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j) {
            dist_t d = add(dists[edges[j].v], edges[j].tm);
            if (d < dists[edges[j].u])
                dists[edges[j].u] = d;
        }

    printf("%d %lld\n", dists[n-1].tm, dists[n-1].qu);

    return 0;
}
