#include <iostream>
#include <vector>
#include <array>

using namespace std;

const long long c = 1000000000;
const long long INF = 1000000000000000000;

int a, a1;
vector<long long> dpk;

void build() {
	a1 = 1;
	while (a1 < a) a1 *= 2;
	dpk.resize(2 * a1, INF);
}

void update(int i, long long val) {
	int v = i + a1;
	dpk[v] = val;
	while (v > 1) {
		v /= 2;
		dpk[v] = min(dpk[2 * v], dpk[2 * v + 1]);
	}
}

long long get_min(int l, int r, int vl, int vr, int v) {
	if (vl >= r || vr <= l) {
		return INF;
	}
	if (vl >= l && vr <= r) {
		return dpk[v];
	}
	int vm = (vl + vr) / 2;
	return min(get_min(l, r, vl, vm, 2 * v), get_min(l, r, vm, vr, 2 * v + 1));
}

int main()
{
	int n;
	cin >> n >> a;
	a++;
	vector<array<int, 3> > v(n);
	for (int i = 0; i < n; i++) {
		cin >> v[i][0] >> v[i][1] >> v[i][2];
	}
	vector<long long> dp(a);
	build();
	for (int i = 0; i < a; i++) {
		update(i, 0);
	}
	for (int i = a - 1; i >= 0; i--) {
		for (int j = 0; j < n; j++) {
			int l = v[j][0];
			int r = v[j][1];
			int w = v[j][2];
			if (i + r > a - 1) {
				if (dp[i] == 0) {
					update(i, c * i);
				}
				continue;
			}
			/*long long now_c = INF;
			for (int k = i + l; k <= i + r; k++) {
				now_c = min(now_c, dpk[k + a1]);
			}*/
			long long now_c = get_min(i + l, i + r + 1, 0, a1, 1);
			if (dp[i] < now_c - c * i - w) {
				dp[i] = now_c - c * i - w;
				update(i, dp[i] + c * i);
			}
		}
	}
	cout << dp[0] << endl;
    return 0;
}

