#include <algorithm>
#include <iostream>
#include <iterator>
#include <cstdio>
#include <vector>
#include <set>
using namespace std;


string s, t;
int n;
set <pair <int, int> > blocks;
set <pair <int, int> > valid_blocks;

int len(pair <int, int> A) {
	return A.second - A.first + 1;
}

void check(int l, int r) {
	// cout << "\t" << l << r << endl;
	if (s[l] == t[l])
		return;
	pair <int, int> cur = {l, r};
	auto it = blocks.lower_bound(cur);
	if (r != n - 1) {
		if (len(*(next(it))) > len(cur)) {
			valid_blocks.insert(cur);
		}
	}
	if (l != 0) {
		if (len(*(prev(it))) > len(cur)) {
			valid_blocks.insert(cur);
		}
	}
}

void check(pair <int, int> A) {
	check(A.first, A.second);
}
void merge(pair <int, int> cur) {
	// pair <int, int> prev_cur = b
	auto it = blocks.lower_bound(cur);
	if (cur.second != n - 1) {
		valid_blocks.erase(*next(it));
	}
	if (cur.first != 0) {
		valid_blocks.erase(*prev(it));
	}
	if (cur.second < n - 1) {
		cur.second = (*(next(it))).second;
		blocks.erase(next(it));
		blocks.erase(it);
		blocks.insert(cur);
	}
	it = blocks.lower_bound(cur);
	if (cur.first > 0) {		
		cur.first = (*(prev(it))).first;
		blocks.erase(prev(it));
		blocks.erase(it);
		blocks.insert(cur);
	}
	it = blocks.lower_bound(cur);
	// cout << "Here" << endl;
	// cout << cur.first << " " << cur.second << endl;
	if (cur.second != n - 1) {
		// cout << "Here" << endl;
		check(*next(it));
	}
	if (cur.first != 0) {
		check(*prev(it));
	}
	// if (s[cur.first] != t[cur.first])
	// check(cur.first, cur.second);
} 

string sol() {
	cin >> s >> t;
	blocks.clear();
	n = s.size();

	set <int> lims_s; lims_s.insert(n); lims_s.insert(0); 
	set <int> lims_t; lims_t.insert(n); lims_t.insert(0);

	for (int i = 1; i < n; i++) {
		if (s[i - 1] != s[i]) {
			lims_s.insert(i);
		}
	}
	for (int i = 1; i < n; i++) {
		if (t[i - 1] != t[i]) {
			lims_t.insert(i);
		}
	}
	for (auto x : lims_t) {
		if (lims_s.count(x) < 1)
			return "No";
	}

	for (int i = 0; i < n; i++) {
		if (i == 0 || s[i] != s[i - 1]) {
			int cnt = 0;
			for (int j = i; j < n; j++) {
				if (s[i] == s[j])
					cnt++;
				else
					break;
			}
			blocks.insert({i, i + cnt - 1});
		}
	}
	for (auto x : blocks) {
		// cout << "HERE " << x.first << " " << x.second << endl;

	}

	for (auto x : blocks) {
		if (s[x.first] != t[x.first]) {
			// cout << x.first << " " << x.second << endl;
			check(x.first, x.second);
		}
	}
	// cout << valid_blocks.size() << endl;

	while (!valid_blocks.empty()) {
		auto cur = *(valid_blocks.begin());
		valid_blocks.erase(cur);
		// cout << "\t\t " << cur.second << endl;
		for (int i = cur.first; i <= cur.second; i++) {
			s[i] = t[cur.first];
		}
		merge(cur);
	}

	if (s == t)
		return "Yes";
	return "No";


}

int main() {
	freopen("storage.in", "r", stdin);
	freopen("storage.out", "w", stdout);

	int n;
	cin >> n;
	for (int i = 0; i < n; i++) {
		cout << sol() << endl;
	}

	fclose(stdin);
	fclose(stdout);
	return 0;
}