// A.cpp : Defines the entry point for the console application.
//

#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <algorithm>

using namespace std;

struct frg
{
	int ln;
	char type;
	bool used;
	//int num;

	frg(int _ln, char _type)//, int _num)
	{
		ln = _ln;
		type = _type;
		used = false;
		//num = _num;
	}

	frg() {}
};

vector<frg> conv(string now)
{
	vector<frg> ret;
	int l = 0, r = 0;
	while (l < now.size())
	{
		while (r < now.size() - 1 && now[r + 1] == now[r])
		{
			++r;
		}
		ret.push_back(frg(r - l + 1, now[l]));
		l = r + 1;
		r = l;
	}
	return ret;
}

string s;
string f;
vector<frg> arr;
int cnt;
vector<int> p;
vector<int> sz;
vector<int> getsz;
vector<pair<int, int> > bond;

int getp(int now)
{
	if (p[now] == now)
	{
		return now;
	}

	int pr = getp(p[now]);
	p[now] = pr;
	return pr;
}

void st_u(int i1, int i2)
{
	int p1 = getp(i1);
	int p2 = getp(i2);

	if (p1 == p2)
	{
		return;
	}

	if (sz[p1] > sz[p2])
	{
		p[p2] = p1;
		getsz[p1] += getsz[p2];
		sz[p1] = max(sz[p2] + 1, sz[p1]);
		bond[p1].first = min(bond[p1].first, bond[p2].first);
		bond[p1].second = max(bond[p1].second, bond[p2].second);
	}
	else
	{
		p[p1] = p2;
		getsz[p2] += getsz[p1];
		sz[p2] = max(sz[p2], sz[p1] + 1);
		bond[p2].first = min(bond[p1].first, bond[p2].first);
		bond[p2].second = max(bond[p1].second, bond[p2].second);
	}
}


bool check(int ind)
{
	bool ret = false;
	if (ind > 0 && getsz[getp(ind - 1)] > arr[ind].ln)
	{
		ret = true;
	}
	if (ind < arr.size() - 1 && getsz[getp(ind + 1)] > arr[ind].ln)
	{
		ret = true;
	}
	return ret;
}

void refresh(int ind)
{
	arr[ind].used = true;

	bool changed = true;

	if (ind > 0)
	{
		st_u(ind, ind - 1);
	}
	if (ind < arr.size() - 1)
	{
		st_u(ind, ind + 1);
	}


	for (int i = 0; i < 3; ++i)
	{
		changed = false;
		int ii1 = bond[getp(ind)].first;
		int ii2 = bond[getp(ind)].second;

		if (ii1 > 0 && check(ii1 - 1) && !arr[ii1 - 1].used)
		{
			refresh(ii1 - 1);
			changed = true;
		}



		if (ii2 < arr.size() - 1 && check(ii2 + 1) && !arr[ii2 + 1].used)
		{
			refresh(ii2 + 1);
			changed = true;
		}
	}
}

int main()
{

	int q;
	cin >> q;
	for (int o = 0; o < q; ++o)
	{
		cin >> s >> f;
		arr = conv(s);
		p.clear();
		p.resize(arr.size());
		sz.clear();
		sz.resize(arr.size());
		getsz.clear();
		getsz.resize(arr.size());
		bond.clear();
		bond.resize(arr.size());

		for (int i = 0; i < arr.size(); ++i)
		{
			p[i] = i;
			sz[i] = 0;
			getsz[i] = arr[i].ln;
			bond[i] = { i, i };
		}

		for (int i = 0; i < arr.size(); ++i)
		{
			if (arr[i].type == '-' && !arr[i].used && check(i))
			{
				refresh(i);
			}
		}

		string res = "Yes";
		for (int i = 0; i < arr.size(); ++i)
		{
			if (arr[i].type == '-' && !arr[i].used)
			{
				res = "No";
			}
		}
		cout << res << endl;
		cnt = 0;
	}
    return 0;
}

//++-+---+-------------++-+---++++++++++++++++++