#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <queue>
#include <set>
using namespace std;
#define rep(i, n) for (int i = 0; i < n; i++)
#define repp(i, a, b) for (int i = a; i < b; i++)
#define all(v) v.begin(), v.end()
typedef long long ll;
typedef pair<int, int> pii;
struct SEG {
	int l, r;
	ll sum;
	SEG(int _l, int _r, ll _sum) {
		l = _l;
		r = _r;
		sum = _sum;
	}
	bool operator < (const SEG &s) const {
		return l < s.l;
	}
};
struct SEG2 {
	int l, r;
	ll sum;
	SEG2(int _l, int _r, ll _sum) {
		l = _l;
		r = _r;
		sum = _sum;
	}
	bool operator < (const SEG2 &s) const {
		if (sum == s.sum) return l < s.l;
		return sum > s.sum;
	}
};
int main() {
	ios_base::sync_with_stdio(0);
	//freopen("internship.in", "r", stdin);
	//freopen("internship.out", "w", stdout);
	int n, m;
	cin >> n >> m;
	vector<int> d1(n), c1(n), d2(m), c2(m);
	rep(i, n) cin >> d1[i];
	rep(i, n) cin >> c1[i];
	rep(i, m) cin >> d2[i];
	rep(i, m) cin >> c2[i];
	vector<ll> psum1(n + 1), psum2(m + 1);
	repp(i, 1, n + 1) psum1[i] = psum1[i - 1] + c1[i - 1];
	repp(i, 1, m + 1) psum2[i] = psum2[i - 1] + c2[i - 1];
	vector<int> pos(n + m + 1, -1);
	rep(i, m) pos[d2[i]] = i;
	ll curs = 0, ans = 0;
	int la, lb, ra, rb;
	set<SEG> ss1;
	set<SEG2> ss2;
	rep(i, n) {
		curs = 0;
		SEG s1(0, m - 1, psum2[m]);
		SEG2 s2(0, m - 1, psum2[m]);
		ss1.clear();
		ss2.clear();
		ss1.insert(s1);
		ss2.insert(s2);
		repp(j, i, n) {
			curs += c1[j];
			int p = pos[d1[j]];
			if (p != -1) {
				auto it = ss1.upper_bound(SEG(p, 0, 0));
				it--;
				int l = it->l, r = it->r;
				ll sum = it->sum;
				ss1.erase(it);
				ss2.erase(SEG2(l, r, sum));
				if (p != l || p != r) {
					if (p == l) {
						sum -= c2[p];
						ss1.insert(SEG(p + 1, r, sum));
						ss2.insert(SEG2(p + 1, r, sum));
					}
					else if (p == r) {
						sum -= c2[p];
						ss1.insert(SEG(l, p - 1, sum));
						ss2.insert(SEG2(l, p - 1, sum));
					}
					else {
						ll sum1 = psum2[p] - psum2[l];
						ll sum2 = psum2[r + 1] - psum2[p + 1];
						ss1.insert(SEG(l, p - 1, sum1)); 
						ss1.insert(SEG(p + 1, r, sum2));
						ss2.insert(SEG2(l, p - 1, sum1));
						ss2.insert(SEG2(p + 1, r, sum2));
					}
				}
			}
			if (ss2.empty()) {
				if (curs > ans) {
					ans = curs;
					la = i; ra = j;
					rb = lb = -1;
				}
			}
			else {
				auto it = ss2.begin();
				if (curs + it->sum > ans) {
					ans = curs + it->sum;
					la = i; ra = j;
					lb = it->l; rb = it->r;
				}
			}
		}
	}
	int s = 0;
	rep(i, m) s += c2[i];
	if (s > ans) {
		ans = s;
		la = ra = -1;
		lb = 0; rb = m - 1;
	}
	cout << ans << endl << la + 1 << " " << ra + 1 <<
		endl << lb + 1 << " " << rb + 1;
}