#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <algorithm>
#include <utility>
#include <string>
#include <vector>



using namespace std;

struct pt {
	long long x, y;
	pt() {}
	pt(int _x, int _y) {
		x = _x, y = _y;
	}
	long long operator % (pt b) {
		return x * b.y - y * b.x;
	}
	bool operator < (pt b) {
		return (x == b.x ? y < b.y : x < b.x);
	}
	pt operator - (pt b) {
		return pt(x - b.x, y - b.y);
	}
};

bool ask(vector<int> &t) {
	cout << "? " << (int)t.size() << " ";
	for (auto i : t) {
		cout << i + 1 << " ";
	}
	cout << endl;
	string s;
	cin >> s;
	if (s == "Yes")
		return true;
	return false;
}

pt x;

vector<pt> g;

bool cmp2(int a, int b) {
	return g[a] < g[b];
}
bool cmp(int a, int b) {
	pt q = g[a];
	pt w = g[b];
	pt xq = q - x;
	pt qw = w - q;
	if (xq % qw > 0) {
		return true;
	}
	return false;
}

vector<int> convex(vector<int> t) {
	sort(t.begin(), t.end(), cmp2);
	x = g[t[0]];
	sort(t.begin() + 1, t.end(), cmp);
	vector<int> st;
	st.push_back(t[0]);
	for (int i = 1; i < (int)t.size(); i++) {
		while (st.size() > 1) {
			pt c1 = g[st.back()] - g[st[(int)st.size() - 2]];
			pt c2 = g[t[i]] - g[st.back()];
			if (c1 % c2 <= 0)
				st.pop_back();
			else
				break;
		}
		st.push_back(t[i]);
	}
	return st;
}


bool is(vector<pt> g, pt x) {
	long long s = 0;
	for (int i = 0; i < g.size(); i++) {
		pt a1 = g[i] - x;
		pt a2 = g[(i + 1) % g.size()] - x;
		s += abs(a1 % a2);
	}
	return s == abs((g[1] - g[0]) % (g.back() - g[0]));
}
void rec(vector<int> t) {
	if (t.size() == 3) {
		t = convex(t);
		cout << "! 3 ";
		for (auto i : t) {
			cout << i + 1 << " ";
		}
		cout << endl;
		return;
	}
	sort(t.begin(), t.end(), cmp2);
	x = g[t[0]];
	sort(t.begin() + 1, t.end(), cmp);
	int p = rand() % t.size();
	pt xx = g[t[p]];
	int pp = t[p];
	t.erase(t.begin() + p);
	for (int i = 0; i < t.size(); i++) {
		pt a1 = g[t[i]];
		pt a2 = g[t[(i + 1) % t.size()]];
		pt a3 = xx;
		vector<pt> cur = { a1, a2, a3 };
		vector<int> s;
		for (int i = 0; i < (int)t.size(); i++) {
			if (is(cur, g[t[i]])) {
				s.push_back(t[i]);
			}
		}
		s.push_back(pp);
		vector<int> r = convex(s);
		if (r.size() < 3)
			continue;
		if (ask(r)) {
			rec(s);
			break;
		}
	}

}

int main() {
	srand(1337);
	int n;
	cin >> n;
	g.resize(n);
	vector<int> t(n);
	for (int i = 0; i < n; i++) {
		cin >> g[i].x >> g[i].y;
		t[i] = i;
	}
	int m;
	cin >> m;
	while (m--) {
		rec(t);
	}
	return 0;
}