#include <iostream>
#include <cstdio>
#include <vector>
#include <memory.h>
#include <cmath>
#include <algorithm>

using namespace std;

const int INF = 1e9 + 7, maxn = 1e3 + 7;

int n, pr[maxn];
bool used[maxn];
vector <vector <pair <int, int>>> adj_list;
vector <int> d;

void Dijkstra(int v) {
    d[v] = 0;
    for (int i = 0; i < n; ++i) {
        int mx = -1, a;
        for (int j = 0; j < n; ++j) {
            if (!used[j] && d[j] != INF && d[j] > mx) {
                mx = d[j];
                a = j;
            }
        }
        used[a] = true;
        for (auto b : adj_list[a]) {
            int u = b.first, w = b.second;
            if (d[u] > d[a] + w) {
                pr[u] = a;
                d[u] = d[a] + w;
            }
        }
    }
}

int main()
{
    //freopen("input.txt", "r", stdin);
    freopen("trains.in", "r", stdin);
    freopen("trains.out", "w", stdout);
    ios_base::sync_with_stdio(0);
    int m;
    cin >> n >> m;
    adj_list.resize(n + 1);
    d.resize(n + 1, INF);
    for (int i = 1; i <= n; ++i) {
        pr[i] = -1;
    }
    for (int i = 0; i < m; ++i) {
        int si;
        cin >> si;
        int v;
        cin >> v;
        for (int j = 0; j < si; ++j) {
            int t, u;
            cin >> t >> u;
            adj_list[v].push_back({u, t});
            v = u;
        }
    }
    Dijkstra(1);
    int ans = 0, v = n;
    while (v != -1) {
        int u = pr[v], mn = -1;
        //cout << u << " " << v << endl;
        if (u != -1) {
            for (auto a : adj_list[u]) {
                int b = a.first, w = a.second;
                if (b == v) {
                    if (mn == -1 || w < mn) {
                        mn = w;
                    }
                }
            }
            ans += mn * mn;
        }
        v = u;
    }
    cout << d[n] << " " << ans << endl;
    return 0;
}
