import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Random;
import java.util.StringTokenizer;

public class C {

	private class Point {
		public final int x, y, n;

		public Point(int x, int y, int n) {
			this.x = x;
			this.y = y;
			this.n = n;
		}

		public boolean equals(Point o) {
			return n == o.n;
		}
	}
	
	private void solve() throws IOException {
		final int n = nextInt();
		final Point[] p = new Point[n];
		for (int i = 0; i < n; i++) {
			p[i] = new Point(nextInt(), nextInt(), i + 1);
		}
		
		final int q = nextInt();
		Random ra = new Random(0);
		
		for (int i = 0; i < q; i++) {
			tiger : for (int j = 0; j < n; j++) {
				j = ra.nextInt(n);
				final Point[] pc = p.clone();
				final Point qu = p[j];
				Arrays.sort(pc, new Comparator<Point>() {

					@Override
					public int compare(Point o1, Point o2) {
						if (o1.equals(qu)) {
							return 1;
						}
						if (o2.equals(qu)) {
							return -1;
						}
						return Double.compare(Math.atan2(o1.y - qu.y, o1.x - qu.x), Math.atan2(o2.y - qu.y, o2.x - qu.x));
					}
				});
				for (int k = 0; k <= n - 1; k++) {
					int nx = (k + 1) % (n - 1);
					if (	(pc[k].x - qu.x) * (pc[nx].y - qu.y) - 
							(pc[k].y - qu.y) * (pc[nx].x - qu.x) > 0) {
						out.println("? 3 " + qu.n + " " + pc[k].n + " " + pc[nx].n);
						out.flush();
						if (nextToken().equals("Yes")) {
							out.println("! 3 " + qu.n + " " + pc[k].n + " " + pc[nx].n);
							out.flush();
							break tiger;
						}
					}
				}
			}
		}
	}
	
	private final BufferedReader in;
	private final PrintWriter out;
	private StringTokenizer st;
	
	private String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(in.readLine());
		}
		return st.nextToken();
	}
	
	private int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}
	
	private C() throws IOException {
		in = new BufferedReader(new InputStreamReader(System.in));
		out = new PrintWriter(System.out);
		
		solve();
		
		in.close();
		out.close();
	}
	
	public static void main(final String[] args) throws IOException {
		new C();
	}

}
/*
6
3 0
0 2
2 4
4 2
5 5
6 1
4

6
3 0
0 2
2 4
4 2
5 5
6 1
1
*/