#include <iostream>
#include <vector>
#include <string>

using namespace std;

struct Elem
{
	int cnt;
	bool sign1, sign2;
	Elem *prev, *next;

	Elem(int _cnt = 0, bool _sign1 = false, bool _sign2 = false, Elem *_prev = 0, Elem *_next = 0) : cnt(_cnt), sign1(_sign1), sign2(_sign2), prev(_prev), next(_next) {}
};

struct List
{
	Elem *root, *end;

	List() : root(new Elem), end(root) {}

	void push(int cnt, bool sign1, bool sign2, Elem *prev = 0)
	{
		if (prev == 0)
		{
			Elem *nw = new Elem(cnt, sign1, sign2, end);
			end->next = nw;
			end = nw;
		}
		else
		{
			Elem *nw = new Elem(cnt, sign1, sign2, prev, prev->next);
			prev->next->prev = nw;
			prev->next = nw;
		}
	}

	Elem *pop(Elem *elem)
	{
		elem->prev->next = elem->next;
		if (elem->next != 0)
			elem->next->prev = elem->prev;
		Elem *ret = elem->prev;
		delete elem;
		return ret;
	}

	void print(ostream &out)
	{
		for (auto curr = root->next; curr != 0; curr = curr->next)
			out << '(' << curr->cnt << ", " << (curr->sign1 ? '+' : '-') << ", " << (curr->sign1 ? '+' : '-') << ") ";
	}
};

Elem *transform(List &ls, Elem *elem);

bool get(List &ls, Elem *elem, int req)
{
	if (elem->cnt > req)
		return true;
	if (elem->next == 0)
		return false;
	elem = transform(ls, elem->next);
	if (elem == 0)
		return false;
	return elem->cnt > req;
}

Elem *transform(List &ls, Elem *elem)
{
	if (elem != ls.root->next && elem->prev->cnt > elem->cnt)
	{
		elem->prev->cnt += elem->cnt;
		if (elem->next != 0)
		{
			elem->prev->cnt += elem->next->cnt;
			ls.pop(elem->next);
		}
		return ls.pop(elem);
	}
	if (elem->next == 0)
		return 0;
	if (get(ls, elem->next, elem->cnt))
	{
		elem->next->cnt += elem->cnt;
		if (elem->prev != ls.root)
		{
			elem->next->cnt += elem->prev->cnt;
			ls.pop(elem->prev);
		}
		Elem *ret = elem->next;
		ls.pop(elem);
		return ret;
	}
	return 0;
}

int main()
{
	int q;
	cin >> q;
	for (; q > 0; --q)
	{
		string s, t;
		cin >> s >> t;
		List ls, lt;
		bool flag = false;
		for (int i = 0; i < s.size();)
		{
			int j;
			for (j = i + 1; j < s.size() && s[j] == s[i]; ++j)
			{
				if (t[j] != t[i])
				{
					flag = true;
					break;
				}
			}
			if (flag)
				break;
			ls.push(j - i, s[i] == '+', t[i] == '+');
			i = j;
		}
		if (flag)
		{
			cout << "No\n";
			continue;
		}
		for (auto curr = ls.root->next; curr != ls.end; curr = curr->next)
		{
			if (curr->sign1 != curr->sign2 && curr->next->sign1 != curr->next->sign2)
			{
				flag = true;
				break;
			}
		}
		if (flag)
		{
			cout << "No\n";
			continue;
		}
		/*while (true)
		{
			bool flag2 = true;
			for (Elem *it = ls.root->next; it != 0; it = it->next)
			{
				if (it->sign1 != it->sign2)
				{
					if (it != ls.root->next && it->prev->cnt > it->cnt)
					{
						flag2 = false;
						int cnt = it->cnt;
						if (it != ls.end)
						{
							cnt += it->next->cnt;
							ls.pop(it->next);
						}
						it->prev->cnt += cnt;
						it = ls.pop(it);
					}
					else if (it != ls.end && it->next->cnt > it->cnt)
					{
						flag2 = false;
						int cnt = it->cnt;
						if (it != ls.root->next)
						{
							cnt += it->prev->cnt;
							ls.pop(it->prev);
						}
						it->next->cnt += cnt;
						it = ls.pop(it);
					}
				}
			}
			if (flag2)
				break;
		}*/
		for (auto curr = ls.root->next; curr != 0; curr = curr->next)
		{
			if (curr->sign1 != curr->sign2)
			{
				curr = transform(ls, curr);
				if (curr == 0)
				{
					flag = true;
					break;
				}
			}
		}
		if (flag)
			cout << "No\n";
		else
			cout << "Yes\n";
	}
    return 0;
}

