#include <iostream>
#include <vector>


using namespace std;


vector <vector <int> > table(30);
vector <vector <int> > tree(30);
vector <int> ans(30);
int n;


void build(int v, int tl, int tr, int i)
{
    if (tl == tr)
    {
        tree[i][v] = table[i][tl];
    }
    else
    {
        int mid = (tl + tr) / 2;
        build(v * 2, tl, mid, i);
        build(v * 2 + 1, mid + 1, tr, i);
        tree[i][v] = tree[i][v * 2] + tree[i][v * 2 + 1];
    }
}
int sum(int v, int tl, int tr, int l, int r, int i)
{
    if (l == tl && r == tr)
    {
        return tree[i][v];
    }
    if (l > r)
    {
        return 0;
    }
    int mid = (tl + tr) / 2;
    return sum(v * 2, tl, mid, l, min(r, mid), i) + sum(v * 2 + 1, mid + 1, tr, max(mid + 1, l), r, i);
}
void update(int v, int tl, int tr, int pos, int val, int i)
{
    if (tl == tr)
    {
        tree[i][v] = val;
    }
    else
    {
        int mid = (tl + tr) / 2;
        if (pos <= mid)
        {
            update(v * 2, tl, mid, pos, val, i);
        }
        else
        {
            update(v * 2 + 1, mid + 1, tr, pos, val, i);
        }
        tree[i][v] = tree[i][v * 2] + tree[i][v * 2 + 1];
    }
}
void step(int row, int a, int b)
{
    if (sum(1, 0, n - 1, a, a, row) == 0)
    {
        cout << "LUL";
        int l = a, r = b + 1, m;
        while (r - l > 1)
        {
            m = (l + r) / 2;
            if (sum(1, 0, n - 1, a, m, row) == 0)
            {
                l = m;
            }
            else
            {
                r = m;
            }
        }
        if (l != b)
        {
            if (ans[row] != 2 && ans[row] != 0)
            {
                ans[row] = -1;
            }
            else
            {
                ans[row] = 0;
                if (row != 0)
                {
                    step(row - 1, a, l);
                    step(row - 1, l + 1, b);
                }
            }
        }
        else if (row != 0)
        {
            step(row - 1, a, b);
        }
    }
    else
    {
        cout << "LUL";
        int l = a, r = b + 1, m;
        while (r - l > 1)
        {
            if (sum(1, 0, n - 1, a, m, row) == m - a + 1)
            {
                l = m;
            }
            else
            {
                r = m;
            }
        }
        if (l != b)
        {
            if (ans[row] != 2 && ans[row] != 1)
            {
                ans[row] = -1;
            }
            else
            {
                ans[row] = 1;
                if (row != 0)
                {
                    step(row - 1, a, l);
                    step(row - 1, l + 1, b);
                }
            }
        }
        else if (row != 0)
        {
            step(row - 1, a, b);
        }
    }
}
void solve()
{
    int i, o = 0;
    for (i = 0; i < 30; i++)
    {
        ans[i] = 2;
    }
    step(29, 0, n - 1);
    i = 0;
    while (i < 30 && ans[i] != -1)
    {
        i++;
    }
    if (i != 30)
    {
        cout << -1 << endl;
    }
    else
        {
        for (i = 0; i < 30; i++)
        {
            if (ans[i] == 2)
            {
                ans[i] = 0;
            }
            o *= 2;
            o += ans[i];
        }
        cout << o << endl;
    }
}
int main()
{
    int i, temp, j, q, pos, val;
    cin >> n;
    for (i = 0; i < 30; i++)
    {
        table[i].resize(n);
        tree[i].resize(n * 2);
    }
    for (i = 0; i < n; i++)
    {
        cin >> temp;
        for (j = 0; j < 30; j++)
        {
            table[j][i] = temp % 2;
            temp /= 2;
        }
    }
    for (i = 0; i < 30; i++)
    {
        build(1, 0, n - 1, i);
    }
    solve();
    cin >> q;
    for (i = 0; i < q; i++)
    {
        cin >> pos >> val;
        for (j = 0; j < 30; j++)
        {
            update(1, 0, n - 1, pos - 1, val % 2, j);
            val /= 2;
        }
        solve();
    }
    return 0;
}
