#include <bits/stdc++.h>

using std::cin;
using std::cout;
using std::cerr;
using std::abs;
using std::min;
using std::max;
using std::pair;
using std::swap;
using std::vector;
using std::set;
using std::map;
using std::string;

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

#define ff first
#define ss second
#define pb emplace_back
#ifdef LOCAL
#define dbg(as...) {\
	std::stringstream _ss(#as);\
	vector<string> _v;\
	string _cur, _loc;\
	while (getline(_ss, _cur, ',')) {\
		while (count(_cur.begin(), _cur.end(), '(') != count(_cur.begin(), _cur.end(), ')')) {\
			getline(_ss, _loc, ',');\
			_cur += "," + _loc;\
		}\
		_v.pb(_cur);\
	}\
	err(_v.begin(), as);\
}
#else 
#define dbg(as...) {}
#endif

template<typename T> 
void err(vector<string>::iterator it, T a) {
	cerr << *it << " = " << a << '\n';
}

template<typename T, typename...Ts>
void err(vector<string>::iterator it, T a, Ts...as) {
	cerr << *it << " = " << a << ',';
	err(++it, as...);
}

struct init{
	init() {
		std::iostream::sync_with_stdio(0);
		cin.tie(0);
		cout << std::fixed << std::setprecision(10);
		cerr << std::fixed << std::setprecision(3);
		srand(300);
	}
} init;

const int MAXN = 1e5 + 1;
#ifdef LOCAL
const int MAXB = 5;
#else
const int MAXB = 30;
#endif
struct segmenttree{
	vector<char> in, de, ch;
	int n, sh;
	segmenttree() {}
	void build(int v, int tl, int tr) {
		// dbg(v, tl, tr);
		if (tl == tr) return;
		int tm = tl + tr >> 1;
		build(v + v, tl, tm);
		build(v + v + 1, tm + 1, tr);
		in[v] = in[v + v] && in[v + v + 1] && ch[tm + 1] != -1;
		de[v] = de[v + v] && de[v + v + 1] && ch[tm + 1] != +1;
		// dbg(v, tl, tr, (int)in[v], (int)de[v]);
	}
	segmenttree(const vector<char> _ch) {
		n = _ch.size();
		if (n == 1) sh = 1;
		else sh = 1 << 32 - __builtin_clz(n - 1);
		in.resize(sh + sh, 1);
		de.resize(sh + sh, 1);
		ch = _ch;
		build(1, 0, n - 1);
	}
	void upd(int v, int tl, int tr, int i) {
		if (tl == tr) return;
		dbg(v, tl, tr, i);
		int tm = tl + tr >> 1;
		if (i <= tm) upd(v + v, tl, tm, i);
		else upd(v + v + 1, tm + 1, tr, i);
		in[v] = in[v + v] && in[v + v + 1] && ch[tm + 1] != -1;
		de[v] = de[v + v] && de[v + v + 1] && ch[tm + 1] != +1;
	}
};

int a[MAXN];
segmenttree sts[MAXB];
bool ch2[MAXN];
vector<char> chs[MAXB + 1];
int32_t main() {

	int n;
	cin >> n;
	for (int i = 0; i < n; ++i) cin >> a[i];
	chs[MAXB].resize(n, 0);
	int ans = 0;
	for (int bit = MAXB - 1; bit >= 0; --bit) {
		vector<char> ch = chs[bit + 1];
		for (int i = 1; i < n; ++i) {
			if (ch[i] != 0) ch[i] = 17;
			else ch[i] = (a[i] >> bit & 1) - (a[i - 1] >> bit & 1);
		}
		sts[bit] = ch;
		chs[bit] = ch;
		// dbg(bit, (int)sts[bit].in[1], (int)sts[bit].de[1]);
		bool in = sts[bit].in[1], de = sts[bit].de[1];
			if (ans != -1) {
				if (!in && !de) {
					ans = -1;
				} else if (de && !in) ans |= (1 << bit);
			}
	}
	cout << ans << '\n';

	int q;
	cin >> q;
	while (q--) {
		int p, v;
		cin >> p >> v;
		--p;
		ans = 0;
		a[p] = v;
		for (int bit = MAXB - 1; bit >= 0; --bit) {
			for (int i = max(p, 1); i < min(p + 2, n); ++i) {
				if (chs[bit + 1][i] != 0) chs[bit][i] = 17;
				else chs[bit][i] = (a[i] >> bit & 1) - (a[i - 1] >> bit & 1);
				sts[bit].ch[i] = chs[bit][i];
				dbg(bit, i, (int)chs[bit][i]);
			}
			sts[bit].upd(1, 0, n - 1, p);
			dbg(bit, (int)sts[bit].in[1], (int)sts[bit].de[1]);
			bool in = sts[bit].in[1], de = sts[bit].de[1];
			if (ans != -1) {
				if (!in && !de) {
					ans = -1;
				} else if (de && !in) ans |= (1 << bit);
			}
		}
		cout << ans << '\n';

	}

	return 0;
}
