#include <bits/stdc++.h>

using std::cin;
using std::cout;
using std::cerr;
using std::abs;
using std::min;
using std::max;
using std::swap;
using std::pair;
using std::vector;
using std::set;
using std::map;
using std::string;
using std::bitset;

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

#define ff first
#define ss second
#define pb emplace_back
#ifdef LOCAL
#define dbg(as...) {\
	string _cur, _loc;\
	std::stringstream _ss(#as);\
	vector<string> _v;\
	while (getline(_ss,_cur, ',')) {\
		while (count(_cur.begin(), _cur.end(), '(') != count(_cur.begin(), _cur.end(), ')')) {\
			getline(_ss, _loc, ',');\
			_cur += ',' + _loc;\
		}\
		_v.pb(_cur);\
	}\
	err(_v.begin(), as);\
}
#else
#define dbg(as...) {}
#endif

template<typename T> void err(vector<string>::iterator it, T a) {
	cerr << *it << " = " << a << '\n';
}

template <typename T, typename...Ts>
void err(vector<string>::iterator it, T a, Ts...as) {
	cerr << *it << " = " << a << ',';
	err(++it, as...);
}

struct init{
	init() {
		std::iostream::sync_with_stdio(0);
		cin.tie(0);
		cout << std::fixed << std::setprecision(10);
		cerr << std::fixed << std::setprecision(3);
	}
} init;

const int MAXN = 2e5 + 25, INF = 1e9 + 7, MAXT = 5000;
// #define int ll
int c[MAXN];
int l[MAXN], r[MAXN];

int pl[MAXN], pr[MAXN], nl[MAXN], nr[MAXN];

vector<int> solve1(int n) {
	vector<int> ans;
	for (int i = 1; i <= n; ++i) {
		// dbg(l[i], r[i]);
        int tm = 0;
        for (; tm <= MAXT; ++tm) {
            bool ok = true;
            int curt;
            curt = tm;
            for (int j = i; j > 1; --j) {
            	if (l[j] <= curt && curt <= r[j]) {
            		;
            	} else if (l[j] > curt && curt + c[j] >= l[j]) {
            		curt = l[j];
            	} else {
            		ok = false;
            		break;
            	}
            }
            curt = tm;
            for (int j = i; j < n; ++j) {
            	if (l[j + 1] <= curt && curt <= r[j + 1]) {
            		;
            	} else if (l[j + 1] > curt && curt + c[j] >= l[j + 1]) {
            		curt = l[j + 1];
            	} else {
            		ok = false;
            		break;
            	}
            }
            if (ok) {
            	ans.pb(tm);
            	break;
            }
        }
        if (tm > MAXT)
        	ans.pb(-1);
    }
    return ans;
}

vector<int> solve2(int n) {
	vector<int> ans;
	pl[0] = 0;
    pr[0] = +INF;
    pl[1] = 0;
    pr[1] = +INF;
 	
    for (int i = 2; i <= n; ++i) {
    	if (pl[i - 1] <= l[i] && l[i] <= pr[i - 1]) {
    		pl[i] = max(0, l[i] - c[i]);
    		pr[i] = min(pr[i - 1], r[i]);
    	} else if (l[i] <= pl[i - 1] && pl[i - 1] <= r[i] + c[i]) {
    		pl[i] = pl[i - 1];
    		pr[i] = min(pr[i - 1], r[i]);
    	} else {
    		pl[i] = INF;
    		pr[i] = 0; 
    	}
    }   
 
    nl[n] = 0;
    nr[n] = +INF;
    nl[n + 1] = 0;
    nr[n + 1] = +INF;
 
    l[1] = 0;
    r[1] = INF;
 
    l[n + 1] = 0;
    r[n + 1] = INF;
 
    for (int i = n - 1; i >= 1; --i) {
    	if (nl[i + 1] <= l[i + 1] && l[i + 1] <= nr[i + 1]) {
    		nl[i] = max(0, l[i + 1] - c[i]);
    		nr[i] = min(nr[i + 1], r[i + 1]);
    	} else if (l[i + 1] <= nl[i + 1] && nl[i + 1] <= r[i + 1] + c[i]) {
    		nl[i] = nl[i + 1];
    		nr[i] = min(nr[i + 1], r[i + 1]);
    	} else {
    		nl[i] = INF;
    		nr[i] = 0; 
    	}

    }

    for (int i = 1; i <= n; ++i) {
    	dbg(i, pl[i], pr[i], nl[i], nr[i]);
    }

    for (int i = 1; i <= n; ++i) {
    	vector<int> tms = {l[i], l[i] - c[i], pl[i - 1], l[i + 1], l[i + 1] - c[i], nl[i + 1]};
    	int cans = INF;
    	for (int tm : tms) {
    		if (tm < 0) tm = 0;
            bool ok = true;
            if (l[i] <= tm && tm <= r[i])
                ok &= pl[i - 1] <= tm && tm <= pr[i - 1];
            else if (l[i] > tm && l[i] <= tm + c[i])
                ok &= pl[i - 1] <= l[i] && l[i] <= pr[i - 1];
            else
                ok = 0;
            // dbg(tm, ok);
            if (l[i + 1] <= tm && tm <= r[i + 1])
                ok &= nl[i + 1] <= tm && tm <= nr[i + 1];
            else if (l[i + 1] > tm && l[i + 1] <= tm + c[i])
                ok &= nl[i + 1] <= l[i + 1] && l[i + 1] <= nr[i + 1];
            else
                ok = 0;
            if (ok) {
            	cans = min(cans, tm);
            }
        }
        if (cans == INF) cans = -1;
    	ans.pb(cans);
            // cout << "-1\n";
    }
    return ans;
}

int32_t main() {
// while (1) {
	int n = rand() % 10 + 1;
	dbg(n);
	cin >> n;
	for (int i = 1; i <= n; ++i) {
		c[i] = rand() % 5 + 1;
		dbg(c[i]);
		cin >> c[i];
	}
	for (int i = 2; i <= n; ++i)  {
		l[i] = rand() % 5 + 1;
		r[i] = rand() % 5 + 1;
		if (r[i] < l[i])
			swap(l[i], r[i]);
		dbg(l[i], r[i]);
		cin >> l[i] >> r[i];
	}

	// auto x = solve1(n);
	auto y = solve2(n);
	for (int i : y)
		cout << i << '\n';
// 	if (x != y) {
// 		dbg("correct:");
// 		for (int i : x) dbg(i);
// 		dbg("my:");
// 		for (int i : y)
// 		dbg(i);
// 	break;
// 	}
// }


	return 0;
}