#include <iostream>
#include <vector>
#include <fstream>
#include <algorithm>

using namespace std;

const int max_num = 2000000000;

struct segment {
    bool flag;
    int minimum, maximum;
    segment () {
        minimum = -1;
        maximum = -1;
    }
};

int main() {
    ifstream fin;
    fin.open("servers.in");
    ofstream fout;
    fout.open("servers.out");
    int n, min_start, max_start;
    fin >> n;
    vector <int> times(n);
    for (int i = 0; i < n; i++) {
        fin >> times[i];
    }
    vector <pair <int, int> > v(n - 1);
    for (int i = 0; i < n - 1; i++) {
        fin >> v[i].first >> v[i].second;
    }
    vector <segment> left_dp(n);
    left_dp[0].flag = true;
    left_dp[0].minimum = 0;
    left_dp[0].maximum = max_num;
    for (int i = 1; i < n; i++) {
        if (!left_dp[i - 1].flag) {
            left_dp[i].flag = false;
        }
        else {
            max_start = min(v[i - 1].second, left_dp[i - 1].maximum);
            min_start = max(v[i - 1].first, left_dp[i - 1].minimum);
            if (max_start < min_start) {
                left_dp[i].flag = false;
            }
            else {
                left_dp[i].flag = true;
                if (min_start > v[i - 1].first) {
                    left_dp[i].minimum = min_start;
                }
                else {
                    left_dp[i].minimum = max(0, min_start - times[i]);
                }
                left_dp[i].maximum = max_start;
            }
        }
    }
    vector <segment> right_dp(n);
    right_dp[n - 1].flag = true;
    right_dp[n - 1].minimum = 0;
    right_dp[n - 1].maximum = max_num;
    for (int i = n - 2; i >= 0; i--) {
        if (!right_dp[i + 1].flag) {
            right_dp[i].flag = false;
        }
        else {
            max_start = min(v[i].second, right_dp[i + 1].maximum);
            min_start = max(v[i].first, right_dp[i + 1].minimum);
            if (max_start < min_start) {
                right_dp[i].flag = false;
            }
            else {
                right_dp[i].flag = true;
                if (min_start > v[i].first) {
                    right_dp[i].minimum = min_start;
                }
                else {
                    right_dp[i].minimum = max(0, min_start - times[i]);
                }
                right_dp[i].maximum = max_start;
            }
        }
    }
/*
    cout << "left:\n";
    for (int i = 0; i < n; i++) {
        cout << left_dp[i].flag << ' ' << left_dp[i].minimum << ' ' << left_dp[i].maximum << '\n';
    }
    cout << "right:\n";
    for (int i = 0; i < n; i++) {
        cout << right_dp[i].flag << ' ' << right_dp[i].minimum << ' ' << right_dp[i].maximum << '\n';
    }
*/
    vector <segment> answers(n);
    for (int i = 0; i < n; i++) {
        if ((!right_dp[i].flag) || (!left_dp[i].flag)) {
            answers[i].flag = false;
        }
        else {
            answers[i].minimum = max(left_dp[i].minimum, right_dp[i].minimum);
            answers[i].maximum = min(left_dp[i].maximum, right_dp[i].maximum);
            if (answers[i].minimum > answers[i].maximum) {
                answers[i].flag = false;
            }
            else {
                answers[i].flag = true;
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (answers[i].flag) {
            fout << answers[i].minimum << '\n';
        }
        else {
            fout << "-1\n";
        }
    }
    fin.close();
    fout.close();
    return 0;
}
