#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>

using namespace std;

#define int long long

struct point
{
	int x, y;
	point() {}
	point(int x, int y) : x(x), y(y) {}

	bool operator< (const point &a) const
	{
		return x < a.x || a.x == x && y < a.y;
	}
};

struct vect
{
	int x, y;
	vect() {}
	vect(int x, int y) : x(x), y(y) {}
	vect(point a, point b)
	{
		x = b.x - a.x;
		y = b.y - a.y;
	}
};

double dist(point a, point b)
{
	return sqrt((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y));
}

int mult(vect a, vect b)
{
	return a.x * b.y - b.x * a.y;
}

int sq(point p1, point p2, point p3)
{
	return abs(mult(vect(p1, p2), vect(p1, p3)));
}

int sq_s(vector<point> a)
{
	int s = 0;
	for (int i = 2; i < a.size(); i++)
		s += sq(a[0], a[i - 1], a[i]);
	return s;
}

bool in(point a, vector<point> b)
{
	int s = 0;
	for (int i = 0; i + 1 < b.size(); i++)
		s += sq(a, b[i], b[i + 1]);
	s += sq(a, b[0], b.back());
	return s == sq_s(b);
}


signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	
	int n;
	cin >> n;
	vector<point> v(n);

	for (int i = 0; i < n; i++)
		cin >> v[i].x >> v[i].y;

	int q;
	cin >> q;

	for (int O = 0; O < q; O++)
	{
		bool global_good = false;
		for (int p1 = 0; p1 < n; p1++)
			for (int p2 = 0; p2 < n; p2++)
				for (int p3 = 0; p3 < n; p3++)
				{
					if (global_good)
						continue;
					vector<point> tr;
					tr.push_back(v[p1]);
					tr.push_back(v[p2]);
					tr.push_back(v[p3]);
					if (p1 == p2 || p2 == p3 || p1 == p3)
						continue;
					bool good = true;
					for (int i = 0; i < n; i++)
					{
						if (i != p1 && i != p2 && i != p3 && in(v[i], tr))
							good = false;
					}
					if (!good)
						continue;
					cout << "? 3 " << p1 + 1 << " " << p2 + 1 << " " << p3 + 1 << endl;
					string s;
					cin >> s;
					if (s == "Yes")
					{
						cout << "! 3 " << p1 + 1 << " " << p2 + 1 << " " << p3 + 1 << endl;
						global_good = true;
					}
				}
	}

	//system("pause");
}