#define _CRT_SECURE_NO_WARNINGS
#pragma comment(linker, "/STACK:512000000")

#include <iostream>
#include <fstream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <queue>
#include <vector>
#include <unordered_set>
#include <unordered_map>
#include <cassert>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

#define pk push_back
#define mk make_pair
#define forn(i, n) for(int i = 0; i < (int)(n); i++)
#define for1(i, n) for(int i = 1; i <=(int)(n); i++)

void solve();

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#endif
	solve();
}

struct str {
	int l, r, sz1, sz2;

	int get() {
		return max(sz1, sz2) - (r - l + 1);
	}

	friend bool operator <(const str &s1, const str &s2) {
		str cop1 = s1;
		str cop2 = s2;
		if (cop1.get() == cop2.get()) {
			return s1.l < s2.l;
		}
		return cop1.get() < cop2.get();
	}
};

const int MAXN = (int)1e6 + 7;
int nxtl[MAXN], nxtr[MAXN];

vector<pii> v;

void add(int l, int r) {
	v.push_back({ l, r });
	nxtr[l] = r;
	nxtl[r] = l;
}

int get_left(string &s, int pos) {
	if (pos < 0) return 0;
	int start = pos;
	while (pos - 1 >= 0 && s[pos - 1] == s[pos]) pos--;
	return start - pos + 1;
}

int get_right(string &s, int pos) {
	if (pos >= s.length()) return 0;
	int start = pos;
	while (pos + 1 < s.length() && s[pos + 1] == s[pos]) pos++;
	return pos - start + 1;
}

bool sol() {
	v.clear();

	string s, t;
	cin >> s >> t;
	int n = s.length(), cur = -1;

	forn(i, n) nxtl[i] = nxtr[i] = -1;

	forn(i, n) {
		if (s[i] != t[i]) {
			if (cur == -1) {
				cur = i;
				continue;
			}
			if (s[i] == s[cur]) continue;
			add(cur, i - 1);
			cur = i;
			continue;
		}
		if (cur == -1) continue;
		add(cur, i - 1);
		cur = -1;
	}
	if (cur != -1) {
		add(cur, n - 1);
	}
	for (int i = 1; i < (int)v.size(); i++) {
		if (v[i].first == v[i - 1].second + 1) {
			return false;
		}
	}
	
	string cop = s;

	set<str> my_set;
	forn(i, v.size()) {
		int l = v[i].first, r = v[i].second;
		my_set.insert({ l, r, get_left(cop, l - 1), get_right(cop, r + 1) });
	}

	while (!my_set.empty()) {
		auto t = *my_set.rbegin();
		my_set.erase(t);

		if (t.get() <= 0) return false;

		bool ok = true;
		int l = t.l, r = t.r;
		int curl = l - 1, curr = r + 1;
		while (curl - 1 >= 0 && cop[curl - 1] == cop[curl]) curl--;
		while (curr + 1 < n  && cop[curr + 1] == cop[curr]) curr++;
		for (int i = l; i <= r; i++) {
			cop[i] = (cop[i] == '+' ? '-' : '+');
		}

		if (curl - 1 >= 0) {
			if (nxtl[curl - 1] == -1) continue;
			int nl = nxtl[curl - 1], nr = curl - 1;
			int sz1 = get_left(cop, nl - 1), sz2 = l - curl;

			str p = { nl, nr, sz1, sz2 };

			my_set.erase(p);

			p.sz2 = curr - max(curl, 0) + 1;
			my_set.insert(p);
		}

		if (curr + 1 < n) {
			if (nxtr[curr + 1] == -1) continue;
			int nl = curr + 1, nr = nxtr[curr + 1];

			int sz1 = curr - r, sz2 = get_right(cop, nr + 1);

			str p = { nl, nr, sz1, sz2 };

			my_set.erase(p);

			p.sz1 = curr - max(curl, 0) + 1;
			my_set.insert(p);
		}
	}

	return true;
}

void solve() {
	int test;
	scanf("%d", &test);
	while (test--) {
		bool ans = sol();
		printf(ans ? "Yes\n" : "No\n");
	}
}