#define _CRT_SECURE_NO_WARNINGS
#pragma comment(linker, "/STACK:512000000")

#include <iostream>
#include <fstream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <queue>
#include <vector>
#include <unordered_set>
#include <unordered_map>
#include <cassert>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

#define pk push_back
#define mk make_pair
#define forn(i, n) for(int i = 0; i < (int)(n); i++)
#define for1(i, n) for(int i = 1; i <=(int)(n); i++)

void solve();

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#endif
	solve();
}

const int MAXN = (int)1e4 + 7;
const int INF = (int)1e9 + 7;

void uin(int &x, int y) {
	x = min(x, y);
}

void uax(int &x, int y) {
	x = max(x, y);
}

int n, m;

struct DSU {
	int pr[MAXN], l[MAXN], r[MAXN];
	ll sum[MAXN];

	void init() {
		for1(i, m) {
			pr[i] = i;
			sum[i] = 0;
			l[i] = i, r[i] = i;
		}
	}

	int get(int v) {
		return (v == pr[v] ? v : pr[v] = get(pr[v]));
	}

	pair<ll, pii> uni(int u, int v) {
		u = get(u), v = get(v);
		if (u == v) return mk(0, mk(0, 0));
		pr[u] = v;
		sum[v] += sum[u];
		r[v] = max(r[u], r[v]);
		l[v] = min(l[u], l[v]);
		return mk(sum[v], mk(l[v], r[v]));
	}
} D;

int a[MAXN], b[MAXN];
ll x[MAXN], y[MAXN];
vector<int> pos_a[MAXN], pos_b[MAXN];
bool used[MAXN];
int comp[MAXN];
ll sum_x, sum_y, answer;
pii para_a, para_b;

void solve() {
	scanf("%d%d", &n, &m);
	for1(i, n) scanf("%d", a + i), pos_a[a[i]].pk(i);
	for1(i, n) scanf("%lld", x + i), sum_x += x[i];

	for1(i, m) scanf("%d", b + i), pos_b[b[i]].pk(i);
	for1(i, m) scanf("%lld", y + i), sum_y += y[i];

	if (sum_x > sum_y) {
		answer = sum_x;
		para_a = { 1, n };
		para_b = { 0, 0 };
	}
	else {
		answer = sum_y;
		para_a = { 0, 0 };
		para_b = { 1, m };
	}


	for (int r = 1; r <= n; r++) {
		fill(used, used + m + 1, false);

		ll dans = 0;
		for (int i = 1; i <= r; i++) {
			for (int pos : pos_b[a[i]]) {
				used[pos] = true;
			}
			dans += x[i];
		}

		D.init();
		used[0] = true;
		for (int i = 1; i <= m; i++) {
			comp[i] = i;
			if (!used[i]) {
				if (used[i - 1]) {
					comp[i] = i;
				}
				else {
					comp[i] = comp[i - 1];
				}

				D.pr[i] = comp[i];
				D.sum[comp[i]] += y[i];
				uin(D.l[comp[i]], i);
				uax(D.r[comp[i]], i);

				if (D.sum[comp[i]] + dans > answer) {
					answer = D.sum[comp[i]] + dans;
					para_a = { 1, r };
					para_b = { D.l[comp[i]] , D.r[comp[i]] };
				}
			}
			else {
				D.sum[i] = y[i];
				D.l[i] = D.r[i] = i;
			}
		}

		for (int l = 2; l <= r; l++) {
			dans -= x[l - 1];
			int el = a[l - 1];
			for (int pos : pos_b[el]) {
				used[pos] = false;
				if (pos - 1 >= 1 && !used[pos - 1]) {
					auto ans1 = D.uni(pos, pos - 1);
					if (ans1.first + dans > answer) {
						answer = ans1.first + dans;
						para_a = { l, r };
						para_b = { ans1.second.first, ans1.second.second };
					}
				}
				if (pos + 1 <= m && !used[pos + 1]) {
					auto ans2 = D.uni(pos, pos + 1);
					if (ans2.first + dans > answer) {
						answer = ans2.first + dans;
						para_a = { l, r };
						para_b = { ans2.second.first, ans2.second.second };
					}
				}

				int v = D.get(pos);
				if (D.sum[v] + dans > answer){
					answer = D.sum[v] + dans;
					para_a = { l, r };
					para_b = { D.l[v], D.r[v] };
			}
			}
		}
	}
	cout << answer << '\n';
	cout << para_a.first << ' ' << para_a.second << '\n';
	cout << para_b.first << ' ' << para_b.second << '\n';
}