#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

struct pt{
    long long x;
    long long y;

    pt(long long _x, long long _y){
        x = _x;
        y = _y;
    }

    pt(){
        x = 0;
        y = 0;
    }
};

pt operator +(const pt &a, const pt &b){
    return pt(a.x + b.x, a.y + b.y);
}

pt operator -(const pt &a, const pt &b){
    return pt(a.x - b.x, a.y - b.y);
}

long long operator *(const pt &a, const pt &b){
    return a.x * b.x + a.y * b.y;
}

long long operator %(const pt &a, const pt &b){
    return a.x * b.y - a.y * b.x;
}

bool pr(pt a, pt b, pt c, pt d){
    long long s1, s2;
    s1 = 0;
    s2 = 0;
    s1 = a % b + b % c + c % a;
    s2 = abs(a % d + d % b + b % a) + abs(b % d + d % c + c % b) + abs(a % d + d % c + c % a);
    if (abs(s1) == s2){
        return true;
    }
    return false;
}

int main(){
    long long n, q, x, y;
    bool f;
    string s;
    cin >> n;
    vector<pt> a;
    for (int i = 0; i < n; i++){
        cin >> x >> y;
        a.push_back(pt(x, y));
    }
    cin >> q;
    for (int i = 0; i < q; i++){
        for (int j = 0; j < n; j++){
            for (int k = j + 1; k < n; k++){
                for (int y = k + 1; y < n; y++){
                    cout << "? " << 3 << ' ' << j + 1 << ' ' << k + 1 << ' ' << y + 1 << "\n";
                    cout.flush();
                    cin >> s;
                    if (s[0] == 'Y'){
                        f = true;
                        for (int t = 0; t < n; t++){
                            if (t != j && t != k && t != y && pr(a[j], a[k], a[y], a[t])){
                                f = false;
                                break;
                            }
                        }
                        if (f){
                            cout << "! " << 3 << ' ' << j + 1 << ' ' << k + 1 << ' ' << y + 1 << "\n";
                            cout.flush();
                        }
                    }
                }
            }
        }
    }
    return 0;
}
