#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <vector>
#include <map>
#include <cstring>
#include <queue>
#include <stack>
#include <set>

using namespace std;

struct point {
    long long x, y;
    point() {}
    point(int a, int b): x(a), y(b) {}
    void read() {
        cin >> x >> y;
    }
    point operator - (point b) {
        return point(x - b.x, y - b.y);
    }
};

struct tri {
    int a, b, c;
    tri(int x, int y, int z): a(x), b(y), c(z){}
    tri() {}
    void print() {
        cout << "? 3 " << a + 1<< " " << b + 1<< " " << c + 1<< endl;
    }
    void print_as() {
        cout << "! 3 " << a + 1 << " " << b + 1 << " " << c + 1 << endl;
    }
};

long long dot_product(point a, point b) {
    return a.x * b.y - a.y * b.x;
}

bool belong_angle(point a, point b, point c) {
    return dot_product(a, c) * dot_product(c, b) > 0;
}

bool belong_triangle(point a, point b, point c, point d) {
    bool t = belong_angle(b - a, c - a, d - a);
    t = t && belong_angle(a - b, c - b, d - b);
    t = t && belong_angle(a - c, b - c, d - c);
    return t;
}

bool read() {
    string s;
    cin >> s;
    return s == "Yes";
}

void print() {

}

int main() {
    int n;
    cin >> n;
    vector<point> a(n);
    for (int i = 0; i < n; ++i) {
        a[i].read();
    }
    vector<tri> b;
    for (int i1 = 0; i1 < n; ++i1) {
        for (int i2 = i1 + 1; i2 < n; ++i2) {
            for (int i3 = i2 + 1; i3 < n; ++ i3) {
                bool can = true;
                for (int j = 0; j < n; ++j) {
                    if (j == i1 || j == i2 || j == i3) continue;
                    if (belong_triangle(a[i1], a[i2], a[i3], a[j])) {
                        //cerr << i1 << " " << i2 << " " << i3 << " " << j << endl;
                        can = false;
                        break;
                    }
                }
                if (can) {
                    b.push_back(tri(i1, i2, i3));
                }
            }
        }
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        for (int j = 0; j < b.size(); ++j) {
            b[j].print();
            if(read()) {
                b[j].print_as();
                break;
            }
        }
    }
    return 0;
}
