#include <iostream>
#include <vector>
#include <cmath>

#define long long long

#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wsign-conversion"
using namespace std;

struct point {
    int x, y, num;

    point(int x, int y, int num) : x(x), y(y), num(num) {}

    point operator-(point &p) {
        return point(x - p.x, y - p.y, -1);
    }
};

vector<point> p;
int n;

int dist(int i, int j, int t) {
    long a = p[j].y - p[i].y, b = p[i].x - p[j].x, c = -a * p[i].x - b * p[i].y;
    long d = a * p[t].x + b * p[t].y + c;
    return d > 0 ? 1 : (d == 0 ? 0 : -1);
}

bool inside(int i, int j, int k, int t) {
    return dist(i, j, t) == dist(i, j, k) &&
           dist(i, k, t) == dist(i, k, j) &&
           dist(j, k, t) == dist(j, k, i);
}

int main() {

    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> n;
    int lower = 0;
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        p.push_back(point(x, y, i));
        if (y < p[lower].y || y == p[lower].y && x < p[lower].x) {
            lower = i;
        }
    }

//    cerr << inside(1, 2, 5, 3) << endl;
//    return 0;

    int q;
    cin >> q;
    for (int h = 0; h < q; h++) {
        bool found = false;
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j++) {
                for (int k = j + 1; k < n; k++) {
                    bool flag = true;
                    for (int t = 0; t < n; t++) {
                        if (t != i && t != j && t != k && inside(i, j, k, t)) {
                            flag = false;
                            break;
                        }
                    }

                    if (flag) {
                        cout << "? 3 " << i + 1 << " " << j + 1 << " " << k + 1 << endl;

                        string ans;
                        cin >> ans;
                        if (ans == "Yes") {
                            cout << "! 3 " << i + 1 << " " << j + 1 << " " << k + 1 << endl;
                            found = true;
                            break;
                        }
                    }
                }
                if (found) {
                    break;
                }
            }
            if (found) {
                break;
            }
        }
    }

    return 0;

}

#pragma clang diagnostic pop