#include <iostream>
#include <unordered_map>
#include <vector>
#include <queue>

#define long long long

#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wsign-conversion"
using namespace std;

int n;

int main() {

    freopen("trains.in", "r", stdin);
    freopen("trains.out", "w", stdout);
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int m;
    cin >> n >> m;
    vector<unordered_map<int, int>> graph(n);
    for (int i = 0; i < m; i++) {
        int s;
        cin >> s;
        if (s != 1) {
            return 1;
        }

        int v, t, u;
        cin >> v >> t >> u;
        v--;
        u--;
        cerr << graph[v].count(u);
        if (graph[v].count(u) == 0) {
            graph[v][u] = t;
        } else {
            graph[v][u] = min(graph[v][u], t);
        }
    }

    vector<queue<int>> q(1001);
    int cur = 0;
    q[0].push(0);
    vector<int> dist(n, 1001 * n);
    vector<long> sq(n, 1000001 * n);
    vector<bool> used(n);
    dist[0] = 0;
    sq[0] = 0;

    while (!used[n - 1]) {
        while (!q[cur].empty()) {
            int f = q[cur].front();
            q[cur].pop();
            if (used[f]) {
                continue;
            }
            used[f] = true;

            for (auto item : graph[f]) {
                if (dist[item.first] > dist[f] + item.second) {
                    dist[item.first] = dist[f] + item.second;
                    sq[item.first] = sq[f] + (long) item.second * item.second;
                    q[(cur + item.second) % 1001].push(item.first);
                } else if (dist[item.first] == dist[f] + item.second) {
                    if (sq[item.first] > sq[f] + (long) item.second * item.second) {
                        sq[item.first] = sq[f] + (long) item.second * item.second;
                        q[(cur + item.second) % 1001].push(item.first);
                    }
                }
            }
        }
        cur++;
    }

    cout << dist[n - 1] << " " << sq[n - 1];

    return 0;

}

#pragma clang diagnostic pop