#include <iostream>
#include <vector>
#include <queue>

#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wsign-conversion"
using namespace std;

struct group {
    int size, l, r;

    group(int size, int l, int r) : size(size), l(l), r(r) {}
};

vector<int> left0, right0, size;
vector<pair<bool, int>> s;
vector<bool> changed;
int m;

void changel(group &g) {
    if (s[g.l - 1].second < g.size) {
        changed[g.l - 1] = false;
        g.size += s[g.l - 1].second;
        if (g.l - 1 > 0) {
            g.size += size[g.l - 2];
            g.l = left0[g.l - 2];
        } else {
            g.l--;
        }
    }
}

void changer(group &g) {
    if (s[g.r + 1].second < g.size) {
        changed[g.r + 1] = false;
        g.size += s[g.r + 1].second;
        if (g.r + 1 < m - 1) {
            g.size += size[g.r + 2];
            g.r = right0[g.r + 2];
        } else {
            g.r++;
        }
    }
}

int main() {

    freopen("storage.in", "r", stdin);
    freopen("storage.out", "w", stdout);
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int q;
    cin >> q;

    for (int i = 0; i < q; i++) {
        string str_s, str_t;
        cin >> str_s >> str_t;
        int n = str_s.length();

        vector<pair<bool, int>> t;
        s = vector<pair<bool, int>>(0);
        int j = 0;
        while (j < n) {
            int l = j;
            while (j < n && str_s[j] == str_s[l]) {
                j++;
            }
            s.push_back(make_pair(str_s[l] == '+', j - l));
        }
        j = 0;
        while (j < n) {
            int l = j;
            while (j < 2 * n + 1 && str_t[j] == str_t[l]) {
                j++;
            }
            t.push_back(make_pair(str_t[l] == '+', j - l));
        }

        m = s.size();
        changed = vector<bool>(m);
        bool correct = true;
        int last = 0, sum = 0, sum_t = 0;
        for (int last_t = 0; last_t < t.size(); last_t++) {
            sum_t += t[last_t].second;
            while (sum < sum_t) {
                if (s[last].first != t[last_t].first) {
                    changed[last] = true;
                }
                sum += s[last].second;
                last++;
            }
            if (sum != sum_t) {
                correct = false;
                break;
            }
        }

        for (int idx = 0; idx < m - 1; idx++) {
            if (changed[idx] && changed[idx + 1]) {
                correct = false;
                break;
            }
        }

        if (!correct) {
            cout << "No\n";
            continue;
        }

        queue<group> cl;
        size = vector<int>(m);
        left0 = vector<int>(m);
        right0 = vector<int>(m);
        for (int idx = 0; idx < m; idx++) {
            cl.push(group(s[idx].second, idx, idx));
            size[idx] = s[idx].second;
            left0[idx] = idx;
            right0[idx] = idx;
        }

        while (!cl.empty()) {
            group g = cl.front();
            int sold = g.size;
            cl.pop();

            if (g.l > 0 && g.r < m - 1) {
                if (changed[g.l - 1] && changed[g.r + 1]) {
                    if (s[g.l - 1].second < s[g.r + 1].second) {
                        changel(g);
                        changer(g);
                    } else {
                        changer(g);
                        changel(g);
                    }
                } else if (changed[g.r + 1]) {
                    changer(g);
                } else if (changed[g.l - 1]) {
                    changel(g);
                }
            } else if (g.l > 0 && changed[g.l - 1]) {
                changel(g);
            } else if (g.r < m - 1 && changed[g.r + 1]) {
                changer(g);
            }

            if (g.size != sold) {
                left0[g.r] = g.l;
                right0[g.l] = g.r;
                size[g.r] = g.size;
                size[g.l] = g.size;
                cl.push(g);
            }
        }

        for (int idx = 0; idx < m; idx++) {
            if (changed[idx]) {
                correct = false;
                break;
            }
        }

        if (!correct) {
            cout << "No\n";
        } else {
            cout << "Yes\n";
        }
    }

    return 0;

}

#pragma clang diagnostic pop