import java.io.*;
import java.math.BigInteger;
import java.util.Random;
import java.util.StringTokenizer;

/**
 * Created by roi on 27.03.2017.
 */
public class Floyd {

    public static void main(String[] args) {
        new Floyd().run();
    }

    private void run() {
        FastScanner in = new FastScanner();
        PrintWriter out = new PrintWriter(System.out);

        Random random = new Random();
        int n = 988;
        int[][] dist = new int[n][n];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                dist[i][j] = random.nextInt();
            }
        }

        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                for (int k = 0; k < n; k++) {
                    dist[j][k] = Math.min(dist[j][k], dist[j][i] + dist[i][k]);
                }
            }
        }

        out.print(in.nextBigInt().add(in.nextBigInt()));
        out.close();
    }

    private class FastScanner {

        BufferedReader in;
        StringTokenizer st;

        FastScanner() {
            in = new BufferedReader(new InputStreamReader(System.in));
        }

        FastScanner(String name) {
            try {
                in = new BufferedReader(new FileReader(name + ".br"));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(in.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }

        long nextLong() {
            return Long.parseLong(next());
        }

        double nextDouble() {
            return Double.parseDouble(next());
        }

        BigInteger nextBigInt() {
            return new BigInteger(next());
        }

    }

}
