#include <iostream>
#include <vector>

using namespace std;

vector<int> t, l, r;
vector<pair<int, int>> pref, suff;

const int inf = int(1e9);

pair<int, int> intersect(pair<int, int> a, pair<int, int> b) {
    if (a.second < b.first)
        return {-1, -1};
    if (a.first > b.second)
        return {-1, -1};
    return {max(a.first, b.first), min(a.second, b.second)};
};

pair<int, int> calc(pair<int, int> next, int l, int r, int t) {
    if (next.first == -1)
        return {-1, -1};
    int start, end;
    start = max(next.first, l);
    end = min(next.second, r);
    if (start > end)
        return {-1, -1};
    if (start == l)
        start -= t;
    return {start, end};
};

int main() {
    int n;
    cin >> n;
    t.resize(n);
    l.resize(n - 1);
    r.resize(n - 1);
    pref.resize(n);
    suff.resize(n);
    for (int i = 0; i < n; i++)
        cin >> t[i];
    for (int i = 0; i < n - 1; i++)
        cin >> l[i] >> r[i];

    pref[0] = {0, inf};
    for (int i = 1; i < n; i++)
        pref[i] = calc(pref[i - 1], l[i - 1], r[i - 1], t[i]);

    suff[n - 1] = {0, inf};
    for (int i = n - 2; i >= 0; i--)
        suff[i] = calc(suff[i + 1], l[i], r[i], t[i]);
    

    for (int i = 0; i < n; i++) {
        cout << intersect(pref[i], suff[i]).first << endl;
    }
    return 0;
}