#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
typedef long long ll;
const ll infinite = 10000000000000;

pair<ll, ll> merge(const pair<ll, ll>& a, const pair<ll, ll> &b) {
	return{ max(a.first, b.first), min(a.second, b.second) };
}

pair<ll, ll> sub(const pair<ll, ll>& a, ll p) {
	return { a.first - p, a.second};
}

ll saving[200010];
pair<ll, ll> open[200010];
pair<ll, ll> to_right[200010], to_left[200010];

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll n;
	cin >> n;
	for (int i = 0; i < n; i++) {
		cin >> saving[i];
	}
	for (int i = 0; i < n - 1; i++) {
		cin >> open[i].first >> open[i].second;
	}
	to_left[0] = {0, infinite};
	for (int i = 1; i < n; i++) {
		to_left[i] = merge(to_left[i - 1], open[i - 1]);
		if (to_left[i].second < to_left[i].first)
			to_left[i] = { infinite, -infinite };
		else if (to_left[i - 1].first <= open[i - 1].first)
			to_left[i].first = to_left[i].first - saving[i];
		else
			to_left[i].first = max(to_left[i].first - saving[i], to_left[i - 1].first);
	}
	to_right[n - 1] = { 0, infinite };
	for (int i = n - 2; i >= 0; i--) {
		to_right[i] = merge(to_right[i + 1], open[i]);
		if (to_right[i].second < to_right[i].first)
			to_right[i] = { infinite, -infinite };
		else if (to_right[i + 1].first <= open[i].first)
			to_right[i].first = to_right[i].first - saving[i];
		else
			to_right[i].first = max(to_right[i].first - saving[i], to_right[i + 1].first);
	}
	for (int i = 0; i < n; i++) {
		pair<ll, ll> ans = merge(to_right[i], to_left[i]);
		if (ans.second < ans.first) {
			cout << -1 << endl;
		}
		else
			cout << ans.first << endl;
	}
	return 0;
}