#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
typedef long long ll;
const ll infinite = 10000000000000000LL;
const ll atom = 1000000000LL;

struct Experiment {
	ll l, r, c;
	Experiment(ll l = 0, ll r = 0, ll c = 0) : l(l), r(r), c(c) {};
};

Experiment exps[100];
ll n, a;
ll cache[100000];
ll atom_cache[100000], cost_cache[100000];

pair<ll, ll> recur(ll t) {
	if (atom_cache[t] != -1) {
		return{ atom_cache[t], cost_cache[t] };
	}
	ll res = 0;
	ll cost = 0;
	for (int i = 0; i < n; i++) {
		if (exps[i].r + t <= a) {
			ll minres = infinite;
			ll mincost = 0;
			for (int l = exps[i].l; l <= exps[i].r; l++) {
				pair<ll, ll> ans = recur(t + l);
				if (ans.first < minres) {
					minres = ans.first;
					mincost = ans.second + exps[i].c;
				}
				else if (ans.first == minres) {
					if (ans.second + exps[i].c> mincost) {
						mincost = ans.second + exps[i].c;
					}
				}
				//minres = min(minres, ans);
			}
			if (minres > res) {
				res = minres;
				cost = mincost;
			}
			else if (minres == res) {
				if (mincost < cost)
					cost = mincost;
			}
			//res = max(res, minres);
		}
	}

	if (res == infinite|| t >= res) {
		res = t;
		cost = 0;
	}
	//res = max(res, t*atom - c);
	atom_cache[t] = res;
	cost_cache[t] = cost;
	return {res, cost};
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	cin >> n >> a;
	for (int i = 0; i < n; i++) {
		cin >> exps[i].l >> exps[i].r >> exps[i].c;
	}
	for (int i = 0; i <= a; i++) {
		atom_cache[i] = -1;
		cost_cache[i] = -1;
	}
	pair<ll, ll> ans = recur(0);
	cout << ans.first * atom - ans.second << endl;
	return 0;
}