#pragma comment(linker, "/Stack:512000000")
#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <cmath>
#include <vector>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <algorithm>
#include <unordered_map>
#include <unordered_set>
#include <cassert>

using namespace std;

typedef long long LL;

const int MAXB = 31;
const int MAXN = (int)1e6 + 100;

int a[MAXN];
int n;

int must0[MAXB], must1[MAXB];
set<int> changes[MAXB];


inline int BIT(int a, int b) {
  return (a & (1 << b)) >> b;
}

bool findB(int bit, int L, int R) {
  if (bit < 0 || L >= R) return 1;

  int prev = L;
  for (int i = L; i < R; ++i) {
    if (i != L && BIT(a[i], bit) < BIT(a[i - 1], bit)) {
      ++must1[bit];
      findB(bit - 1, prev, i);
      changes[bit].insert(i);
      prev = i;
    }
    if (i != L && BIT(a[i], bit) > BIT(a[i - 1], bit)) {
      ++must0[bit];
      findB(bit - 1, prev, i);
      changes[bit].insert(i);
      prev = i;
    }
  }

  findB(bit - 1, prev, R);
}

int calcB() {
  int B = 0;
  for (int i = 0; i < MAXB; ++i) {
    if (must0[i] > 0 && must1[i]) return -1;
    if (must1[i]) B |= 1 << i;
  }
  return B;
}

void change(int bit, int id, int val) {
  if (bit < 0) return;
  if (BIT(val, bit) == BIT(a[id], bit)) {
    change(bit - 1, id, val);
    return;
  }

  auto it = changes[bit].upper_bound(id);
  int segR = *it;
  --it;
  int segL = *it;

  for (int i = max(segL + 1, id); i <= min(segR - 1, id + 1); ++i) {
    if (BIT(a[i], bit) < BIT(a[i - 1], bit)) {
      --must1[bit];
    }
    if (BIT(a[i], bit) > BIT(a[i - 1], bit)) {
      --must0[bit];
    }
  }
  
  if (segL == segR - 1) {
    if (segR != n) changes[bit].erase(segR);
    changes[bit].erase(segL);
  }
  else if (id == segL) {
    
  }
  else if (id == segR) {

  }
  else {

  }

  change(bit - 1, id, val);
}

int main() {
#ifdef _DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#elif 1
# define PROB "order"
  freopen(PROB".in", "r", stdin);
  freopen(PROB".out", "w", stdout);
#endif
  
  scanf("%d", &n);
  for (int i = 0; i < n; ++i) {
    scanf("%d", &a[i]);
  }

  for (int i = 0; i < MAXB; ++i) {
    must0[i] = must1[i] = 0;
    changes[i].insert(0);
    changes[i].insert(n);
  }
  /*
  findB(MAXB - 1, 0, n);*/

  for (int i = 1; i < n; ++i) {
    for (int bit = MAXB - 1; bit > -1; --bit) {
      if (BIT(a[i - 1], bit) < BIT(a[i], bit)) {
        must0[bit]++;
        break;
      }
      if (BIT(a[i - 1], bit) > BIT(a[i], bit)) {
        must1[bit]++;
        break;
      }
    }
  }

  int B = calcB();
  printf("%d\n", B);

  int q;
  scanf("%d", &q);

  for (int i = 0; i < q; ++i) {
    int p, v;
    scanf("%d%d", &p, &v);
    //change(MAXB - 1, p - 1, v);
    a[p - 1] = v;
    for (int i = 0; i < MAXB; ++i) {
      must0[i] = must1[i] = 0;
      changes[i].insert(0);
      changes[i].insert(n);
    }
    /*
    findB(MAXB - 1, 0, n);*/

    for (int i = 1; i < n; ++i) {
      for (int bit = MAXB - 1; bit > -1; --bit) {
        if (BIT(a[i - 1], bit) < BIT(a[i], bit)) {
          must0[bit]++;
          break;
        }
        if (BIT(a[i - 1], bit) > BIT(a[i], bit)) {
          must1[bit]++;
          break;
        }
      }
    }
    B = calcB();
    printf("%d\n", B);
  }
  return 0;
}