#pragma comment(linker, "/Stack:512000000")
#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <cmath>
#include <vector>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <algorithm>
#include <unordered_map>
#include <unordered_set>

using namespace std;

typedef long long LL;

int main() {
#ifdef _DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#elif 1
# define PROB "trains"
  freopen(PROB".in", "r", stdin);
  freopen(PROB".out", "w", stdout);
#endif
  int n, m;
  scanf("%d%d", &n, &m);

  struct Edge {
    int from, to, cost, path;
  };

  vector<vector<Edge>> paths(m);
  vector<vector<Edge>> g(n + 1);

  for (int i = 0; i < m; ++i) {
    int s;
    scanf("%d", &s);

    int prev;
    scanf("%d", &prev);

    for (int j = 0; j < s; ++j) {
      int cost, next;
      scanf("%d%d", &cost, &next);
      Edge e = Edge{ prev, next, cost, i };
      paths[i].push_back(e);
      g[prev].push_back(e);
      prev = next;
    }
  }

  vector<int> order;
  set<pair<int, int>> q;
  
  vector<int> dist(n + 1, (int)2e9);

  dist[1] = 0;
  q.insert({ 0, 1 });

  while (!q.empty()) {
    int v = q.begin()->second;
    order.push_back(v);
    q.erase(q.begin());

    for (auto to : g[v]) {
      if (dist[to.to] > dist[v] + to.cost) {
        q.erase({ dist[to.to], to.to });
        dist[to.to] = dist[v] + to.cost;
        q.insert({ dist[to.to], to.to });
      }
    }
  }

  vector<int> revorder = order;
  reverse(revorder.begin(), revorder.end());

  cout << dist[n] << ' ';

  vector<map<int, pair<LL, LL>>> dp(n + 1);
  vector<pair<int, pair<LL, LL>>> dpmx(n + 1);
  vector<bool> good(n + 1);
  good[n] = 1;

  for (auto v : revorder) {
    for (auto to : g[v]) {
      if (!good[to.to]) continue;
      if (dist[v] + to.cost == dist[to.to]) {
        good[v] = 1;
        
        pair<LL, LL> cur = dp[v][to.path], mb = dp[to.to][to.path];
        pair<int, pair<LL, LL>> mbmx = dpmx[to.to];
        
        if (cur.second < mb.second + 2 * mb.first * to.cost + to.cost * to.cost) {
          cur.second = mb.second + 2 * mb.first * to.cost + to.cost * to.cost;
          cur.first = to.cost + mb.first;
          dp[v][to.path] = cur;
        }

        if (cur.second < mbmx.second.second + to.cost * to.cost) {
          cur.second = mbmx.second.second + to.cost * to.cost;
          cur.first = to.cost;
          dp[v][to.path] = cur;
        }

        if (cur.second > dpmx[v].second.second) dpmx[v] = { to.path, cur };
      }
    }
  }

  cout << dpmx[1].second.second << endl;
  
  return 0;
}