#pragma comment(linker, "/Stack:512000000")
#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <cmath>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <queue>

using namespace std;

typedef long long LL;

int n;
vector<pair<int, int>> pushtime;
vector<int> t;

pair<int, int> intersect(pair<int, int> a, pair<int, int> b) {
  if (a == pair<int,int>{-1, -1} || b == pair<int, int>{-1, -1}) return pair<int, int>{ -1, -1 };
  pair<int, int> res;
  res.first = max(a.first, b.first);
  res.second = min(a.second, b.second);
  if (res.first > res.second) res = { -1, -1 };
  return res;
}

int main() {
#ifdef _DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#elif 1
# define PROB "servers"
  freopen(PROB".in", "r", stdin);
  freopen(PROB".out", "w", stdout);
#endif
  cin.tie(0);
  cin.sync_with_stdio(0);

  cin >> n;

  if (n == 1) {
    cout << 0 << endl;
    return 0;
  }

  t.resize(n);
  pushtime.resize(n - 1);

  for (int i = 0; i < n; ++i)
    cin >> t[i];

  for (int i = 0; i < n - 1; ++i) {
    cin >> pushtime[i].first >> pushtime[i].second;
  }

  vector<pair<int, int>> toend(n - 1), tobeg(n - 1);

  toend[n - 2] = pushtime[n - 2];
  toend[n - 2].first = max(0, toend[n - 2].first - t[n - 2]);

  for (int i = n - 3; i > -1; --i) {
    pair<int, int> next = toend[i + 1], cur = pushtime[i];
    //next.first -= t[i];

    toend[i] = intersect(next, cur);
    if (toend[i] == pair<int, int>{-1, -1}) continue;

    if (cur.first >= next.first) toend[i].first = max(toend[i].first - t[i], pushtime[i].first - t[i]);
    if (toend[i].first > toend[i].second) toend[i] = { -1, -1 };
  }

  tobeg[0] = pushtime[0];
  tobeg[0].first = max(tobeg[0].first - t[1], 0);

  for (int i = 1; i < n - 1; ++i) {
    pair<int, int> prev = tobeg[i - 1], cur = pushtime[i];

    tobeg[i] = intersect(prev, cur);
    if (tobeg[i] == pair<int, int>{-1, -1}) continue;
    if (cur.first >= prev.first) tobeg[i].first = max(tobeg[i].first - t[i + 1], pushtime[i].first - t[i + 1]);
    if (tobeg[i].first > tobeg[i].second) tobeg[i] = { -1, -1 };
  }

  {
    pair<int, int> e = toend[0];
    cout << e.first << '\n';
  }

  for (int i = 1; i < n - 1; ++i) {
    pair<int, int> e = toend[i], b = tobeg[i - 1];
    
    pair<int, int> res = intersect(e, b);

    cout << res.first << '\n';
  }

  {
    pair<int, int> b = tobeg[n - 2];
    cout << b.first << '\n';
  }

  return 0;
}