# include <iostream>
# include <vector>
# include <string>
# include <map>
# include <set>
# include <algorithm>
# include <cmath>
# include <queue>

using namespace std;

const int MAXN = 1e6;

struct point {
    int x;
    int y;
};
point p[MAXN];
int n;

struct vect {
    int x;
    int y;
};

vect make_v (point p1, point p2) {
    vect ans;
    ans.x = p2.x - p1.x;
    ans.y = p2.y - p1.y;
    return ans;
}

int f (vect v1, vect v2) {
    return v1.x * v2.y - v1.y * v2.x;
}

bool cmp (point p1, point p2) {
    vect v1 = make_v(p[0], p1);
    vect v2 = make_v(p[0], p2);
    return (f(v1, v2) > 0);
}


void work() {
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            for (int k = j + 1; k < n; k++) {
                bool flag = true;
                for (int ind = 0; ind < n; ind++) {
                    vect v1 = make_v(p[i], p[j]);
                    vect v2 = make_v(p[i], p[ind]);
                    vect v3 = make_v(p[i], p[k]);
                    vect v4 = make_v(p[j], p[i]);
                    vect v5 = make_v(p[j], p[ind]);
                    vect v6 = make_v(p[j], p[k]);
                    if (f(v1, v2) * f(v2, v3) > 0 && f(v4, v5) * f(v5, v6) > 0) {
                        flag = false;
                        break;
                    }
                }
                if (flag) {
                    cout << "? " << 3 <<  ' ' << i + 1 << ' ' << j + 1 << ' ' << k + 1 << endl;
                    string a;
                    cin >> a;
                    if (a == "Yes") {
                        cout << "! " << 3 << ' ' << i + 1 << ' ' << j + 1 << ' ' << k + 1 << endl;
                        return;
                    }
                }
            }
        }
    }
    return;
}

int main() {
    cin >> n;
    for (int i = 0; i < n; i++) cin >> p[i].x >> p[i].y;
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) work();
}
