#include <bits/stdc++.h>

using namespace std;

const int maxN = 1000005;

bool dpSBeg[maxN];
bool dpSEnd[maxN];
bool dpTBeg[maxN];
bool dpTEnd[maxN];

void build(string& s, bool* dpBeg, bool* dpEnd)
{
    for(int i = 0; i < s.size();)
    {
        dpBeg[i] = 1;
        int j = i;
        while(j < s.size() && s[j] == s[i]) j++;
        dpEnd[j - 1] = 1;
        i = j;
    }
}

int pv[maxN];
int sz[maxN];
pair<int, int> seg[maxN];
void buildSNM(int n)
{
    for(int i = 0; i < n; i++) pv[i] = i, sz[i] = 1, seg[i] = make_pair(i, i);
}

int get_p(int v)
{
    if(pv[v] == v) return v;
    return pv[v] = get_p(pv[v]);
}

void union_s(int v, int u)
{
    v = get_p(v);
    u = get_p(u);

    if(v == u) return;

    if(sz[v] > sz[u]) swap(v, u);

    pv[v] = u;
    sz[u] += sz[v];
    seg[u].first = min(seg[u].first, seg[v].first);
    seg[u].second = max(seg[u].second, seg[v].second);
}


struct Seg
{
    int l, r;
    Seg() {}
    Seg(int _l, int _r) : l(_l), r(_r) {}
};

bool operator < (Seg s1, Seg s2)
{
    return s1.r - s1.l < s2.r - s2.l;
}

int check(int v, int l, int r)
{
    v = get_p(v);

    int sz1 = -1, sz2 = -1;
    if(seg[v].first > l) sz1 = sz[get_p(seg[v].first - 1)];
    if(seg[v].second < r - 1) sz2 = sz[get_p(seg[v].second + 1)];

    return sz[v] < max(sz1, sz2);
}

int solve(string& s, string& t, int l, int r)
{
    if(t[l] == '+')
    {
        for(int i = l; i < r; i++) s[i] = (s[i] == '+' ? '-' : '+');
        for(int i = l; i < r; i++) t[i] = '-';
    }

    int was = 0;
    for(int i = l; i < r; i++) if(s[i] == '-') was = 1;
    if(!was) return 0;

    for(int i = l + 1; i < r; i++)
    {
        if(s[i] == s[i - 1]) union_s(i, i - 1);
    }

    vector<int> st;
    set<int> cur;

    for(int i = l; i < r; i++)
    {
        int v = get_p(i);

        if(check(v, l, r))
        {
            if(st.size() == 0 || st.back() != v)
            {
                st.push_back(v);
                cur.insert(v);
            }
        }
    }

    while(st.size() > 0)
    {
        int v = st.back(); st.pop_back();

        int lv = seg[v].first, rv = seg[v].second;

        if(lv > l) union_s(v, lv - 1);
        if(rv < r - 1) union_s(v, rv + 1);

        v = get_p(v);

        lv = seg[v].first, rv = seg[v].second;

        if(lv > l)
        {
            if(check(lv - 1, l, r) && !cur.count(get_p(lv - 1)))
            {
                st.push_back(get_p(lv - 1));
                cur.insert(get_p(lv - 1));
            }
        }

        if(rv < r - 1)
        {
            if(check(rv + 1, l, r) && !cur.count(get_p(rv + 1)))
            {
                st.push_back(get_p(rv + 1));
                cur.insert(get_p(rv + 1));
            }
        }
    }

    return sz[get_p(l)] == r - l;
}

int solve(string& s, string& t)
{
    int n = s.size();

    build(s, dpSBeg, dpSEnd);
    build(t, dpTBeg, dpTEnd);

    for(int i = 0; i < n; i++) if(dpTBeg[i] && !dpSBeg[i] || dpTEnd[i] && !dpSEnd[i]) return 0;

    for(int i = 0; i < n - 1; i++) if(dpTEnd[i] && s[i] != t[i]) return 0;
    for(int i = 1; i < n; i++) if(dpTBeg[i] && s[i] != t[i]) return 0;

    for(int i = 0; i < n;)
    {
        int j = i;
        while(!dpTEnd[j]) j++;

        if(!solve(s, t, i, j + 1)) return 0;

        i = j + 1;
    }

    return 1;
}

int main()
{
    #ifdef DEBUG
        freopen("in.in", "r", stdin);
        //freopen("in.out", "w", stdout);
    #endif // DEBUG

    int q;
    cin >> q;
    while(q--)
    {
        string s, t;
        cin >> s >> t;

        fill(dpSBeg, dpSBeg + s.size(), 0);
        fill(dpTBeg, dpTBeg + s.size(), 0);
        fill(dpSEnd, dpSEnd + s.size(), 0);
        fill(dpTEnd, dpTEnd + s.size(), 0);

        buildSNM(s.size());

        cout << (solve(s, t) ? "Yes" : "No") << endl;
    }

    return 0;
}
