#include <bits/stdc++.h>

#define ll long long

using namespace std;

const int maxN = 200005;
const int INF = 5 + 1e9;

int dpLeft[maxN];
int dpRight[maxN];
int dpLeft2[maxN];
int dpRight2[maxN];

int arr[maxN];
pair<int, int> arr2[maxN];

int st1[maxN * 12];
int st2[maxN * 12];

void build(int v, int l, int r, int x)
{
    st1[v] = x;
    st2[v] = x;

    if(l == r - 1) return;

    int m = (l + r) / 2;
    build(v * 2, l, m, x);
    build(v * 2 + 1, m, r, x);
}

int getMax(int v, int l, int r, int a, int b, int* st)
{
    if(b <= l || r <= a) return -1;
    if(a <= l && r <= b) return st[v];

    int m = (l + r) / 2;
    return max(getMax(v * 2, l, m, a, b, st), getMax(v * 2 + 1, m, r, a, b, st));
}

int getMin(int v, int l, int r, int a, int b, int* st)
{
    if(b <= l || r <= a) return INF;
    if(a <= l && r <= b) return st[v];

    int m = (l + r) / 2;
    return min(getMin(v * 2, l, m, a, b, st), getMin(v * 2 + 1, m, r, a, b, st));
}

void set_stMax(int v, int l, int r, int i, int x, int* st)
{
    if(l == r - 1)
    {
        st[v] = max(st[v], x);
        return;
    }

    int m = (l + r) / 2;

    if(i < m) set_stMax(v * 2, l, m, i, x, st);
    else set_stMax(v * 2 + 1, m, r, i, x, st);

    st[v] = max(st[v * 2], st[v * 2 + 1]);
}

void set_stMin(int v, int l, int r, int i, int x, int* st)
{
    if(l == r - 1)
    {
        st[v] = min(st[v], x);
        return;
    }

    int m = (l + r) / 2;

    if(i < m) set_stMin(v * 2, l, m, i, x, st);
    else set_stMin(v * 2 + 1, m, r, i, x, st);

    st[v] = min(st[v * 2], st[v * 2 + 1]);
}

vector<int> coords;

int ans[maxN];

int main()
{
    #ifdef DEBUG
        freopen("in.in", "r", stdin);
        //freopen("in.out", "w", stdout);
    #endif // DEBUG

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;

    if(n == 1)
    {
        cout << 0 << endl;
        return 0;
    }

    for(int i = 0; i < n; i++) cin >> arr[i];
    for(int i = 0; i < n - 1; i++)
    {
        cin >> arr2[i].first >> arr2[i].second;
        coords.push_back(arr2[i].first);
        coords.push_back(arr2[i].second);
    }

    dpLeft[0] = 0;
    for(int i = 1; i < n; i++)
    {
        if(arr2[i - 1].first < dpLeft[i - 1]) dpLeft[i] = dpLeft[i - 1];
        else dpLeft[i] = arr2[i - 1].first - arr[i];
    }

    dpRight[n - 1] = 0;
    for(int i = n - 2; i >= 0; i--)
    {
        if(arr2[i].first < dpRight[i + 1]) dpRight[i] = dpRight[i + 1];
        else dpRight[i] = arr2[i].first - arr[i];
    }

    for(int i = 0; i < n; i++)
    {
        ans[i] = max(dpLeft[i], dpRight[i]);
        coords.push_back(ans[i]);
    }

    sort(coords.begin(), coords.end());
    coords.resize(unique(coords.begin(), coords.end()) - coords.begin());

    build(1, 0, coords.size(), -1);

    dpLeft2[0] = 1;
    for(int i = 1; i < n; i++)
    {
        //cout << i << endl;

        int l = lower_bound(coords.begin(), coords.end(), arr2[i - 1].first) - coords.begin();
        int r = lower_bound(coords.begin(), coords.end(), arr2[i - 1].second) - coords.begin();

        int i1 = getMax(1, 0, coords.size(), l, coords.size(), st1);
        int i2 = getMax(1, 0, coords.size(), 0, l, st2);

        //cout << i << " " << i1 << " " << i2 << " " << l << " " << r << endl;

        if(i2 != -1) dpLeft2[i] = 0;
        else
        {
            if(i1 == -1) dpLeft2[i] = 1;
            else dpLeft2[i] = dpLeft2[i1];
        }

        l = lower_bound(coords.begin(), coords.end(), max(ans[i], arr2[i - 1].first)) - coords.begin();
        i1 = getMax(1, 0, coords.size(), l, coords.size(), st1);
        i2 = getMax(1, 0, coords.size(), 0, l, st2);

        if(i2 != -1) ans[i] = -1;
        else
        {
            if(i1 != -1) if(!dpLeft2[i1]) ans[i] = -1;
        }

        set_stMax(1, 0, coords.size(), l, i, st1);
        set_stMax(1, 0, coords.size(), r, i, st2);
    }

    build(1, 0, coords.size(), INF);

    dpRight2[n - 1] = 1;
    for(int i = n - 2; i >= 0; i--)
    {
        int l = lower_bound(coords.begin(), coords.end(), arr2[i].first) - coords.begin();
        int r = lower_bound(coords.begin(), coords.end(), arr2[i].second) - coords.begin();

        int i1 = getMin(1, 0, coords.size(), l, coords.size(), st1);
        int i2 = getMin(1, 0, coords.size(), 0, l, st2);

        //cout << i << " " << l << " " << r << " " << i2 << endl;

        if(i2 != INF) dpRight2[i] = 0;
        else
        {
            if(i1 == INF) dpRight2[i] = 1;
            else dpRight2[i] = dpRight2[i1];
        }

        l = lower_bound(coords.begin(), coords.end(), max(ans[i], arr2[i].first)) - coords.begin();
        i1 = getMin(1, 0, coords.size(), l, coords.size(), st1);
        i2 = getMin(1, 0, coords.size(), 0, l, st2);

        //cout << l << " " << i1 << " " << i2 << endl;

        if(i2 != INF) ans[i] = -1;
        else
        {
            if(i1 != INF) if(!dpRight2[i1]) ans[i] = -1;
        }

        set_stMin(1, 0, coords.size(), l, i, st1);
        set_stMin(1, 0, coords.size(), r, i, st2);
    }

    for(int i = 0; i < n; i++)
    {
        cout << ans[i] << " ";
    }





    return 0;
}
