import javax.swing.text.Segment;
import java.awt.*;
import java.awt.geom.Line2D;
import java.util.*;
import java.util.List;

public class Main {

    public static void main(String[] args) throws Exception {
        Scanner scanner = new Scanner(System.in);
        int n = scanner.nextInt();
        int[] xs = new int[300];
        int[] ys = new int[300];

        for (int i = 0; i < n; i++) {
            xs[i] = scanner.nextInt();
            ys[i] = scanner.nextInt();
        }
        ArrayList<Polygon> polygons = new ArrayList<>();
        ArrayList<int[]> polygonIds = new ArrayList<>();
        double eps = 0;
        for (int i1 = 0; i1 < n; i1++)
            for (int i2 = i1 + 1; i2 < n; i2++)
                for (int i3 = i2 + 1; i3 < n; i3++) {

                    Polygon polygon = new Polygon(new int[]{xs[i1], xs[i2], xs[i3]}, new int[]{ys[i1], ys[i2], ys[i3]}, 3);
                    boolean bad = false;
                    for (int i = 0; i < n; i++) {
                        if (polygon.contains(xs[i], ys[i]) && Line2D.ptSegDist(xs[i1], ys[i1], xs[i2], ys[i2], xs[i], ys[i]) != eps
                                && Line2D.ptSegDist(xs[i2], ys[i2], xs[i3], ys[i3], xs[i], ys[i]) != eps
                                && Line2D.ptSegDist(xs[i1], ys[i1], xs[i3], ys[i3], xs[i], ys[i]) != eps) {
                            bad = true;
                            break;
                        }
                    }
                    if (!bad) {
                        polygons.add(polygon);
                        polygonIds.add(new int[]{i1 + 1, i2 + 1, i3 + 1});
                    }

                }


        Collections.shuffle(polygonIds,new Random(n));


        int q=scanner.nextInt();
        for (int i = 0; i < q; i++) {
            for (int j = 0; j < polygonIds.size(); j++) {
                System.out.printf("? 3 %d %d %d\n",polygonIds.get(j)[0],polygonIds.get(j)[1],polygonIds.get(j)[2]);
                System.out.flush();
                if (scanner.next().contains("Yes")){
                    System.out.printf("! 3 %d %d %d\n",polygonIds.get(j)[0],polygonIds.get(j)[1],polygonIds.get(j)[2]);
                    break;
                }
            }
        }
    }
}
